Logger = {
    /**
     * @cfg _writeLogs
     * preset with the false
     * this config value has a setter and should be treated as private
     * @private
     */
    _writeLogs: false,

    _bufferLogs: false,

    _logCache: [],

    /**
     * @method log, dir, warn, error
     * same as console.log, console.dir, console.warn, console.error
     * @public
     */
    log: function (payload) {
        this.exec(payload, 'log');
    },
    dir: function (payload) {
        this.exec(payload, 'dir');
    },
    warn: function (payload) {
        this.exec(payload, 'warn');
    },
    error: function (payload) {
        this.exec(payload, 'error');
    },
    todo: function( payload){
        console.log( '%c %s %s %s ', 'color: yellow; background-color: black;', '--', payload, '--');
    },
    important: function( payload){
        console.log( '%c%s %s %s', 'color: brown; font-weight: bold; text-decoration: underline;', '--', payload, '--');
    },
    threeD: function (payload) {
        console.log('%c%s', 'font-size:100px;color:#fff;text-shadow:0 1px 0 #ccc,0 2px 0 #c9c9c9,0 3px 0 #bbb,0 4px 0 #b9b9b9,0 5px 0 #aaa,0 6px 1px rgba(0,0,0,.1),0 0 5px rgba(0,0,0,.1),0 1px 3px rgba(0,0,0,.3),0 3px 5px rgba(0,0,0,.2),0 5px 10px rgba(0,0,0,.25),0 10px 10px rgba(0,0,0,.2),0 20px 20px rgba(0,0,0,.15);', payload);
    },

    /**
     * @method exec
     * @param {string|object} payload
     * @param {string} severity
     *
     * @private
     */
    exec: function (payload, severity) {
        if (this.getWriteLogs()) {
            if (this._bufferLogs) {
                this._logCache.push({severity: severity, payload: payload});
            } else {
                console[severity](payload);
            }
        }
    },

    writeBufferedLogs: function() {
        var temp = this._logCache;
        this._logCache = [];
        temp.forEach(function(item) {
            console[item.severity](item.payload);
        });
    },

    setBufferLogs: function(value) {
        this._bufferLogs = value;
    },

    /**
     * @method setWriteLogs
     * @param {boolean} [allowWriteLogs=false]
     *
     * @public
     */
    setWriteLogs: function (allowWriteLogs) {
        this._writeLogs = allowWriteLogs;
    },
    getWriteLogs: function () {
        return this._writeLogs;
    }
};