Testing = {
    /**
     * logs the current events
     *
     *    Testin.getEvents(App);
     *    -->
     *         object: {
     *             _events:         List of current event listeners
     *             _listeningTo:    List of current events with scoped event listeners
     *         }
     *
     * @param el
     */
    getHTMLEvents: function () {

        function isEmpty(map) {
            var key;

            for (key in map) {
                return false;
            }
            return true;
        }

        var allNodes = document.getElementsByTagName('*'),
            allEvents = {}, allCount = 0,
            nodeNo, listener, event;

        listenerCollection = getEventListeners(document);

        for (nodeNo in allNodes) {
            var node = allNodes[nodeNo];
            var listenerCollection = null;
            listenerCollection = getEventListeners(node);
            if (!isEmpty(listenerCollection)) {
                for (listener in listenerCollection) {
                    listenerCollection[listener][0].node = allNodes[nodeNo];
                    if (listener in allEvents) {
                        allEvents[listener] = allEvents[listener].concat(listenerCollection[listener]);
                    } else {
                        allEvents[listener] = listenerCollection[listener];
                    }
                }
            }
        }


        for (event in allEvents) {
            allCount += allEvents[event].length;
        }

        console.group('DOM Events');
        console.dir(allEvents);
        console.log('number of all Events: ' + allCount);
        console.groupEnd();
    },

    /**
     * Other way to get listeners ----------------------------------------------------------
     */
    getEvents: function (app, addIds) {
        app = app || require('App');

        var startTimer = new Date().getTime();
        var settings = {noBeforeIgnoreNextTime: 100, maxLoopNo: 7};
        var returnItem = {_events: {}, _listeningTo: {}, events: {}}, doneMaxLoopNo = 0,
            controlElement = {}, positiveElement = {}, positiveObj = {}, dumpElement = {}, notDumpElement = {}, forgetMe = {},
            forbiddenElement = {
                app:0,applicants:0,
                cache:0,callingRegion:0,category:0,changed:0,classList:0,config:0,contacts:0,context:0,
                dataset:0,debug:0,defaults:0,dependencies:0,dialogs:0,dynConfiguration:0,
                $el:0,el:0,error:0,fastclick:0,getLogger:0,hammer:0,headers:0,
                label:0,localStorage:0,localStorageSaver:0,log:0,logger:0,
                namespaceURI:0,nodeValue:0,ownerDocument:0,parameters:0,prefix:0,print: 0,
                server:0,sessions:0,submodules:0,style:0,ua:0,uri:0,validationError:0,warn:0,

                Crypto: 0,GSMDetection:0,LocalStorage:0,PermissionModule:0,

                _action:0,_behaviors:0,_byId:0,_callbacks:0,_defaults:0,_deferred:0,_finalizerCallbacks:0,
                _initializerCallbacks:0,_parent:0,_parentApp:0,_regionManager:0,_type:0,_uiBindings: 0,

                childNodes:1,children:1,firstChild:1,firstElementChild: 1,lastChild: 1,lastElementChild: 1,
                nextElementSibling: 1,nextSibling: 1,offsetParent:1,parentElement:1,parentNode:1,prevObject:1,
                previousElementSibling: 1,previousSibling: 1,
                _contacts:0, contacts:0,contact:0,_contact:0
            };

        if(addIds){
            delete forbiddenElement['_byId'];
        }

        var loop = function (group, loopNo, previousElement) {
            loopNo = loopNo || 0;
            previousElement = previousElement || '';
            var item;

            if (loopNo > doneMaxLoopNo) {
                doneMaxLoopNo = loopNo;
            }
            loopNo += 1;

            for (item in group) {
                if (group.hasOwnProperty(item)) {
                    if (!(item in forbiddenElement)
                        && item !== undefined && item !== null
                        && item.substr(0, 6) !== 'webkit') {

                        var isListener = false;
                        if (item in returnItem) {
                            // is listener
                            _.extend(returnItem[item], group[item]);
                            var thisElement = previousElement + '.' + item;
                            positiveElement[thisElement] = (thisElement in positiveElement) ? (positiveElement[thisElement] + 1) : 1;
                        } else {
                            // is not listener
                            if (typeof group[item] !== "object") {
                                // this is not an object and not used. So calc this to find out if you need it next time
                                notDumpElement[item] = (item in notDumpElement) ? (notDumpElement[item] + 1) : 1;
                            } else {
                                // this is an object, so loop this object
                                controlElement[item] = (item in controlElement) ? (controlElement[item] + 1) : 1;

                                if (loopNo < (settings.maxLoopNo + 1)){
                                    loop(group[item], loopNo, previousElement + '.' + item);
                                }
                            }
                        }
                    } else {
                        // was not used at all
                        dumpElement[item] = (item in dumpElement) ? (dumpElement[item] + 1) : 1;
                    }
                }
            }
        };
        var countEvents = function (events) {
            var returnValue = 0;
            for (var item in events) {
                returnValue += events[item].length;
            }
            return returnValue;
        };
        var countListeners = function (listeners) {
            var returnValue = 0;
            for (var item in listeners) {
                returnValue += countEvents(listeners[item]._events);
            }
            return returnValue;
        };
        var itemsToIgnoreNextTime = function () {
            for (item in notDumpElement)
                if (notDumpElement[item] > settings.noBeforeIgnoreNextTime) forgetMe[item] = notDumpElement[item];
            return forgetMe;
        };

        var sortPositiveElements = function () {
            makeObjFromString = function (itemArray, no){
                var ln = itemArray.length;
                var returnObj = {};
                returnObj[itemArray[ln-1]] = no;
                for(var i = (ln-2); i >=1; i--){
                    var tempObj = returnObj;
                    returnObj = {};
                    returnObj[itemArray[i]] = tempObj;
                }
                return returnObj;
            };
            mergeProperties = function (propertyKey, firstObject, secondObject) {
                var propertyValue = firstObject[propertyKey];

                if (typeof(propertyValue) === "object") {
                    return mergeNestedObjects(firstObject[propertyKey], secondObject ? secondObject[propertyKey] : {});
                } else if (secondObject === undefined || secondObject[propertyKey] === undefined) {
                    return firstObject[propertyKey];
                }

                return secondObject[propertyKey];
            };
            mergeNestedObjects = function (firstObject, secondObject) {
                var finalObject = {};

                // Merge first object and its properties.
                for (var propertyKey in firstObject) {
                    finalObject[propertyKey] = mergeProperties(propertyKey, firstObject, secondObject);
                }

                // Merge second object and its properties.
                for (var propertyKey in secondObject) {
                    finalObject[propertyKey] = mergeProperties(propertyKey, secondObject, firstObject);
                }

                return finalObject;
            };

            var item;
            for(item in positiveElement) {
                var itemArray = item.split('.');
                var itemObj = makeObjFromString(itemArray, positiveElement[item]);
                positiveObj = mergeNestedObjects(positiveObj, itemObj);
            }
            return positiveObj;
        };

        loop(app);


        console.group('Events');
            console.log('----EVENTS');
            console.dir(returnItem);

            console.log('----NUMBERS');
            console.log('Events: ' + countEvents(returnItem._events));
            console.log('Listeners haben ' + countListeners(returnItem._listeningTo) + ' Events');

            console.log('----DUMP_ELEMENTS');
            console.dir(dumpElement);

            console.log('----NOT_DUMP_ELEMENTS');
            console.dir(notDumpElement);
            console.log('DoneMaxLoopNo: ' + doneMaxLoopNo);

            console.log('----SHOULD FORGET_ELEMENTS');
            console.dir(itemsToIgnoreNextTime());

            console.log('----POSITIVE_ELEMENTS');
            console.dir(positiveElement);
            console.dir(sortPositiveElements());

            console.log('----OVERALL_TIME');
            console.log((new Date().getTime() - startTimer));
        console.groupEnd();
    }
};

Testing.History = {
    /**
     * @param {number} [amount=100] number of items to add
     */
    addMulti: function (amount) {
        amount = amount || 100;
        var collection = require('App').getHistoryCollection(),
            collectionLn = collection.length,
            model1;

        if (collectionLn === 0)
            this.addSingle();

        model1 = collection.first();

        for (var i = 1; i <= amount; i++) {
            collection.add(model1.clone())
        }

        collection.storeHistory();
    },

    /**
     * @param {number} [amount=(collection.length-1)] number of items to remove
     */
    removeMulti: function (amount) {
        var app = require('App'),
            collection = app.getHistoryCollection(),
            collectionLn = collection.length;
        if (!amount || amount >= collectionLn)
            amount = (collectionLn - 1);

        for (var i = 1; i <= amount; i++) {
            collection.pop();
        }

        collection.storeHistory();
    },

    /**
     *
     * @param {string} [number='017684084004'] telephone number
     * @param {'OUTGOING'|'INCOMING'|'MISSED'} [type='OUTGOING']
     * @param {number} [date=new Date().getTime()]
     */
    addSingle: function (number, type, date) {
        number = number || '017684084004';

        date = date || new Date().getTime();
        date = date / 1000;

        var callStats = {
            number: number,
            startTime: date,
            type: type,
            status: null
        };

        switch (callStats.type) {
            case 'INCOMING':
                callStats.status = 'CALL-IS-ENDED-BY-THE-CALLEE';
                break;
            case 'MISSED':
                callStats.type = 'INCOMING';
                callStats.status = 'MISSED';
                break;
            default:
                callStats.type = 'OUTGOING';
                callStats.status = 'CALL-IS-ENDED-BY-THE-CALLEE';
        }

        require('App').getHistoryCollection().addCall(callStats)
    },

    addMonth: function () {
        var historyLn = 30,
            dayLn = 86400000, //60*60*24*1000,
            date = new Date().getTime() - (historyLn * dayLn);

        for(var i = 0; i < historyLn; i++){
            var curDate = date + (dayLn * i);
            this.addSingle(null, null, curDate);
        }
    }
};