cordova.define("de.isaco.webrtc.MediaStreamTrack", function(require, exports, module) {
var exec = require('cordova/exec'),
    utils = require('cordova/utils'),
    cordova = require('cordova'),
    log = require('./WebRTCLog');

var MediaStreamTrack = function (id, kind, state, enabled, streamId) {
    // event handlers defined in http://www.w3.org/TR/mediacapture-streams/
    this.onmute = null;
    this.onunmute = null;
    this.onstarted = null;
    this.onended = null;
    // attributes defined in http://www.w3.org/TR/mediacapture-streams/
    this._enabled = enabled;
    this.id = id;
    this.kind = kind;
    this.muted = false;
    this.readonly = false;
    this.readyState = state;
    this.remote = true;
    // private attributes
    this.__streamId = streamId;
};

MediaStreamTrack.prototype = {
    get enabled(){
        // TODO: retrieve actual value?
        return this._enabled;
    },
    set enabled(val){
        cordova.exec(null, log.error, "WebRTC", "setMSTEnabled", [this.__streamId, this.id, val]);
        this._enabled = val;
    }
};

MediaStreamTrack.prototype.clone = function() {
    log.debug("clone() not implemented yet");
};

MediaStreamTrack.prototype.stop = function() {
    log.debug("stop() not implemented yet");
};

module.exports = MediaStreamTrack;

});
