cordova.define("de.isaco.webrtc.IPlayback", function(require, exports, module) {
var exec = require('cordova/exec'),
    utils = require('cordova/utils'),
    cordova = require('cordova'),
    log = require('./WebRTCLog');

var IPlayback = function() {
};

/*
 * Start playing a WAV file locally.
 *   successCallback: function();
 *   failureCallback: function(error);
 *   fileName: string; local file relative to the app's bundle, e.g. "www/res/raw/test.wav"
 *   loop: bool; whether file should be played in a loop
 */
IPlayback.prototype.play = function(successCallback, failureCallback, fileName, loop) {
    cordova.exec(successCallback, failureCallback, "WebRTC", "play", [fileName, loop]);
};

/*
 * Determine whether a file is currently played locally.
 *   successCallback: function(result);
 *   failureCallback: function(error);
 */
IPlayback.prototype.isPlaying = function(successCallback, failureCallback) {
    cordova.exec(successCallback, failureCallback, "WebRTC", "isPlaying", []);
};

/*
 * Stop playing a file locally.
 *   successCallback: function();
 *   failureCallback: function(error);
 */
IPlayback.prototype.stop = function(successCallback, failureCallback) {
    cordova.exec(successCallback, failureCallback, "WebRTC", "stop", []);
};

module.exports = IPlayback;

});
