cordova.define("de.telekom.hometalk.apphelper.AppState", function(require, exports, module) {
var exec = require('cordova/exec'),
    Plugin = function () {
    };

Plugin.prototype.toForeground = function (successFn, errorFn) {
    var errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::toForeground] can not push app to foreground');
        Logger.dir(msg);
    };
    var successFn = successFn || function () {
            Logger.log('[appHelper::toForeground] pushed app to foreground succeed');
        };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'toForeground', []);
};

Plugin.prototype.toBackground = function (successFn, errorFn) {
    var errorFn = errorFn || function () {
        Logger.error('[appHelper::toBackground] can not push app to Background');
        Logger.dir(msg);
    };
    var successFn = successFn || function () {
            Logger.log('[appHelper::toBackground] pushed app to Background succeed');
        };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'toBackground', []);
};

Plugin.prototype.getStates = function (successFn, errorFn) {
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::getStates] can not get app states');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'getStates', []);
};

Plugin.prototype.isScreenOn = function (successFn, errorFn) {
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::getStates] can not get if screen on');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'isScreenOn', []);
};

Plugin.prototype.setScreenOn = function (successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::setScreenOn] set screen on succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::setScreenOn] can not set screen on');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'setScreenOn', []);
};               
Plugin.prototype.clearActivityFlags = function (successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::clearActivityFlags] succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::clearActivityFlags] error');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'clearActivityFlags', []);
};
Plugin.prototype.isDeviceLocked = function (successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::isDeviceLocked] isDeviceLocked succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::isDeviceLocked] can not check if isDeviceLocked');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'isDeviceLocked', []);
};

Plugin.prototype.reenableScreenlock = function (successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::reenableScreenlock] reenable screenlock succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::reenableScreenlock] can not reenable screenlock');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'reenableScreenlock', []);
};

Plugin.prototype.encrypt = function (msg, successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::encrypt] encrypt succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::encrypt] can not encrypt');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'encrypt', [msg]);
};

Plugin.prototype.decrypt = function (msg, successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::decrypt] decrypt succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::decrypt] can not decrypt');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'decrypt', [msg]);
};
Plugin.prototype.saveToSharedPrefs = function (msg, successFn, errorFn) {
    successFn = successFn || function () {
        Logger.log('[appHelper::saveToSharedPrefs] save succeed');
    };
    errorFn = errorFn || function (msg) {
        Logger.error('[appHelper::saveToSharedPrefs] can not save');
        Logger.dir(msg);
    };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'saveToSharedPrefs', [msg]);
};
Plugin.prototype.removeToSharedPrefs = function (msg, successFn, errorFn) {
    successFn = successFn || function () {
            Logger.log('[appHelper::saveToSharedPrefs] remove succeed');
        };
    errorFn = errorFn || function (msg) {
            Logger.error('[appHelper::saveToSharedPrefs] can not remove');
            Logger.dir(msg);
        };
    return exec(successFn, errorFn, 'AppHelperPlugin', 'removeToSharedPrefs', [msg]);
};

module.exports = new Plugin();
});
