# Fixtures

This is a short definition of the supported fixture structure.

## Document structure

```
    {
        [calls: array of objects]
    }
```

## Calls

Calls can be specified within the optional `calls` property. This property is of type array. Each item in this array
represents a single call entry of the history. History items will appear in the same order as in the array (first item
is the topmost entry in the history).

An item has the following structure
```
    {
      number: string,            # an e164 number
      time: string,              # a timestamp in ISO 8601 format (yyyy-MM-ddTHH:mm:ss)
      durationInSeconds: number,
      direction: string,         # possible values "in", "out"
      status: string,            # possible values "missed", "ended"
      unread: boolean
    }
```
