define([
        'underscore'
    ],
    function(_) {

        return {

            updatesToVersion: function() {
                return '2.1.2'; // NEVER change this version
            },

            /**
             *
             * @param moduleContainer to grant access to modules. Modules should try to only use the local storage and keychain modules.
             * @param callback will be invoked after executing this step. First parameter (boolean) indicates whether or not there was a problem during the execution.
             */
            execute: function(moduleContainer, callback) {
                var history = moduleContainer.LocalStorageModule.get('history');
                var newAnounymousNumberStrings = 'anonymous';
                var currentAnounymousNumberStrings = ['Anonym', 'Anonymous'];
                if (_.isArray(history)) {
                    history.forEach(function(entry) {
                        if(_.contains(currentAnounymousNumberStrings, entry.number)) {
                            entry.number = newAnounymousNumberStrings;
                        }
                    });

                    moduleContainer.LocalStorageModule.store('history', history);
                }

                callback(true);
            }
        };

    });