define([
        'underscore'
    ],
    function(_) {

        return {

            updatesToVersion: function() {
                return '2.1.3'; // NEVER change this version
            },

            /**
             *
             * @param moduleContainer to grant access to modules. Modules should try to only use the local storage and keychain modules.
             * @param callback will be invoked after executing this step. First parameter (boolean) indicates whether or not there was a problem during the execution.
             */
            execute: function(moduleContainer, callback) {
                //remove password from storage/keychain, because SSO is used in each app case, no pass needed anymore
                moduleContainer.KeyChainModule.remove('pass', function () {
                    Logger.log('[Migration_to_2.1.3::execute] successfully remove password from storage');
                }, function () {
                    Logger.warn('[Migration_to_2.1.3::execute] failed to remove password from storage');
                });

                callback(true);
            }
        };

    });