define([
        'underscore'
    ],
    function(_) {

        return {

            updatesToVersion: function() {
                return '2.1.7.1'; // NEVER change this version
            },

            /**
             *
             * @param moduleContainer to grant access to modules. Modules should try to only use the local storage and keychain modules.
             * @param callback will be invoked after executing this step. First parameter (boolean) indicates whether or not there was a problem during the execution.
             */
            execute: function(moduleContainer, callback) {
                //{"data":{"secure":true,"persistent":false,"value":{"homeNotification":true,"disturbSetting":true,"sipInstanceId":"89d0da8b-a160-4f54-8333-0b799b9b79fe"}},"expires":null}

                // remove disturb setting from shared preferences on android
                var sharedPreferences = navigator.AppState;
                if(sharedPreferences) {
                    sharedPreferences.removeToSharedPrefs('DND');
                }

                // get app model data
                var appModelData = moduleContainer.LocalStorageModule.get('app-model-data');

                // remove disturb setting in app model storage key
                appModelData = _.omit(appModelData, 'disturbSetting');
                moduleContainer.LocalStorageModule.store('app-model-data', appModelData);

                callback(true);
            }
        };

    });