define([
        'underscore'
    ],
    function(_) {

        return {

            updatesToVersion: function() {
                return '2.1.7'; // NEVER change this version
            },

            /**
             *
             * @param moduleContainer to grant access to modules. Modules should try to only use the local storage and keychain modules.
             * @param callback will be invoked after executing this step. First parameter (boolean) indicates whether or not there was a problem during the execution.
             */
            execute: function(moduleContainer, callback) {
                // get app model data
                var appModelData = moduleContainer.LocalStorageModule.get('app-model-data');

                // set is tracking allowed value to new storage key for data privacy
                var isTrackingAllowed = appModelData.trackingAllowed;
                moduleContainer.LocalStorageModule.store('privacy', {trackingAllowed: isTrackingAllowed});

                // remove tracking allowed value in app model storage key
                appModelData = _.omit(appModelData, 'trackingAllowed');
                moduleContainer.LocalStorageModule.store('app-model-data', appModelData);

                callback(true);
            }
        };

    });