define([
        'underscore'
    ],
    function (_) {

        return {

            updatesToVersion: function () {
                return '2.3.0'; // NEVER change this version
            },

            /**
             *
             * @param moduleContainer to grant access to modules. Modules should try to only use the local storage and keychain modules.
             * @param callback will be invoked after executing this step. First parameter (boolean) indicates whether or not there was a problem during the execution.
             */
            execute: function (moduleContainer, callback) {
                this._getUsernameFromKeyChain(moduleContainer.KeyChainModule, _.bind(this._saveUserObject, this, moduleContainer.KeyChainModule, callback), function () {
                    Logger.warn('[Migration_to_2.3.0::execute] failed to get username to migrate');

                    callback(false);
                });
            },

            _getUsernameFromKeyChain: function (keychain, success, failure) {
                keychain.get('username', success, failure);
            },

            _saveUserObject: function (keychain, callback, username) {
                var storeCallback = function () {
                    callback(true);
                };
                try {
                    var data = {};
                    if(username) {
                        data._username = username;
                        data._isLoggedIn = true;
                    }else {
                        data._username = '';
                        data._isLoggedIn = false;
                    }
                    keychain.store('username', JSON.stringify(data), storeCallback, storeCallback);

                } catch (e) {
                    Logger.warn('[Migration_to_2.3.0::execute] failed to store migrated username');
                    callback(false);
                }
            }
        };

    });