/*
 * JsSIP v2.0.6
 * the Javascript SIP library
 * Copyright: 2012-2018 José Luis Millán <jmillan@aliax.net> (https://github.com/jmillan)
 * Homepage: http://jssip.net
 * License: MIT
 */

!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{var t;t="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,t.JsSIP=e()}}(function(){var e;return function(){function e(t,n,r){function s(l,o){if(!n[l]){if(!t[l]){var u="function"==typeof require&&require;if(!o&&u)return u(l,!0);if(i)return i(l,!0);var a=new Error("Cannot find module '"+l+"'");throw a.code="MODULE_NOT_FOUND",a}var c=n[l]={exports:{}};t[l][0].call(c.exports,function(e){return s(t[l][1][e]||e)},c,c.exports,e,t,n,r)}return n[l].exports}for(var i="function"==typeof require&&require,l=0;l<r.length;l++)s(r[l]);return s}return e}()({1:[function(e,t,n){var r=e("../package.json"),s={USER_AGENT:r.title+" "+r.version,SIP:"sip",SIPS:"sips",causes:{CONNECTION_ERROR:"Connection Error",REQUEST_TIMEOUT:"Request Timeout",SIP_FAILURE_CODE:"SIP Failure Code",INTERNAL_ERROR:"Internal Error",BUSY:"Busy",REJECTED:"Rejected",REDIRECTED:"Redirected",UNAVAILABLE:"Unavailable",NOT_FOUND:"Not Found",ADDRESS_INCOMPLETE:"Address Incomplete",INCOMPATIBLE_SDP:"Incompatible SDP",MISSING_SDP:"Missing SDP",AUTHENTICATION_ERROR:"Authentication Error",BYE:"Terminated",WEBRTC_ERROR:"WebRTC Error",CANCELED:"Canceled",NO_ANSWER:"No Answer",EXPIRES:"Expires",NO_ACK:"No ACK",DIALOG_ERROR:"Dialog Error",USER_DENIED_MEDIA_ACCESS:"User Denied Media Access",BAD_MEDIA_DESCRIPTION:"Bad Media Description",RTP_TIMEOUT:"RTP Timeout"},SIP_ERROR_CAUSES:{REDIRECTED:[300,301,302,305,380],BUSY:[486,600],REJECTED:[403,603],NOT_FOUND:[404,604],UNAVAILABLE:[480,410,408,430],ADDRESS_INCOMPLETE:[484,424],INCOMPATIBLE_SDP:[488,606],AUTHENTICATION_ERROR:[401,407]},ACK:"ACK",PRACK:"PRACK",BYE:"BYE",CANCEL:"CANCEL",INFO:"INFO",INVITE:"INVITE",MESSAGE:"MESSAGE",NOTIFY:"NOTIFY",OPTIONS:"OPTIONS",REGISTER:"REGISTER",REFER:"REFER",UPDATE:"UPDATE",SUBSCRIBE:"SUBSCRIBE",REASON_PHRASE:{100:"Trying",180:"Ringing",181:"Call Is Being Forwarded",182:"Queued",183:"Session Progress",199:"Early Dialog Terminated",200:"OK",202:"Accepted",204:"No Notification",300:"Multiple Choices",301:"Moved Permanently",302:"Moved Temporarily",305:"Use Proxy",380:"Alternative Service",400:"Bad Request",401:"Unauthorized",402:"Payment Required",403:"Forbidden",404:"Not Found",405:"Method Not Allowed",406:"Not Acceptable",407:"Proxy Authentication Required",408:"Request Timeout",410:"Gone",412:"Conditional Request Failed",413:"Request Entity Too Large",414:"Request-URI Too Long",415:"Unsupported Media Type",416:"Unsupported URI Scheme",417:"Unknown Resource-Priority",420:"Bad Extension",421:"Extension Required",422:"Session Interval Too Small",423:"Interval Too Brief",424:"Bad Location Information",428:"Use Identity Header",429:"Provide Referrer Identity",430:"Flow Failed",433:"Anonymity Disallowed",436:"Bad Identity-Info",437:"Unsupported Certificate",438:"Invalid Identity Header",439:"First Hop Lacks Outbound Support",440:"Max-Breadth Exceeded",469:"Bad Info Package",470:"Consent Needed",478:"Unresolvable Destination",480:"Temporarily Unavailable",481:"Call/Transaction Does Not Exist",482:"Loop Detected",483:"Too Many Hops",484:"Address Incomplete",485:"Ambiguous",486:"Busy Here",487:"Request Terminated",488:"Not Acceptable Here",489:"Bad Event",491:"Request Pending",493:"Undecipherable",494:"Security Agreement Required",500:"JsSIP Internal Error",501:"Not Implemented",502:"Bad Gateway",503:"Service Unavailable",504:"Server Time-out",505:"Version Not Supported",513:"Message Too Large",580:"Precondition Failure",600:"Busy Everywhere",603:"Decline",604:"Does Not Exist Anywhere",606:"Not Acceptable"},ALLOWED_METHODS:"INVITE,ACK,CANCEL,BYE,UPDATE,MESSAGE,OPTIONS,REFER,INFO",ACCEPTED_BODY_TYPES:"application/sdp, application/dtmf-relay",MAX_FORWARDS:69,SESSION_EXPIRES:90,MIN_SESSION_EXPIRES:60};t.exports=s},{"../package.json":47}],2:[function(e,t,n){function r(e,t,n,r){var o;if(this.uac_pending_reply=!1,this.uas_pending_reply=!1,!t.hasHeader("contact"))return{error:"unable to create a Dialog without Contact header field"};r=t instanceof l.IncomingResponse?t.status_code<200?s.STATUS_EARLY:s.STATUS_CONFIRMED:r||s.STATUS_CONFIRMED,o=t.parseHeader("contact"),"UAS"===n?(this.id={call_id:t.call_id,local_tag:t.to_tag,remote_tag:t.from_tag,toString:function(){return this.call_id+this.local_tag+this.remote_tag}},this.state=r,this.remote_seqnum=t.cseq,this.local_uri=t.parseHeader("to").uri,this.remote_uri=t.parseHeader("from").uri,this.remote_target=o.uri,this.route_set=t.getHeaders("record-route"),e.ua.registerServerTransaction(t.to_tag,t.cseq,t.method,t.server_transaction)):"UAC"===n&&(this.id={call_id:t.call_id,local_tag:t.from_tag,remote_tag:t.to_tag,toString:function(){return this.call_id+this.local_tag+this.remote_tag}},this.state=r,this.local_seqnum=this.local_invite_seqnum=t.cseq,this.local_uri=t.parseHeader("from").uri,this.remote_uri=t.parseHeader("to").uri,this.remote_target=o.uri,this.route_set=t.getHeaders("record-route").reverse()),this.owner=e,e.ua.dialogs[this.id.toString()]=this,i("new "+n+" dialog created with status "+(this.state===s.STATUS_EARLY?"EARLY":"CONFIRMED"))}t.exports=r;var s={STATUS_EARLY:1,STATUS_CONFIRMED:2};r.C=s;var i=e("debug")("JsSIP:Dialog"),l=e("./SIPMessage"),o=e("./Constants"),u=e("./Transactions"),a=e("./Dialog/RequestSender");r.prototype={update:function(e,t){this.state=s.STATUS_CONFIRMED,i("dialog "+this.id.toString()+"  changed to CONFIRMED state"),"UAC"===t&&(this.route_set=e.getHeaders("record-route").reverse())},terminate:function(){i("dialog "+this.id.toString()+" deleted"),delete this.owner.ua.dialogs[this.id.toString()]},createRequest:function(e,t,n){var r,s;return t=t&&t.slice()||[],this.local_seqnum||(this.local_seqnum=this.local_invite_seqnum=Math.floor(1e4*Math.random())),r=e===o.CANCEL||e===o.ACK?this.local_invite_seqnum:this.local_seqnum+=1,e===o.INVITE&&(this.local_invite_seqnum=r),s=new l.OutgoingRequest(e,this.remote_target,this.owner.ua,{cseq:r,call_id:this.id.call_id,from_uri:this.local_uri,from_tag:this.id.local_tag,to_uri:this.remote_uri,to_tag:this.id.remote_tag,route_set:this.route_set},t,n),s.dialog=this,s},checkInDialogRequest:function(e){var t=this;if(e.method!==o.ACK&&e.method!==o.CANCEL)if(this.remote_seqnum){if(e.cseq<this.remote_seqnum)return e.reply(500),!1;e.cseq>this.remote_seqnum&&(this.remote_seqnum=e.cseq)}else this.remote_seqnum=e.cseq;else{if(!this.owner.ua.lookupServerTransaction(e.to_tag,e.cseq,"INVITE"))return e.method!==o.ACK&&e.reply(500),!1}if(e.method===o.INVITE&&this.owner.ua.registerServerTransaction(e.to_tag,e.cseq,e.method,e.server_transaction),e.method===o.INVITE||e.method===o.UPDATE&&e.body){if(!0===this.uac_pending_reply)e.reply(491);else{if(!0===this.uas_pending_reply){var n=1+(10*Math.random()|0);return e.reply(500,null,["Retry-After:"+n]),!1}this.uas_pending_reply=!0,e.server_transaction.on("stateChanged",function n(){this.state!==u.C.STATUS_ACCEPTED&&this.state!==u.C.STATUS_COMPLETED&&this.state!==u.C.STATUS_TERMINATED||(e.server_transaction.removeListener("stateChanged",n),t.uas_pending_reply=!1)})}e.hasHeader("contact")&&e.server_transaction.on("stateChanged",function(){this.state===u.C.STATUS_ACCEPTED&&(t.remote_target=e.parseHeader("contact").uri)})}else if(e.method===o.NOTIFY)e.hasHeader("contact")&&e.server_transaction.on("stateChanged",function(){this.state===u.C.STATUS_COMPLETED&&(t.remote_target=e.parseHeader("contact").uri)});else if(e.method===o.PRACK){var r=e.parseHeader("rack"),s=this.owner.ua.lookupServerTransaction(e.to_tag,r.value,r.method);if(!s)return e.reply(481),!1;if(!s.acknowledge100rel(r))return e.reply(481),!1}return!0},sendRequest:function(e,t,n){n=n||{};var r=n.extraHeaders&&n.extraHeaders.slice()||[],s=n.body||null,i=this.createRequest(t,r,s);return new a(this,e,i).send(),i},receiveRequest:function(e){this.checkInDialogRequest(e)&&this.owner.receiveRequest(e)}}},{"./Constants":1,"./Dialog/RequestSender":3,"./SIPMessage":18,"./Transactions":21,debug:29}],3:[function(e,t,n){function r(e,t,n){this.dialog=e,this.applicant=t,this.request=n,this.reattempt=!1,this.reattemptTimer=null}t.exports=r;var s=e("../Constants"),i=e("../Transactions"),l=e("../RTCSession"),o=e("../RequestSender");r.prototype={send:function(){var e=this,t=new o(this,this.dialog.owner.ua);t.send(),(this.request.method===s.INVITE||this.request.method===s.UPDATE&&this.request.body)&&t.clientTransaction.state!==i.C.STATUS_TERMINATED&&(this.dialog.uac_pending_reply=!0,t.clientTransaction.on("stateChanged",function n(){this.state!==i.C.STATUS_ACCEPTED&&this.state!==i.C.STATUS_COMPLETED&&this.state!==i.C.STATUS_TERMINATED||(t.clientTransaction.removeListener("stateChanged",n),e.dialog.uac_pending_reply=!1)}))},onRequestTimeout:function(){this.applicant.onRequestTimeout()},onTransportError:function(){this.applicant.onTransportError()},receiveResponse:function(e){var t=this;408===e.status_code||481===e.status_code?this.applicant.onDialogError(e):e.method===s.INVITE&&491===e.status_code?this.reattempt?this.applicant.receiveResponse(e):(this.request.cseq.value=this.dialog.local_seqnum+=1,this.reattemptTimer=setTimeout(function(){t.applicant.owner.status!==l.C.STATUS_TERMINATED&&(t.reattempt=!0,t.request_sender.send())},1e3)):this.applicant.receiveResponse(e)}}},{"../Constants":1,"../RTCSession":11,"../RequestSender":17,"../Transactions":21}],4:[function(e,t,n){function r(e){this.credentials=e,this.cnonce=null,this.nc=0,this.ncHex="00000000",this.algorithm=null,this.realm=null,this.nonce=null,this.opaque=null,this.stale=null,this.qop=null,this.method=null,this.uri=null,this.ha1=null,this.response=null}t.exports=r;var s=e("debug")("JsSIP:DigestAuthentication"),i=e("debug")("JsSIP:ERROR:DigestAuthentication");i.log=console.warn.bind(console);var l=e("./Utils");r.prototype.get=function(e){switch(e){case"realm":return this.realm;case"ha1":return this.ha1;default:return void i('get() | cannot get "%s" parameter',e)}},r.prototype.authenticate=function(e,t){var n,r;if(this.algorithm=t.algorithm,this.realm=t.realm,this.nonce=t.nonce,this.opaque=t.opaque,this.stale=t.stale,this.algorithm){if("MD5"!==this.algorithm)return i('authenticate() | challenge with Digest algorithm different than "MD5", authentication aborted'),!1}else this.algorithm="MD5";if(!this.nonce)return i("authenticate() | challenge without Digest nonce, authentication aborted"),!1;if(!this.realm)return i("authenticate() | challenge without Digest realm, authentication aborted"),!1;if(!this.credentials.password){if(!this.credentials.ha1)return i("authenticate() | no plain SIP password nor ha1 provided, authentication aborted"),!1;if(this.credentials.realm!==this.realm)return i('authenticate() | no plain SIP password, and stored `realm` does not match the given `realm`, cannot authenticate [stored:"%s", given:"%s"]',this.credentials.realm,this.realm),!1}if(t.qop)if(t.qop.indexOf("auth")>-1)this.qop="auth";else{if(!(t.qop.indexOf("auth-int")>-1))return i('authenticate() | challenge without Digest qop different than "auth" or "auth-int", authentication aborted'),!1;this.qop="auth-int"}else this.qop=null;return this.method=e.method,this.uri=e.ruri,this.cnonce=l.createRandomToken(12),this.nc+=1,r=Number(this.nc).toString(16),this.ncHex="00000000".substr(0,8-r.length)+r,4294967296===this.nc&&(this.nc=1,this.ncHex="00000001"),this.credentials.password?this.ha1=l.calculateMD5(this.credentials.username+":"+this.realm+":"+this.credentials.password):this.ha1=this.credentials.ha1,"auth"===this.qop?(n=l.calculateMD5(this.method+":"+this.uri),this.response=l.calculateMD5(this.ha1+":"+this.nonce+":"+this.ncHex+":"+this.cnonce+":auth:"+n)):"auth-int"===this.qop?(n=l.calculateMD5(this.method+":"+this.uri+":"+l.calculateMD5(this.body?this.body:"")),this.response=l.calculateMD5(this.ha1+":"+this.nonce+":"+this.ncHex+":"+this.cnonce+":auth-int:"+n)):null===this.qop&&(n=l.calculateMD5(this.method+":"+this.uri),this.response=l.calculateMD5(this.ha1+":"+this.nonce+":"+n)),s("authenticate() | response generated"),!0},r.prototype.toString=function(){var e=[];if(!this.response)throw new Error("response field does not exist, cannot generate Authorization header");return e.push("algorithm="+this.algorithm),e.push('username="'+this.credentials.username+'"'),e.push('realm="'+this.realm+'"'),e.push('nonce="'+this.nonce+'"'),e.push('uri="'+this.uri+'"'),e.push('response="'+this.response+'"'),this.opaque&&e.push('opaque="'+this.opaque+'"'),this.qop&&(e.push("qop="+this.qop),e.push('cnonce="'+this.cnonce+'"'),e.push("nc="+this.ncHex)),"Digest "+e.join(", ")}},{"./Utils":25,debug:29}],5:[function(e,t,n){var r={ConfigurationError:function(){var e=function(e,t){this.code=1,this.name="CONFIGURATION_ERROR",this.parameter=e,this.value=t,this.message=this.value?"Invalid value "+JSON.stringify(this.value)+' for parameter "'+this.parameter+'"':"Missing parameter: "+this.parameter};return e.prototype=new Error,e}(),InvalidStateError:function(){var e=function(e){this.code=2,this.name="INVALID_STATE_ERROR",this.status=e,this.message="Invalid status: "+e};return e.prototype=new Error,e}(),NotSupportedError:function(){var e=function(e){this.code=3,this.name="NOT_SUPPORTED_ERROR",this.message=e};return e.prototype=new Error,e}(),NotReadyError:function(){var e=function(e){this.code=4,this.name="NOT_READY_ERROR",this.message=e};return e.prototype=new Error,e}()};t.exports=r},{}],6:[function(e,t,n){t.exports=function(){function t(e){return'"'+e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E-\x1F\x80-\uFFFF]/g,escape)+'"'}var n={parse:function(n,r){function s(e){Sr<Er||(Sr>Er&&(Er=Sr,Ar=[]),Ar.push(e))}function i(){var e;return"\r\n"===n.substr(Sr,2)?(e="\r\n",Sr+=2):(e=null,0===Cr&&s('"\\r\\n"')),e}function l(){var e;return/^[0-9]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[0-9]")),e}function o(){var e;return/^[a-zA-Z]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[a-zA-Z]")),e}function u(){var e;return/^[0-9a-fA-F]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[0-9a-fA-F]")),e}function a(){var e;return e=d(),null===e&&(e=p()),e}function c(){var e;return/^[\0-\xFF]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[\\0-\\xFF]")),e}function h(){var e;return/^["]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s('["]')),e}function d(){var e;return 32===n.charCodeAt(Sr)?(e=" ",Sr++):(e=null,0===Cr&&s('" "')),e}function p(){var e;return 9===n.charCodeAt(Sr)?(e="\t",Sr++):(e=null,0===Cr&&s('"\\t"')),e}function f(){var e;return/^[a-zA-Z0-9]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[a-zA-Z0-9]")),e}function m(){var e;return 59===n.charCodeAt(Sr)?(e=";",Sr++):(e=null,0===Cr&&s('";"')),null===e&&(47===n.charCodeAt(Sr)?(e="/",Sr++):(e=null,0===Cr&&s('"/"')),null===e&&(63===n.charCodeAt(Sr)?(e="?",Sr++):(e=null,0===Cr&&s('"?"')),null===e&&(58===n.charCodeAt(Sr)?(e=":",Sr++):(e=null,0===Cr&&s('":"')),null===e&&(64===n.charCodeAt(Sr)?(e="@",Sr++):(e=null,0===Cr&&s('"@"')),null===e&&(38===n.charCodeAt(Sr)?(e="&",Sr++):(e=null,0===Cr&&s('"&"')),null===e&&(61===n.charCodeAt(Sr)?(e="=",Sr++):(e=null,0===Cr&&s('"="')),null===e&&(43===n.charCodeAt(Sr)?(e="+",Sr++):(e=null,0===Cr&&s('"+"')),null===e&&(36===n.charCodeAt(Sr)?(e="$",Sr++):(e=null,0===Cr&&s('"$"')),null===e&&(44===n.charCodeAt(Sr)?(e=",",Sr++):(e=null,0===Cr&&s('","'))))))))))),e}function g(){var e;return e=f(),null===e&&(e=T()),e}function T(){var e;return 45===n.charCodeAt(Sr)?(e="-",Sr++):(e=null,0===Cr&&s('"-"')),null===e&&(95===n.charCodeAt(Sr)?(e="_",Sr++):(e=null,0===Cr&&s('"_"')),null===e&&(46===n.charCodeAt(Sr)?(e=".",Sr++):(e=null,0===Cr&&s('"."')),null===e&&(33===n.charCodeAt(Sr)?(e="!",Sr++):(e=null,0===Cr&&s('"!"')),null===e&&(126===n.charCodeAt(Sr)?(e="~",Sr++):(e=null,0===Cr&&s('"~"')),null===e&&(42===n.charCodeAt(Sr)?(e="*",Sr++):(e=null,0===Cr&&s('"*"')),null===e&&(39===n.charCodeAt(Sr)?(e="'",Sr++):(e=null,0===Cr&&s('"\'"')),null===e&&(40===n.charCodeAt(Sr)?(e="(",Sr++):(e=null,0===Cr&&s('"("')),null===e&&(41===n.charCodeAt(Sr)?(e=")",Sr++):(e=null,0===Cr&&s('")"')))))))))),e}function v(){var e,t,r,i,l;return i=Sr,l=Sr,37===n.charCodeAt(Sr)?(e="%",Sr++):(e=null,0===Cr&&s('"%"')),null!==e?(t=u(),null!==t?(r=u(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){return t.join("")}(0,e)),null===e&&(Sr=i),e}function _(){var e,t,n,r,s,l;for(r=Sr,s=Sr,l=Sr,e=[],t=a();null!==t;)e.push(t),t=a();if(null!==e?(t=i(),null!==t?e=[e,t]:(e=null,Sr=l)):(e=null,Sr=l),null!==(e=null!==e?e:"")){if(null!==(n=a()))for(t=[];null!==n;)t.push(n),n=a();else t=null;null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return null!==e&&(e=" "),null===e&&(Sr=r),e}function S(){var e;return e=_(),e=null!==e?e:""}function C(){var e,t,r,i,l;for(i=Sr,l=Sr,e=[],t=d(),null===t&&(t=p());null!==t;)e.push(t),null===(t=d())&&(t=p());return null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=":"),null===e&&(Sr=i),e}function E(){var e,t,r,s,i,l,o;if(i=Sr,l=Sr,null!==(t=A()))for(e=[];null!==t;)e.push(t),t=A();else e=null;if(null!==e){for(t=[],o=Sr,r=[],s=_();null!==s;)r.push(s),s=_();for(null!==r?(s=A(),null!==s?r=[r,s]:(r=null,Sr=o)):(r=null,Sr=o);null!==r;){for(t.push(r),o=Sr,r=[],s=_();null!==s;)r.push(s),s=_();null!==r?(s=A(),null!==s?r=[r,s]:(r=null,Sr=o)):(r=null,Sr=o)}null!==t?e=[e,t]:(e=null,Sr=l)}else e=null,Sr=l;return null!==e&&(e=function(e){return n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function A(){var e;return/^[!-~]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[!-~]")),null===e&&(e=y()),e}function y(){var e;return/^[\x80-\uFFFF]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[\\x80-\\uFFFF]")),e}function R(){var e;return/^[\x80-\xBF]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[\\x80-\\xBF]")),e}function b(){var e;return e=l(),null===e&&(/^[a-f]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[a-f]"))),e}function I(){var e,t,r;if(r=Sr,t=f(),null===t&&(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null===t&&(46===n.charCodeAt(Sr)?(t=".",Sr++):(t=null,0===Cr&&s('"."')),null===t&&(33===n.charCodeAt(Sr)?(t="!",Sr++):(t=null,0===Cr&&s('"!"')),null===t&&(37===n.charCodeAt(Sr)?(t="%",Sr++):(t=null,0===Cr&&s('"%"')),null===t&&(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null===t&&(95===n.charCodeAt(Sr)?(t="_",Sr++):(t=null,0===Cr&&s('"_"')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(96===n.charCodeAt(Sr)?(t="`",Sr++):(t=null,0===Cr&&s('"`"')),null===t&&(39===n.charCodeAt(Sr)?(t="'",Sr++):(t=null,0===Cr&&s('"\'"')),null===t&&(126===n.charCodeAt(Sr)?(t="~",Sr++):(t=null,0===Cr&&s('"~"')))))))))))),null!==t)for(e=[];null!==t;)e.push(t),null===(t=f())&&(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null===t&&(46===n.charCodeAt(Sr)?(t=".",Sr++):(t=null,0===Cr&&s('"."')),null===t&&(33===n.charCodeAt(Sr)?(t="!",Sr++):(t=null,0===Cr&&s('"!"')),null===t&&(37===n.charCodeAt(Sr)?(t="%",Sr++):(t=null,0===Cr&&s('"%"')),null===t&&(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null===t&&(95===n.charCodeAt(Sr)?(t="_",Sr++):(t=null,0===Cr&&s('"_"')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(96===n.charCodeAt(Sr)?(t="`",Sr++):(t=null,0===Cr&&s('"`"')),null===t&&(39===n.charCodeAt(Sr)?(t="'",Sr++):(t=null,0===Cr&&s('"\'"')),null===t&&(126===n.charCodeAt(Sr)?(t="~",Sr++):(t=null,0===Cr&&s('"~"'))))))))))));else e=null;return null!==e&&(e=function(e){return n.substring(Sr,e)}(r)),null===e&&(Sr=r),e}function w(){var e,t,r;if(r=Sr,t=f(),null===t&&(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null===t&&(33===n.charCodeAt(Sr)?(t="!",Sr++):(t=null,0===Cr&&s('"!"')),null===t&&(37===n.charCodeAt(Sr)?(t="%",Sr++):(t=null,0===Cr&&s('"%"')),null===t&&(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null===t&&(95===n.charCodeAt(Sr)?(t="_",Sr++):(t=null,0===Cr&&s('"_"')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(96===n.charCodeAt(Sr)?(t="`",Sr++):(t=null,0===Cr&&s('"`"')),null===t&&(39===n.charCodeAt(Sr)?(t="'",Sr++):(t=null,0===Cr&&s('"\'"')),null===t&&(126===n.charCodeAt(Sr)?(t="~",Sr++):(t=null,0===Cr&&s('"~"'))))))))))),null!==t)for(e=[];null!==t;)e.push(t),null===(t=f())&&(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null===t&&(33===n.charCodeAt(Sr)?(t="!",Sr++):(t=null,0===Cr&&s('"!"')),null===t&&(37===n.charCodeAt(Sr)?(t="%",Sr++):(t=null,0===Cr&&s('"%"')),null===t&&(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null===t&&(95===n.charCodeAt(Sr)?(t="_",Sr++):(t=null,0===Cr&&s('"_"')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(96===n.charCodeAt(Sr)?(t="`",Sr++):(t=null,0===Cr&&s('"`"')),null===t&&(39===n.charCodeAt(Sr)?(t="'",Sr++):(t=null,0===Cr&&s('"\'"')),null===t&&(126===n.charCodeAt(Sr)?(t="~",Sr++):(t=null,0===Cr&&s('"~"')))))))))));else e=null;return null!==e&&(e=function(e){return n.substring(Sr,e)}(r)),null===e&&(Sr=r),e}function N(){var e;return 40===n.charCodeAt(Sr)?(e="(",Sr++):(e=null,0===Cr&&s('"("')),null===e&&(41===n.charCodeAt(Sr)?(e=")",Sr++):(e=null,0===Cr&&s('")"')),null===e&&(60===n.charCodeAt(Sr)?(e="<",Sr++):(e=null,0===Cr&&s('"<"')),null===e&&(62===n.charCodeAt(Sr)?(e=">",Sr++):(e=null,0===Cr&&s('">"')),null===e&&(64===n.charCodeAt(Sr)?(e="@",Sr++):(e=null,0===Cr&&s('"@"')),null===e&&(44===n.charCodeAt(Sr)?(e=",",Sr++):(e=null,0===Cr&&s('","')),null===e&&(59===n.charCodeAt(Sr)?(e=";",Sr++):(e=null,0===Cr&&s('";"')),null===e&&(58===n.charCodeAt(Sr)?(e=":",Sr++):(e=null,0===Cr&&s('":"')),null===e&&(92===n.charCodeAt(Sr)?(e="\\",Sr++):(e=null,0===Cr&&s('"\\\\"')),null===e&&null===(e=h())&&(47===n.charCodeAt(Sr)?(e="/",Sr++):(e=null,0===Cr&&s('"/"')),null===e&&(91===n.charCodeAt(Sr)?(e="[",Sr++):(e=null,0===Cr&&s('"["')),null===e&&(93===n.charCodeAt(Sr)?(e="]",Sr++):(e=null,0===Cr&&s('"]"')),null===e&&(63===n.charCodeAt(Sr)?(e="?",Sr++):(e=null,0===Cr&&s('"?"')),null===e&&(61===n.charCodeAt(Sr)?(e="=",Sr++):(e=null,0===Cr&&s('"="')),null===e&&(123===n.charCodeAt(Sr)?(e="{",Sr++):(e=null,0===Cr&&s('"{"')),null===e&&(125===n.charCodeAt(Sr)?(e="}",Sr++):(e=null,0===Cr&&s('"}"')),null===e&&null===(e=d())&&(e=p())))))))))))))))),e}function D(){var e,t,r;if(r=Sr,t=f(),null===t&&(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null===t&&(46===n.charCodeAt(Sr)?(t=".",Sr++):(t=null,0===Cr&&s('"."')),null===t&&(33===n.charCodeAt(Sr)?(t="!",Sr++):(t=null,0===Cr&&s('"!"')),null===t&&(37===n.charCodeAt(Sr)?(t="%",Sr++):(t=null,0===Cr&&s('"%"')),null===t&&(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null===t&&(95===n.charCodeAt(Sr)?(t="_",Sr++):(t=null,0===Cr&&s('"_"')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(96===n.charCodeAt(Sr)?(t="`",Sr++):(t=null,0===Cr&&s('"`"')),null===t&&(39===n.charCodeAt(Sr)?(t="'",Sr++):(t=null,0===Cr&&s('"\'"')),null===t&&(126===n.charCodeAt(Sr)?(t="~",Sr++):(t=null,0===Cr&&s('"~"')),null===t&&(40===n.charCodeAt(Sr)?(t="(",Sr++):(t=null,0===Cr&&s('"("')),null===t&&(41===n.charCodeAt(Sr)?(t=")",Sr++):(t=null,0===Cr&&s('")"')),null===t&&(60===n.charCodeAt(Sr)?(t="<",Sr++):(t=null,0===Cr&&s('"<"')),null===t&&(62===n.charCodeAt(Sr)?(t=">",Sr++):(t=null,0===Cr&&s('">"')),null===t&&(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null===t&&(92===n.charCodeAt(Sr)?(t="\\",Sr++):(t=null,0===Cr&&s('"\\\\"')),null===t&&null===(t=h())&&(47===n.charCodeAt(Sr)?(t="/",Sr++):(t=null,0===Cr&&s('"/"')),null===t&&(91===n.charCodeAt(Sr)?(t="[",Sr++):(t=null,0===Cr&&s('"["')),null===t&&(93===n.charCodeAt(Sr)?(t="]",Sr++):(t=null,0===Cr&&s('"]"')),null===t&&(63===n.charCodeAt(Sr)?(t="?",Sr++):(t=null,0===Cr&&s('"?"')),null===t&&(123===n.charCodeAt(Sr)?(t="{",Sr++):(t=null,0===Cr&&s('"{"')),null===t&&(125===n.charCodeAt(Sr)?(t="}",Sr++):(t=null,0===Cr&&s('"}"')))))))))))))))))))))))),null!==t)for(e=[];null!==t;)e.push(t),null===(t=f())&&(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null===t&&(46===n.charCodeAt(Sr)?(t=".",Sr++):(t=null,0===Cr&&s('"."')),null===t&&(33===n.charCodeAt(Sr)?(t="!",Sr++):(t=null,0===Cr&&s('"!"')),null===t&&(37===n.charCodeAt(Sr)?(t="%",Sr++):(t=null,0===Cr&&s('"%"')),null===t&&(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null===t&&(95===n.charCodeAt(Sr)?(t="_",Sr++):(t=null,0===Cr&&s('"_"')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(96===n.charCodeAt(Sr)?(t="`",Sr++):(t=null,0===Cr&&s('"`"')),null===t&&(39===n.charCodeAt(Sr)?(t="'",Sr++):(t=null,0===Cr&&s('"\'"')),null===t&&(126===n.charCodeAt(Sr)?(t="~",Sr++):(t=null,0===Cr&&s('"~"')),null===t&&(40===n.charCodeAt(Sr)?(t="(",Sr++):(t=null,0===Cr&&s('"("')),null===t&&(41===n.charCodeAt(Sr)?(t=")",Sr++):(t=null,0===Cr&&s('")"')),null===t&&(60===n.charCodeAt(Sr)?(t="<",Sr++):(t=null,0===Cr&&s('"<"')),null===t&&(62===n.charCodeAt(Sr)?(t=">",Sr++):(t=null,0===Cr&&s('">"')),null===t&&(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null===t&&(92===n.charCodeAt(Sr)?(t="\\",Sr++):(t=null,0===Cr&&s('"\\\\"')),null===t&&null===(t=h())&&(47===n.charCodeAt(Sr)?(t="/",Sr++):(t=null,0===Cr&&s('"/"')),null===t&&(91===n.charCodeAt(Sr)?(t="[",Sr++):(t=null,0===Cr&&s('"["')),null===t&&(93===n.charCodeAt(Sr)?(t="]",Sr++):(t=null,0===Cr&&s('"]"')),null===t&&(63===n.charCodeAt(Sr)?(t="?",Sr++):(t=null,0===Cr&&s('"?"')),null===t&&(123===n.charCodeAt(Sr)?(t="{",Sr++):(t=null,0===Cr&&s('"{"')),null===t&&(125===n.charCodeAt(Sr)?(t="}",Sr++):(t=null,0===Cr&&s('"}"'))))))))))))))))))))))));else e=null;return null!==e&&(e=function(e){return n.substring(Sr,e)}(r)),null===e&&(Sr=r),e}function O(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(42===n.charCodeAt(Sr)?(t="*",Sr++):(t=null,0===Cr&&s('"*"')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e="*"),null===e&&(Sr=i),e}function x(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(47===n.charCodeAt(Sr)?(t="/",Sr++):(t=null,0===Cr&&s('"/"')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e="/"),null===e&&(Sr=i),e}function U(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e="="),null===e&&(Sr=i),e}function P(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(40===n.charCodeAt(Sr)?(t="(",Sr++):(t=null,0===Cr&&s('"("')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e="("),null===e&&(Sr=i),e}function M(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(41===n.charCodeAt(Sr)?(t=")",Sr++):(t=null,0===Cr&&s('")"')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=")"),null===e&&(Sr=i),e}function q(){var e,t,r,i;return r=Sr,i=Sr,62===n.charCodeAt(Sr)?(e=">",Sr++):(e=null,0===Cr&&s('">"')),null!==e?(t=S(),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e=">"),null===e&&(Sr=r),e}function k(){var e,t,r,i;return r=Sr,i=Sr,e=S(),null!==e?(60===n.charCodeAt(Sr)?(t="<",Sr++):(t=null,0===Cr&&s('"<"')),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e="<"),null===e&&(Sr=r),e}function L(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(44===n.charCodeAt(Sr)?(t=",",Sr++):(t=null,0===Cr&&s('","')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=","),null===e&&(Sr=i),e}function H(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(59===n.charCodeAt(Sr)?(t=";",Sr++):(t=null,0===Cr&&s('";"')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=";"),null===e&&(Sr=i),e}function F(){var e,t,r,i,l;return i=Sr,l=Sr,e=S(),null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=S(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=":"),null===e&&(Sr=i),e}function G(){var e,t,n,r;return n=Sr,r=Sr,e=S(),null!==e?(t=h(),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),null!==e&&(e='"'),null===e&&(Sr=n),e}function j(){var e,t,n,r;return n=Sr,r=Sr,e=h(),null!==e?(t=S(),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),null!==e&&(e='"'),null===e&&(Sr=n),e}function W(){var e,t,n,r;if(r=Sr,null!==(e=P())){for(t=[],n=B(),null===n&&null===(n=J())&&(n=W());null!==n;)t.push(n),null===(n=B())&&null===(n=J())&&(n=W());null!==t?(n=M(),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)}else e=null,Sr=r;return e}function B(){var e;return/^[!-']/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[!-']")),null===e&&(/^[*-[]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[*-[]")),null===e&&(/^[\]-~]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[\\]-~]")),null===e&&null===(e=y())&&(e=_()))),e}function V(){var e,t,r,s,i,l;if(i=Sr,l=Sr,null!==(e=S()))if(null!==(t=h())){for(r=[],s=K(),null===s&&(s=J());null!==s;)r.push(s),null===(s=K())&&(s=J());null!==r?(s=h(),null!==s?e=[e,t,r,s]:(e=null,Sr=l)):(e=null,Sr=l)}else e=null,Sr=l;else e=null,Sr=l;return null!==e&&(e=function(e){return n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function z(){var e,t,r,s,i,l;if(i=Sr,l=Sr,null!==(e=S()))if(null!==(t=h())){for(r=[],s=K(),null===s&&(s=J());null!==s;)r.push(s),null===(s=K())&&(s=J());null!==r?(s=h(),null!==s?e=[e,t,r,s]:(e=null,Sr=l)):(e=null,Sr=l)}else e=null,Sr=l;else e=null,Sr=l;return null!==e&&(e=function(e){return n.substring(Sr-1,e+1)}(i)),null===e&&(Sr=i),e}function K(){var e;return e=_(),null===e&&(33===n.charCodeAt(Sr)?(e="!",Sr++):(e=null,0===Cr&&s('"!"')),null===e&&(/^[#-[]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[#-[]")),null===e&&(/^[\]-~]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[\\]-~]")),null===e&&(e=y())))),e}function J(){var e,t,r;return r=Sr,92===n.charCodeAt(Sr)?(e="\\",Sr++):(e=null,0===Cr&&s('"\\\\"')),null!==e?(/^[\0-\t]/.test(n.charAt(Sr))?(t=n.charAt(Sr),Sr++):(t=null,0===Cr&&s("[\\0-\\t]")),null===t&&(/^[\x0B-\f]/.test(n.charAt(Sr))?(t=n.charAt(Sr),Sr++):(t=null,0===Cr&&s("[\\x0B-\\f]")),null===t&&(/^[\x0E-]/.test(n.charAt(Sr))?(t=n.charAt(Sr),Sr++):(t=null,0===Cr&&s("[\\x0E-]")))),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),e}function Y(){var e,t,r,i,l,o;return l=Sr,o=Sr,e=X(),null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=ee(),r=null!==r?r:"",null!==r?(i=se(),null!==i?e=[e,t,r,i]:(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o),null!==e&&(e=function(e){try{br.uri=new yr(br.scheme,br.user,br.host,br.port),delete br.scheme,delete br.user,delete br.host,delete br.host_type,delete br.port}catch(e){br=-1}}()),null===e&&(Sr=l),e}function $(){var e,t,i,l,o,u,a,c;return a=Sr,c=Sr,e=X(),null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(i=ee(),i=null!==i?i:"",null!==i?(l=se(),null!==l?(o=ge(),null!==o?(u=Ne(),u=null!==u?u:"",null!==u?e=[e,t,i,l,o,u]:(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c),null!==e&&(e=function(e){try{br.uri=new yr(br.scheme,br.user,br.host,br.port,br.uri_params,br.uri_headers),delete br.scheme,delete br.user,delete br.host,delete br.host_type,delete br.port,delete br.uri_params,"SIP_URI"===r&&(br=br.uri)}catch(e){br=-1}}()),null===e&&(Sr=a),e}function X(){var e;return e=Q(),null===e&&(e=Z()),e}function Q(){var e,t;return t=Sr,"sips"===n.substr(Sr,4).toLowerCase()?(e=n.substr(Sr,4),Sr+=4):(e=null,0===Cr&&s('"sips"')),null!==e&&(e=function(e,t){br.scheme=t.toLowerCase()}(0,e)),null===e&&(Sr=t),e}function Z(){var e,t;return t=Sr,"sip"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),
Sr+=3):(e=null,0===Cr&&s('"sip"')),null!==e&&(e=function(e,t){br.scheme=t.toLowerCase()}(0,e)),null===e&&(Sr=t),e}function ee(){var e,t,r,i,l,o;return i=Sr,l=Sr,e=te(),null!==e?(o=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=re(),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o),t=null!==t?t:"",null!==t?(64===n.charCodeAt(Sr)?(r="@",Sr++):(r=null,0===Cr&&s('"@"')),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e){br.user=decodeURIComponent(n.substring(Sr-1,e))}(i)),null===e&&(Sr=i),e}function te(){var e,t;if(t=g(),null===t&&null===(t=v())&&(t=ne()),null!==t)for(e=[];null!==t;)e.push(t),null===(t=g())&&null===(t=v())&&(t=ne());else e=null;return e}function ne(){var e;return 38===n.charCodeAt(Sr)?(e="&",Sr++):(e=null,0===Cr&&s('"&"')),null===e&&(61===n.charCodeAt(Sr)?(e="=",Sr++):(e=null,0===Cr&&s('"="')),null===e&&(43===n.charCodeAt(Sr)?(e="+",Sr++):(e=null,0===Cr&&s('"+"')),null===e&&(36===n.charCodeAt(Sr)?(e="$",Sr++):(e=null,0===Cr&&s('"$"')),null===e&&(44===n.charCodeAt(Sr)?(e=",",Sr++):(e=null,0===Cr&&s('","')),null===e&&(59===n.charCodeAt(Sr)?(e=";",Sr++):(e=null,0===Cr&&s('";"')),null===e&&(63===n.charCodeAt(Sr)?(e="?",Sr++):(e=null,0===Cr&&s('"?"')),null===e&&(47===n.charCodeAt(Sr)?(e="/",Sr++):(e=null,0===Cr&&s('"/"'))))))))),e}function re(){var e,t,r;for(r=Sr,e=[],t=g(),null===t&&null===(t=v())&&(38===n.charCodeAt(Sr)?(t="&",Sr++):(t=null,0===Cr&&s('"&"')),null===t&&(61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(36===n.charCodeAt(Sr)?(t="$",Sr++):(t=null,0===Cr&&s('"$"')),null===t&&(44===n.charCodeAt(Sr)?(t=",",Sr++):(t=null,0===Cr&&s('","')))))));null!==t;)e.push(t),null===(t=g())&&null===(t=v())&&(38===n.charCodeAt(Sr)?(t="&",Sr++):(t=null,0===Cr&&s('"&"')),null===t&&(61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')),null===t&&(36===n.charCodeAt(Sr)?(t="$",Sr++):(t=null,0===Cr&&s('"$"')),null===t&&(44===n.charCodeAt(Sr)?(t=",",Sr++):(t=null,0===Cr&&s('","')))))));return null!==e&&(e=function(e){br.password=n.substring(Sr,e)}(r)),null===e&&(Sr=r),e}function se(){var e,t,r,i,l;return i=Sr,e=ie(),null!==e?(l=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=me(),null!==r?t=[t,r]:(t=null,Sr=l)):(t=null,Sr=l),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),e}function ie(){var e,t;return t=Sr,e=le(),null===e&&null===(e=pe())&&(e=ae()),null!==e&&(e=function(e){return br.host=n.substring(Sr,e).toLowerCase(),br.host}(t)),null===e&&(Sr=t),e}function le(){var e,t,r,i,l,o;for(i=Sr,l=Sr,e=[],o=Sr,t=oe(),null!==t?(46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o);null!==t;)e.push(t),o=Sr,t=oe(),null!==t?(46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o);return null!==e?(t=ue(),null!==t?(46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')),r=null!==r?r:"",null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e){return br.host_type="domain",n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function oe(){var e,t,r,i;if(i=Sr,null!==(e=f())){for(t=[],r=f(),null===r&&(45===n.charCodeAt(Sr)?(r="-",Sr++):(r=null,0===Cr&&s('"-"')),null===r&&(95===n.charCodeAt(Sr)?(r="_",Sr++):(r=null,0===Cr&&s('"_"'))));null!==r;)t.push(r),null===(r=f())&&(45===n.charCodeAt(Sr)?(r="-",Sr++):(r=null,0===Cr&&s('"-"')),null===r&&(95===n.charCodeAt(Sr)?(r="_",Sr++):(r=null,0===Cr&&s('"_"'))));null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return e}function ue(){var e,t,r,i;if(i=Sr,null!==(e=o())){for(t=[],r=f(),null===r&&(45===n.charCodeAt(Sr)?(r="-",Sr++):(r=null,0===Cr&&s('"-"')),null===r&&(95===n.charCodeAt(Sr)?(r="_",Sr++):(r=null,0===Cr&&s('"_"'))));null!==r;)t.push(r),null===(r=f())&&(45===n.charCodeAt(Sr)?(r="-",Sr++):(r=null,0===Cr&&s('"-"')),null===r&&(95===n.charCodeAt(Sr)?(r="_",Sr++):(r=null,0===Cr&&s('"_"'))));null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return e}function ae(){var e,t,r,i,l;return i=Sr,l=Sr,91===n.charCodeAt(Sr)?(e="[",Sr++):(e=null,0===Cr&&s('"["')),null!==e?(t=ce(),null!==t?(93===n.charCodeAt(Sr)?(r="]",Sr++):(r=null,0===Cr&&s('"]"')),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e){return br.host_type="IPv6",n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function ce(){var e,t,r,i,l,o,u,a,c,h,d,p,f,m,g,T;return m=Sr,g=Sr,e=he(),null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?(58===n.charCodeAt(Sr)?(i=":",Sr++):(i=null,0===Cr&&s('":"')),null!==i?(l=he(),null!==l?(58===n.charCodeAt(Sr)?(o=":",Sr++):(o=null,0===Cr&&s('":"')),null!==o?(u=he(),null!==u?(58===n.charCodeAt(Sr)?(a=":",Sr++):(a=null,0===Cr&&s('":"')),null!==a?(c=he(),null!==c?(58===n.charCodeAt(Sr)?(h=":",Sr++):(h=null,0===Cr&&s('":"')),null!==h?(d=he(),null!==d?(58===n.charCodeAt(Sr)?(p=":",Sr++):(p=null,0===Cr&&s('":"')),null!==p?(f=de(),null!==f?e=[e,t,r,i,l,o,u,a,c,h,d,p,f]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=he(),null!==t?(58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?(58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?(58===n.charCodeAt(Sr)?(u=":",Sr++):(u=null,0===Cr&&s('":"')),null!==u?(a=he(),null!==a?(58===n.charCodeAt(Sr)?(c=":",Sr++):(c=null,0===Cr&&s('":"')),null!==c?(h=he(),null!==h?(58===n.charCodeAt(Sr)?(d=":",Sr++):(d=null,0===Cr&&s('":"')),null!==d?(p=de(),null!==p?e=[e,t,r,i,l,o,u,a,c,h,d,p]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=he(),null!==t?(58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?(58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?(58===n.charCodeAt(Sr)?(u=":",Sr++):(u=null,0===Cr&&s('":"')),null!==u?(a=he(),null!==a?(58===n.charCodeAt(Sr)?(c=":",Sr++):(c=null,0===Cr&&s('":"')),null!==c?(h=de(),null!==h?e=[e,t,r,i,l,o,u,a,c,h]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=he(),null!==t?(58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?(58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?(58===n.charCodeAt(Sr)?(u=":",Sr++):(u=null,0===Cr&&s('":"')),null!==u?(a=de(),null!==a?e=[e,t,r,i,l,o,u,a]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=he(),null!==t?(58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?(58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=de(),null!==o?e=[e,t,r,i,l,o]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=he(),null!==t?(58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=de(),null!==i?e=[e,t,r,i]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=de(),null!==t?e=[e,t]:(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,"::"===n.substr(Sr,2)?(e="::",Sr+=2):(e=null,0===Cr&&s('"::"')),null!==e?(t=he(),null!==t?e=[e,t]:(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?("::"===n.substr(Sr,2)?(t="::",Sr+=2):(t=null,0===Cr&&s('"::"')),null!==t?(r=he(),null!==r?(58===n.charCodeAt(Sr)?(i=":",Sr++):(i=null,0===Cr&&s('":"')),null!==i?(l=he(),null!==l?(58===n.charCodeAt(Sr)?(o=":",Sr++):(o=null,0===Cr&&s('":"')),null!==o?(u=he(),null!==u?(58===n.charCodeAt(Sr)?(a=":",Sr++):(a=null,0===Cr&&s('":"')),null!==a?(c=he(),null!==c?(58===n.charCodeAt(Sr)?(h=":",Sr++):(h=null,0===Cr&&s('":"')),null!==h?(d=de(),null!==d?e=[e,t,r,i,l,o,u,a,c,h,d]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?(T=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?t=[t,r]:(t=null,Sr=T)):(t=null,Sr=T),t=null!==t?t:"",null!==t?("::"===n.substr(Sr,2)?(r="::",Sr+=2):(r=null,0===Cr&&s('"::"')),null!==r?(i=he(),null!==i?(58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?(58===n.charCodeAt(Sr)?(u=":",Sr++):(u=null,0===Cr&&s('":"')),null!==u?(a=he(),null!==a?(58===n.charCodeAt(Sr)?(c=":",Sr++):(c=null,0===Cr&&s('":"')),null!==c?(h=de(),null!==h?e=[e,t,r,i,l,o,u,a,c,h]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?(T=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?t=[t,r]:(t=null,Sr=T)):(t=null,Sr=T),t=null!==t?t:"",null!==t?(T=Sr,58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?r=[r,i]:(r=null,Sr=T)):(r=null,Sr=T),r=null!==r?r:"",null!==r?("::"===n.substr(Sr,2)?(i="::",Sr+=2):(i=null,0===Cr&&s('"::"')),null!==i?(l=he(),null!==l?(58===n.charCodeAt(Sr)?(o=":",Sr++):(o=null,0===Cr&&s('":"')),null!==o?(u=he(),null!==u?(58===n.charCodeAt(Sr)?(a=":",Sr++):(a=null,0===Cr&&s('":"')),null!==a?(c=de(),null!==c?e=[e,t,r,i,l,o,u,a,c]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?(T=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?t=[t,r]:(t=null,Sr=T)):(t=null,Sr=T),t=null!==t?t:"",null!==t?(T=Sr,58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?r=[r,i]:(r=null,Sr=T)):(r=null,Sr=T),r=null!==r?r:"",null!==r?(T=Sr,58===n.charCodeAt(Sr)?(i=":",Sr++):(i=null,0===Cr&&s('":"')),null!==i?(l=he(),null!==l?i=[i,l]:(i=null,Sr=T)):(i=null,Sr=T),i=null!==i?i:"",null!==i?("::"===n.substr(Sr,2)?(l="::",Sr+=2):(l=null,0===Cr&&s('"::"')),null!==l?(o=he(),null!==o?(58===n.charCodeAt(Sr)?(u=":",Sr++):(u=null,0===Cr&&s('":"')),null!==u?(a=de(),null!==a?e=[e,t,r,i,l,o,u,a]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?(T=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?t=[t,r]:(t=null,Sr=T)):(t=null,Sr=T),t=null!==t?t:"",null!==t?(T=Sr,58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?r=[r,i]:(r=null,Sr=T)):(r=null,Sr=T),r=null!==r?r:"",null!==r?(T=Sr,58===n.charCodeAt(Sr)?(i=":",Sr++):(i=null,0===Cr&&s('":"')),null!==i?(l=he(),null!==l?i=[i,l]:(i=null,Sr=T)):(i=null,Sr=T),i=null!==i?i:"",null!==i?(T=Sr,58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?l=[l,o]:(l=null,Sr=T)):(l=null,Sr=T),l=null!==l?l:"",null!==l?("::"===n.substr(Sr,2)?(o="::",Sr+=2):(o=null,0===Cr&&s('"::"')),null!==o?(u=de(),null!==u?e=[e,t,r,i,l,o,u]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?(T=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?t=[t,r]:(t=null,Sr=T)):(t=null,Sr=T),t=null!==t?t:"",null!==t?(T=Sr,58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?r=[r,i]:(r=null,Sr=T)):(r=null,Sr=T),r=null!==r?r:"",null!==r?(T=Sr,58===n.charCodeAt(Sr)?(i=":",Sr++):(i=null,0===Cr&&s('":"')),null!==i?(l=he(),null!==l?i=[i,l]:(i=null,Sr=T)):(i=null,Sr=T),i=null!==i?i:"",null!==i?(T=Sr,58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?l=[l,o]:(l=null,Sr=T)):(l=null,Sr=T),l=null!==l?l:"",null!==l?(T=Sr,58===n.charCodeAt(Sr)?(o=":",Sr++):(o=null,0===Cr&&s('":"')),null!==o?(u=he(),null!==u?o=[o,u]:(o=null,Sr=T)):(o=null,Sr=T),o=null!==o?o:"",null!==o?("::"===n.substr(Sr,2)?(u="::",Sr+=2):(u=null,0===Cr&&s('"::"')),null!==u?(a=he(),null!==a?e=[e,t,r,i,l,o,u,a]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g),null===e&&(g=Sr,e=he(),null!==e?(T=Sr,58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?t=[t,r]:(t=null,Sr=T)):(t=null,Sr=T),t=null!==t?t:"",null!==t?(T=Sr,58===n.charCodeAt(Sr)?(r=":",Sr++):(r=null,0===Cr&&s('":"')),null!==r?(i=he(),null!==i?r=[r,i]:(r=null,Sr=T)):(r=null,Sr=T),r=null!==r?r:"",null!==r?(T=Sr,58===n.charCodeAt(Sr)?(i=":",Sr++):(i=null,0===Cr&&s('":"')),null!==i?(l=he(),null!==l?i=[i,l]:(i=null,Sr=T)):(i=null,Sr=T),i=null!==i?i:"",null!==i?(T=Sr,58===n.charCodeAt(Sr)?(l=":",Sr++):(l=null,0===Cr&&s('":"')),null!==l?(o=he(),null!==o?l=[l,o]:(l=null,Sr=T)):(l=null,Sr=T),l=null!==l?l:"",null!==l?(T=Sr,58===n.charCodeAt(Sr)?(o=":",Sr++):(o=null,0===Cr&&s('":"')),null!==o?(u=he(),null!==u?o=[o,u]:(o=null,Sr=T)):(o=null,Sr=T),o=null!==o?o:"",null!==o?(T=Sr,58===n.charCodeAt(Sr)?(u=":",Sr++):(u=null,0===Cr&&s('":"')),null!==u?(a=he(),null!==a?u=[u,a]:(u=null,Sr=T)):(u=null,Sr=T),u=null!==u?u:"",null!==u?("::"===n.substr(Sr,2)?(a="::",Sr+=2):(a=null,0===Cr&&s('"::"')),null!==a?e=[e,t,r,i,l,o,u,a]:(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g)):(e=null,Sr=g))))))))))))))),null!==e&&(e=function(e){return br.host_type="IPv6",n.substring(Sr,e)}(m)),null===e&&(Sr=m),e}function he(){var e,t,n,r,s;return s=Sr,e=u(),null!==e?(t=u(),t=null!==t?t:"",null!==t?(n=u(),n=null!==n?n:"",null!==n?(r=u(),r=null!==r?r:"",null!==r?e=[e,t,n,r]:(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s),e}function de(){var e,t,r,i;return i=Sr,e=he(),null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=he(),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),null===e&&(e=pe()),e}function pe(){var e,t,r,i,l,o,u,a,c;return a=Sr,c=Sr,e=fe(),null!==e?(46===n.charCodeAt(Sr)?(t=".",Sr++):(t=null,0===Cr&&s('"."')),null!==t?(r=fe(),null!==r?(46===n.charCodeAt(Sr)?(i=".",Sr++):(i=null,0===Cr&&s('"."')),null!==i?(l=fe(),null!==l?(46===n.charCodeAt(Sr)?(o=".",Sr++):(o=null,0===Cr&&s('"."')),null!==o?(u=fe(),null!==u?e=[e,t,r,i,l,o,u]:(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c)):(e=null,Sr=c),null!==e&&(e=function(e){return br.host_type="IPv4",n.substring(Sr,e)}(a)),null===e&&(Sr=a),e}function fe(){var e,t,r,i;return i=Sr,"25"===n.substr(Sr,2)?(e="25",Sr+=2):(e=null,0===Cr&&s('"25"')),null!==e?(/^[0-5]/.test(n.charAt(Sr))?(t=n.charAt(Sr),Sr++):(t=null,0===Cr&&s("[0-5]")),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null===e&&(i=Sr,50===n.charCodeAt(Sr)?(e="2",Sr++):(e=null,0===Cr&&s('"2"')),null!==e?(/^[0-4]/.test(n.charAt(Sr))?(t=n.charAt(Sr),Sr++):(t=null,0===Cr&&s("[0-4]")),null!==t?(r=l(),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),null===e&&(i=Sr,49===n.charCodeAt(Sr)?(e="1",Sr++):(e=null,0===Cr&&s('"1"')),null!==e?(t=l(),null!==t?(r=l(),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),null===e&&(i=Sr,/^[1-9]/.test(n.charAt(Sr))?(e=n.charAt(Sr),Sr++):(e=null,0===Cr&&s("[1-9]")),null!==e?(t=l(),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null===e&&(e=l())))),e}function me(){var e,t,n,r,s,i,o;return i=Sr,o=Sr,e=l(),e=null!==e?e:"",null!==e?(t=l(),t=null!==t?t:"",null!==t?(n=l(),n=null!==n?n:"",null!==n?(r=l(),r=null!==r?r:"",null!==r?(s=l(),s=null!==s?s:"",null!==s?e=[e,t,n,r,s]:(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o),null!==e&&(e=function(e,t){return t=parseInt(t.join("")),br.port=t,t}(0,e)),null===e&&(Sr=i),e}function ge(){var e,t,r,i;for(e=[],i=Sr,59===n.charCodeAt(Sr)?(t=";",Sr++):(t=null,0===Cr&&s('";"')),null!==t?(r=Te(),null!==r?t=[t,r]:(t=null,Sr=i)):(t=null,Sr=i);null!==t;)e.push(t),i=Sr,59===n.charCodeAt(Sr)?(t=";",Sr++):(t=null,0===Cr&&s('";"')),null!==t?(r=Te(),null!==r?t=[t,r]:(t=null,Sr=i)):(t=null,Sr=i);return e}function Te(){var e;return e=ve(),null===e&&null===(e=_e())&&null===(e=Se())&&null===(e=Ce())&&null===(e=Ee())&&null===(e=Ae())&&(e=ye()),e}function ve(){var e,t,r,i;return r=Sr,i=Sr,"transport="===n.substr(Sr,10).toLowerCase()?(e=n.substr(Sr,10),Sr+=10):(e=null,0===Cr&&s('"transport="')),null!==e?("udp"===n.substr(Sr,3).toLowerCase()?(t=n.substr(Sr,3),Sr+=3):(t=null,0===Cr&&s('"udp"')),null===t&&("tcp"===n.substr(Sr,3).toLowerCase()?(t=n.substr(Sr,3),Sr+=3):(t=null,0===Cr&&s('"tcp"')),null===t&&("sctp"===n.substr(Sr,4).toLowerCase()?(t=n.substr(Sr,4),Sr+=4):(t=null,0===Cr&&s('"sctp"')),null===t&&("tls"===n.substr(Sr,3).toLowerCase()?(t=n.substr(Sr,3),Sr+=3):(t=null,0===Cr&&s('"tls"')),null===t&&(t=I())))),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e=function(e,t){br.uri_params||(br.uri_params={}),br.uri_params.transport=t.toLowerCase()}(0,e[1])),null===e&&(Sr=r),e}function _e(){var e,t,r,i;return r=Sr,i=Sr,"user="===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"user="')),null!==e?("phone"===n.substr(Sr,5).toLowerCase()?(t=n.substr(Sr,5),Sr+=5):(t=null,0===Cr&&s('"phone"')),null===t&&("ip"===n.substr(Sr,2).toLowerCase()?(t=n.substr(Sr,2),Sr+=2):(t=null,0===Cr&&s('"ip"')),null===t&&(t=I())),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e=function(e,t){br.uri_params||(br.uri_params={}),br.uri_params.user=t.toLowerCase()}(0,e[1])),null===e&&(Sr=r),e}function Se(){var e,t,r,i;return r=Sr,i=Sr,"method="===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"method="')),null!==e?(t=ct(),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e=function(e,t){br.uri_params||(br.uri_params={}),br.uri_params.method=t}(0,e[1])),null===e&&(Sr=r),e}function Ce(){var e,t,r,i;return r=Sr,i=Sr,"ttl="===n.substr(Sr,4).toLowerCase()?(e=n.substr(Sr,4),Sr+=4):(e=null,0===Cr&&s('"ttl="')),null!==e?(t=Qn(),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e=function(e,t){br.params||(br.params={}),br.params.ttl=t}(0,e[1])),null===e&&(Sr=r),e}function Ee(){var e,t,r,i;return r=Sr,i=Sr,"maddr="===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"maddr="')),null!==e?(t=ie(),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),null!==e&&(e=function(e,t){br.uri_params||(br.uri_params={}),br.uri_params.maddr=t}(0,e[1])),null===e&&(Sr=r),e}function Ae(){var e,t,r,i,l,o;return i=Sr,l=Sr,"lr"===n.substr(Sr,2).toLowerCase()?(e=n.substr(Sr,2),Sr+=2):(e=null,0===Cr&&s('"lr"')),null!==e?(o=Sr,61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null!==t?(r=I(),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e){br.uri_params||(br.uri_params={}),br.uri_params.lr=void 0}()),null===e&&(Sr=i),e}function ye(){var e,t,r,i,l,o;return i=Sr,l=Sr,e=Re(),null!==e?(o=Sr,61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null!==t?(r=be(),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t,n){br.uri_params||(br.uri_params={}),n=void 0===n?void 0:n[1],br.uri_params[t.toLowerCase()]=n}(0,e[0],e[1])),null===e&&(Sr=i),e}function Re(){var e,t,n;if(n=Sr,null!==(t=Ie()))for(e=[];null!==t;)e.push(t),t=Ie();else e=null;return null!==e&&(e=function(e,t){return t.join("")}(0,e)),null===e&&(Sr=n),e}function be(){var e,t,n;if(n=Sr,null!==(t=Ie()))for(e=[];null!==t;)e.push(t),t=Ie();else e=null;return null!==e&&(e=function(e,t){return t.join("")}(0,e)),null===e&&(Sr=n),e}function Ie(){var e;return e=we(),null===e&&null===(e=g())&&(e=v()),e}function we(){var e;return 91===n.charCodeAt(Sr)?(e="[",Sr++):(e=null,0===Cr&&s('"["')),null===e&&(93===n.charCodeAt(Sr)?(e="]",Sr++):(e=null,0===Cr&&s('"]"')),null===e&&(47===n.charCodeAt(Sr)?(e="/",Sr++):(e=null,0===Cr&&s('"/"')),null===e&&(58===n.charCodeAt(Sr)?(e=":",Sr++):(e=null,0===Cr&&s('":"')),null===e&&(38===n.charCodeAt(Sr)?(e="&",Sr++):(e=null,0===Cr&&s('"&"')),null===e&&(43===n.charCodeAt(Sr)?(e="+",Sr++):(e=null,0===Cr&&s('"+"')),null===e&&(36===n.charCodeAt(Sr)?(e="$",Sr++):(e=null,0===Cr&&s('"$"')))))))),e}function Ne(){var e,t,r,i,l,o,u;if(o=Sr,63===n.charCodeAt(Sr)?(e="?",Sr++):(e=null,0===Cr&&s('"?"')),null!==e)if(null!==(t=De())){for(r=[],u=Sr,38===n.charCodeAt(Sr)?(i="&",Sr++):(i=null,0===Cr&&s('"&"')),null!==i?(l=De(),null!==l?i=[i,l]:(i=null,Sr=u)):(i=null,Sr=u);null!==i;)r.push(i),u=Sr,38===n.charCodeAt(Sr)?(i="&",Sr++):(i=null,0===Cr&&s('"&"')),null!==i?(l=De(),null!==l?i=[i,l]:(i=null,Sr=u)):(i=null,Sr=u);null!==r?e=[e,t,r]:(e=null,Sr=o)}else e=null,Sr=o;else e=null,Sr=o;return e}function De(){var e,t,r,i,l;return i=Sr,l=Sr,e=Oe(),null!==e?(61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null!==t?(r=xe(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t,n){t=t.join("").toLowerCase(),n=n.join(""),br.uri_headers||(br.uri_headers={}),br.uri_headers[t]?br.uri_headers[t].push(n):br.uri_headers[t]=[n]}(0,e[0],e[2])),null===e&&(Sr=i),e}function Oe(){var e,t;if(t=Ue(),null===t&&null===(t=g())&&(t=v()),null!==t)for(e=[];null!==t;)e.push(t),null===(t=Ue())&&null===(t=g())&&(t=v());else e=null;return e}function xe(){var e,t;for(e=[],t=Ue(),null===t&&null===(t=g())&&(t=v());null!==t;)e.push(t),null===(t=Ue())&&null===(t=g())&&(t=v());return e}function Ue(){var e;return 91===n.charCodeAt(Sr)?(e="[",Sr++):(e=null,0===Cr&&s('"["')),null===e&&(93===n.charCodeAt(Sr)?(e="]",Sr++):(e=null,0===Cr&&s('"]"')),null===e&&(47===n.charCodeAt(Sr)?(e="/",Sr++):(e=null,0===Cr&&s('"/"')),null===e&&(63===n.charCodeAt(Sr)?(e="?",Sr++):(e=null,0===Cr&&s('"?"')),null===e&&(58===n.charCodeAt(Sr)?(e=":",Sr++):(e=null,0===Cr&&s('":"')),null===e&&(43===n.charCodeAt(Sr)?(e="+",Sr++):(e=null,0===Cr&&s('"+"')),null===e&&(36===n.charCodeAt(Sr)?(e="$",Sr++):(e=null,0===Cr&&s('"$"')))))))),e}function Pe(){var e;return e=ht(),null===e&&(e=Me()),e}function Me(){var e,t,n,r,s,i;return i=Sr,e=ct(),null!==e?(t=d(),null!==t?(n=qe(),null!==n?(r=d(),null!==r?(s=Ze(),null!==s?e=[e,t,n,r,s]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function qe(){var e;return e=$(),null===e&&(e=ke()),e}function ke(){var e,t,r,i;return i=Sr,e=Je(),null!==e?(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null!==t?(r=Le(),null===r&&(r=Ge()),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function Le(){var e,t,r,i,l;return i=Sr,e=He(),null===e&&(e=Fe()),null!==e?(l=Sr,63===n.charCodeAt(Sr)?(t="?",Sr++):(t=null,0===Cr&&s('"?"')),null!==t?(r=Qe(),null!==r?t=[t,r]:(t=null,Sr=l)):(t=null,Sr=l),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),e}function He(){var e,t,r,i;return i=Sr,"//"===n.substr(Sr,2)?(e="//",Sr+=2):(e=null,0===Cr&&s('"//"')),null!==e?(t=Ye(),null!==t?(r=Fe(),r=null!==r?r:"",null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function Fe(){var e,t,r;return r=Sr,47===n.charCodeAt(Sr)?(e="/",Sr++):(e=null,0===Cr&&s('"/"')),null!==e?(t=Be(),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),e}function Ge(){var e,t,n,r;if(r=Sr,null!==(e=We())){for(t=[],n=je();null!==n;)t.push(n),n=je();null!==t?e=[e,t]:(e=null,Sr=r)}else e=null,Sr=r;return e}function je(){var e;return e=m(),null===e&&null===(e=g())&&(e=v()),e}function We(){var e;return e=g(),null===e&&null===(e=v())&&(59===n.charCodeAt(Sr)?(e=";",Sr++):(e=null,0===Cr&&s('";"')),null===e&&(63===n.charCodeAt(Sr)?(e="?",Sr++):(e=null,0===Cr&&s('"?"')),null===e&&(58===n.charCodeAt(Sr)?(e=":",Sr++):(e=null,0===Cr&&s('":"')),null===e&&(64===n.charCodeAt(Sr)?(e="@",Sr++):(e=null,0===Cr&&s('"@"')),null===e&&(38===n.charCodeAt(Sr)?(e="&",Sr++):(e=null,0===Cr&&s('"&"')),null===e&&(61===n.charCodeAt(Sr)?(e="=",Sr++):(e=null,0===Cr&&s('"="')),null===e&&(43===n.charCodeAt(Sr)?(e="+",Sr++):(e=null,0===Cr&&s('"+"')),null===e&&(36===n.charCodeAt(Sr)?(e="$",Sr++):(e=null,0===Cr&&s('"$"')),null===e&&(44===n.charCodeAt(Sr)?(e=",",Sr++):(e=null,0===Cr&&s('","'))))))))))),e}function Be(){var e,t,r,i,l,o;if(l=Sr,null!==(e=Ve())){for(t=[],o=Sr,47===n.charCodeAt(Sr)?(r="/",Sr++):(r=null,0===Cr&&s('"/"')),null!==r?(i=Ve(),null!==i?r=[r,i]:(r=null,Sr=o)):(r=null,Sr=o);null!==r;)t.push(r),o=Sr,47===n.charCodeAt(Sr)?(r="/",Sr++):(r=null,0===Cr&&s('"/"')),null!==r?(i=Ve(),null!==i?r=[r,i]:(r=null,Sr=o)):(r=null,Sr=o);null!==t?e=[e,t]:(e=null,Sr=l)}else e=null,Sr=l;return e}function Ve(){var e,t,r,i,l,o;for(l=Sr,e=[],t=Ke();null!==t;)e.push(t),t=Ke();if(null!==e){for(t=[],o=Sr,59===n.charCodeAt(Sr)?(r=";",Sr++):(r=null,0===Cr&&s('";"')),null!==r?(i=ze(),null!==i?r=[r,i]:(r=null,Sr=o)):(r=null,Sr=o);null!==r;)t.push(r),o=Sr,59===n.charCodeAt(Sr)?(r=";",Sr++):(r=null,0===Cr&&s('";"')),null!==r?(i=ze(),null!==i?r=[r,i]:(r=null,Sr=o)):(r=null,Sr=o);null!==t?e=[e,t]:(e=null,Sr=l)}else e=null,Sr=l;return e}function ze(){var e,t;for(e=[],t=Ke();null!==t;)e.push(t),t=Ke();return e}function Ke(){var e;return e=g(),null===e&&null===(e=v())&&(58===n.charCodeAt(Sr)?(e=":",Sr++):(e=null,0===Cr&&s('":"')),null===e&&(64===n.charCodeAt(Sr)?(e="@",Sr++):(e=null,0===Cr&&s('"@"')),null===e&&(38===n.charCodeAt(Sr)?(e="&",Sr++):(e=null,0===Cr&&s('"&"')),null===e&&(61===n.charCodeAt(Sr)?(e="=",Sr++):(e=null,0===Cr&&s('"="')),null===e&&(43===n.charCodeAt(Sr)?(e="+",Sr++):(e=null,0===Cr&&s('"+"')),null===e&&(36===n.charCodeAt(Sr)?(e="$",Sr++):(e=null,0===Cr&&s('"$"')),null===e&&(44===n.charCodeAt(Sr)?(e=",",Sr++):(e=null,0===Cr&&s('","'))))))))),e}function Je(){var e,t,r,i,u;if(i=Sr,u=Sr,null!==(e=o())){for(t=[],r=o(),null===r&&null===(r=l())&&(43===n.charCodeAt(Sr)?(r="+",Sr++):(r=null,0===Cr&&s('"+"')),null===r&&(45===n.charCodeAt(Sr)?(r="-",Sr++):(r=null,0===Cr&&s('"-"')),null===r&&(46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')))));null!==r;)t.push(r),null===(r=o())&&null===(r=l())&&(43===n.charCodeAt(Sr)?(r="+",Sr++):(r=null,0===Cr&&s('"+"')),null===r&&(45===n.charCodeAt(Sr)?(r="-",Sr++):(r=null,0===Cr&&s('"-"')),null===r&&(46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')))));null!==t?e=[e,t]:(e=null,Sr=u)}else e=null,Sr=u;return null!==e&&(e=function(e){br.scheme=n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function Ye(){var e;return e=$e(),null===e&&(e=Xe()),e}function $e(){var e,t,r,i;return r=Sr,i=Sr,e=ee(),null!==e?(64===n.charCodeAt(Sr)?(t="@",Sr++):(t=null,0===Cr&&s('"@"')),null!==t?e=[e,t]:(e=null,Sr=i)):(e=null,Sr=i),e=null!==e?e:"",null!==e?(t=se(),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),e=null!==e?e:""}function Xe(){var e,t;if(t=g(),null===t&&null===(t=v())&&(36===n.charCodeAt(Sr)?(t="$",Sr++):(t=null,0===Cr&&s('"$"')),null===t&&(44===n.charCodeAt(Sr)?(t=",",Sr++):(t=null,0===Cr&&s('","')),null===t&&(59===n.charCodeAt(Sr)?(t=";",Sr++):(t=null,0===Cr&&s('";"')),null===t&&(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null===t&&(64===n.charCodeAt(Sr)?(t="@",Sr++):(t=null,0===Cr&&s('"@"')),null===t&&(38===n.charCodeAt(Sr)?(t="&",Sr++):(t=null,0===Cr&&s('"&"')),null===t&&(61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"')))))))))),null!==t)for(e=[];null!==t;)e.push(t),null===(t=g())&&null===(t=v())&&(36===n.charCodeAt(Sr)?(t="$",Sr++):(t=null,0===Cr&&s('"$"')),null===t&&(44===n.charCodeAt(Sr)?(t=",",Sr++):(t=null,0===Cr&&s('","')),null===t&&(59===n.charCodeAt(Sr)?(t=";",Sr++):(t=null,0===Cr&&s('";"')),null===t&&(58===n.charCodeAt(Sr)?(t=":",Sr++):(t=null,0===Cr&&s('":"')),null===t&&(64===n.charCodeAt(Sr)?(t="@",Sr++):(t=null,0===Cr&&s('"@"')),null===t&&(38===n.charCodeAt(Sr)?(t="&",Sr++):(t=null,0===Cr&&s('"&"')),null===t&&(61===n.charCodeAt(Sr)?(t="=",Sr++):(t=null,0===Cr&&s('"="')),null===t&&(43===n.charCodeAt(Sr)?(t="+",Sr++):(t=null,0===Cr&&s('"+"'))))))))));else e=null;return e}function Qe(){var e,t;for(e=[],t=je();null!==t;)e.push(t),t=je();return e}function Ze(){var e,t,r,i,o,u,a,c;if(a=Sr,c=Sr,"sip"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"SIP"')),null!==e)if(47===n.charCodeAt(Sr)?(t="/",Sr++):(t=null,0===Cr&&s('"/"')),null!==t){if(null!==(i=l()))for(r=[];null!==i;)r.push(i),i=l();else r=null;if(null!==r)if(46===n.charCodeAt(Sr)?(i=".",Sr++):(i=null,0===Cr&&s('"."')),null!==i){if(null!==(u=l()))for(o=[];null!==u;)o.push(u),u=l();else o=null;null!==o?e=[e,t,r,i,o]:(e=null,Sr=c)}else e=null,Sr=c;else e=null,Sr=c}else e=null,Sr=c;else e=null,Sr=c;return null!==e&&(e=function(e){br.sip_version=n.substring(Sr,e)}(a)),null===e&&(Sr=a),e}function et(){var e;return"INVITE"===n.substr(Sr,6)?(e="INVITE",Sr+=6):(e=null,0===Cr&&s('"INVITE"')),e}function tt(){var e;return"ACK"===n.substr(Sr,3)?(e="ACK",Sr+=3):(e=null,0===Cr&&s('"ACK"')),e}function nt(){var e;return"PRACK"===n.substr(Sr,5)?(e="PRACK",Sr+=5):(e=null,0===Cr&&s('"PRACK"')),e}function rt(){var e;return"OPTIONS"===n.substr(Sr,7)?(e="OPTIONS",Sr+=7):(e=null,0===Cr&&s('"OPTIONS"')),e}function st(){var e;return"BYE"===n.substr(Sr,3)?(e="BYE",Sr+=3):(e=null,0===Cr&&s('"BYE"')),e}function it(){var e;return"CANCEL"===n.substr(Sr,6)?(e="CANCEL",Sr+=6):(e=null,0===Cr&&s('"CANCEL"')),e}function lt(){var e;return"REGISTER"===n.substr(Sr,8)?(e="REGISTER",Sr+=8):(e=null,0===Cr&&s('"REGISTER"')),e}function ot(){var e;return"SUBSCRIBE"===n.substr(Sr,9)?(e="SUBSCRIBE",Sr+=9):(e=null,0===Cr&&s('"SUBSCRIBE"')),e}function ut(){var e;return"NOTIFY"===n.substr(Sr,6)?(e="NOTIFY",Sr+=6):(e=null,0===Cr&&s('"NOTIFY"')),e}function at(){var e;return"REFER"===n.substr(Sr,5)?(e="REFER",Sr+=5):(e=null,0===Cr&&s('"REFER"')),e}function ct(){var e,t;return t=Sr,e=et(),null===e&&null===(e=tt())&&null===(e=rt())&&null===(e=st())&&null===(e=it())&&null===(e=nt())&&null===(e=lt())&&null===(e=ot())&&null===(e=ut())&&null===(e=at())&&(e=I()),null!==e&&(e=function(e){return br.method=n.substring(Sr,e),br.method}(t)),null===e&&(Sr=t),e}function ht(){var e,t,n,r,s,i;return i=Sr,e=Ze(),null!==e?(t=d(),null!==t?(n=dt(),null!==n?(r=d(),null!==r?(s=ft(),null!==s?e=[e,t,n,r,s]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function dt(){var e,t;return t=Sr,e=pt(),null!==e&&(e=function(e,t){br.status_code=parseInt(t.join(""))}(0,e)),null===e&&(Sr=t),e}function pt(){var e,t,n,r;return r=Sr,e=l(),null!==e?(t=l(),null!==t?(n=l(),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)):(e=null,Sr=r),e}function ft(){var e,t,r;for(r=Sr,e=[],t=m(),null===t&&null===(t=g())&&null===(t=v())&&null===(t=y())&&null===(t=R())&&null===(t=d())&&(t=p());null!==t;)e.push(t),null===(t=m())&&null===(t=g())&&null===(t=v())&&null===(t=y())&&null===(t=R())&&null===(t=d())&&(t=p());return null!==e&&(e=function(e){br.reason_phrase=n.substring(Sr,e)}(r)),null===e&&(Sr=r),e}function mt(){var e,t,n,r,s,i;if(s=Sr,null!==(e=$t())){for(t=[],i=Sr,n=L(),null!==n?(r=$t(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=L(),null!==n?(r=$t(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function gt(){var e,t,r,i,l,o;return i=Sr,l=Sr,e=D(),null!==e?(o=Sr,64===n.charCodeAt(Sr)?(t="@",Sr++):(t=null,0===Cr&&s('"@"')),null!==t?(r=D(),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o),
t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e){br=n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function Tt(){var e,t,n,r,s,i,l;if(s=Sr,null===(e=O()))if(i=Sr,null!==(e=vt())){for(t=[],l=Sr,n=L(),null!==n?(r=vt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=L(),null!==n?(r=vt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){var t,n;for(n=br.multi_header.length,t=0;t<n;t++)if(null===br.multi_header[t].parsed){br=null;break}br=null!==br?br.multi_header:-1}()),null===e&&(Sr=s),e}function vt(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,e=Y(),null===e&&(e=_t()),null!==e){for(t=[],l=Sr,n=H(),null!==n?(r=Ct(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=H(),null!==n?(r=Ct(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){var t;br.multi_header||(br.multi_header=[]);try{t=new Rr(br.uri,br.display_name,br.params),delete br.uri,delete br.display_name,delete br.params}catch(e){t=null}br.multi_header.push({possition:Sr,offset:e,parsed:t})}(s)),null===e&&(Sr=s),e}function _t(){var e,t,n,r,s;return s=Sr,e=St(),e=null!==e?e:"",null!==e?(t=k(),null!==t?(n=$(),null!==n?(r=q(),null!==r?e=[e,t,n,r]:(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s),e}function St(){var e,t,r,s,i,l,o;if(i=Sr,l=Sr,null!==(e=I())){for(t=[],o=Sr,r=_(),null!==r?(s=I(),null!==s?r=[r,s]:(r=null,Sr=o)):(r=null,Sr=o);null!==r;)t.push(r),o=Sr,r=_(),null!==r?(s=I(),null!==s?r=[r,s]:(r=null,Sr=o)):(r=null,Sr=o);null!==t?e=[e,t]:(e=null,Sr=l)}else e=null,Sr=l;return null===e&&(e=V()),null!==e&&(e=function(e,t){t=n.substring(Sr,e).trim(),'"'===t[0]&&(t=t.substring(1,t.length-1)),br.display_name=t}(i,e)),null===e&&(Sr=i),e}function Ct(){var e;return e=Et(),null===e&&null===(e=At())&&(e=bt()),e}function Et(){var e,t,r,i,l;return i=Sr,l=Sr,"q"===n.substr(Sr,1).toLowerCase()?(e=n.substr(Sr,1),Sr++):(e=null,0===Cr&&s('"q"')),null!==e?(t=U(),null!==t?(r=Rt(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.params||(br.params={}),br.params.q=t}(0,e[2])),null===e&&(Sr=i),e}function At(){var e,t,r,i,l;return i=Sr,l=Sr,"expires"===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"expires"')),null!==e?(t=U(),null!==t?(r=yt(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.params||(br.params={}),br.params.expires=t}(0,e[2])),null===e&&(Sr=i),e}function yt(){var e,t,n;if(n=Sr,null!==(t=l()))for(e=[];null!==t;)e.push(t),t=l();else e=null;return null!==e&&(e=function(e,t){return parseInt(t.join(""))}(0,e)),null===e&&(Sr=n),e}function Rt(){var e,t,r,i,o,u,a,c;return u=Sr,a=Sr,48===n.charCodeAt(Sr)?(e="0",Sr++):(e=null,0===Cr&&s('"0"')),null!==e?(c=Sr,46===n.charCodeAt(Sr)?(t=".",Sr++):(t=null,0===Cr&&s('"."')),null!==t?(r=l(),r=null!==r?r:"",null!==r?(i=l(),i=null!==i?i:"",null!==i?(o=l(),o=null!==o?o:"",null!==o?t=[t,r,i,o]:(t=null,Sr=c)):(t=null,Sr=c)):(t=null,Sr=c)):(t=null,Sr=c),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=a)):(e=null,Sr=a),null!==e&&(e=function(e){return parseFloat(n.substring(Sr,e))}(u)),null===e&&(Sr=u),e}function bt(){var e,t,n,r,s,i;return r=Sr,s=Sr,e=I(),null!==e?(i=Sr,t=U(),null!==t?(n=It(),null!==n?t=[t,n]:(t=null,Sr=i)):(t=null,Sr=i),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=s)):(e=null,Sr=s),null!==e&&(e=function(e,t,n){br.params||(br.params={}),n=void 0===n?void 0:n[1],br.params[t.toLowerCase()]=n}(0,e[0],e[1])),null===e&&(Sr=r),e}function It(){var e;return e=I(),null===e&&null===(e=ie())&&(e=V()),e}function wt(){var e,t,n,r,s,i;if(s=Sr,null!==(e=Nt())){for(t=[],i=Sr,n=H(),null!==n?(r=Dt(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=H(),null!==n?(r=Dt(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function Nt(){var e;return"render"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"render"')),null===e&&("session"===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"session"')),null===e&&("icon"===n.substr(Sr,4).toLowerCase()?(e=n.substr(Sr,4),Sr+=4):(e=null,0===Cr&&s('"icon"')),null===e&&("alert"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"alert"')),null===e&&(e=I())))),e}function Dt(){var e;return e=Ot(),null===e&&(e=bt()),e}function Ot(){var e,t,r,i;return i=Sr,"handling"===n.substr(Sr,8).toLowerCase()?(e=n.substr(Sr,8),Sr+=8):(e=null,0===Cr&&s('"handling"')),null!==e?(t=U(),null!==t?("optional"===n.substr(Sr,8).toLowerCase()?(r=n.substr(Sr,8),Sr+=8):(r=null,0===Cr&&s('"optional"')),null===r&&("required"===n.substr(Sr,8).toLowerCase()?(r=n.substr(Sr,8),Sr+=8):(r=null,0===Cr&&s('"required"')),null===r&&(r=I())),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function xt(){var e,t,n,r,s,i;if(s=Sr,null!==(e=I())){for(t=[],i=Sr,n=L(),null!==n?(r=I(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=L(),null!==n?(r=I(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function Ut(){var e,t,n;if(n=Sr,null!==(t=l()))for(e=[];null!==t;)e.push(t),t=l();else e=null;return null!==e&&(e=function(e,t){br=parseInt(t.join(""))}(0,e)),null===e&&(Sr=n),e}function Pt(){var e,t;return t=Sr,e=Mt(),null!==e&&(e=function(e){br=n.substring(Sr,e)}(t)),null===e&&(Sr=t),e}function Mt(){var e,t,n,r,s,i,l,o;if(l=Sr,null!==(e=qt()))if(null!==(t=x()))if(null!==(n=Gt())){for(r=[],o=Sr,s=H(),null!==s?(i=jt(),null!==i?s=[s,i]:(s=null,Sr=o)):(s=null,Sr=o);null!==s;)r.push(s),o=Sr,s=H(),null!==s?(i=jt(),null!==i?s=[s,i]:(s=null,Sr=o)):(s=null,Sr=o);null!==r?e=[e,t,n,r]:(e=null,Sr=l)}else e=null,Sr=l;else e=null,Sr=l;else e=null,Sr=l;return e}function qt(){var e;return e=kt(),null===e&&(e=Lt()),e}function kt(){var e;return"text"===n.substr(Sr,4).toLowerCase()?(e=n.substr(Sr,4),Sr+=4):(e=null,0===Cr&&s('"text"')),null===e&&("image"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"image"')),null===e&&("audio"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"audio"')),null===e&&("video"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"video"')),null===e&&("application"===n.substr(Sr,11).toLowerCase()?(e=n.substr(Sr,11),Sr+=11):(e=null,0===Cr&&s('"application"')),null===e&&(e=Ht()))))),e}function Lt(){var e;return"message"===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"message"')),null===e&&("multipart"===n.substr(Sr,9).toLowerCase()?(e=n.substr(Sr,9),Sr+=9):(e=null,0===Cr&&s('"multipart"')),null===e&&(e=Ht())),e}function Ht(){var e;return e=I(),null===e&&(e=Ft()),e}function Ft(){var e,t,r;return r=Sr,"x-"===n.substr(Sr,2).toLowerCase()?(e=n.substr(Sr,2),Sr+=2):(e=null,0===Cr&&s('"x-"')),null!==e?(t=I(),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),e}function Gt(){var e;return e=Ht(),null===e&&(e=I()),e}function jt(){var e,t,n,r;return r=Sr,e=I(),null!==e?(t=U(),null!==t?(n=Wt(),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)):(e=null,Sr=r),e}function Wt(){var e;return e=I(),null===e&&(e=V()),e}function Bt(){var e,t,n,r;return r=Sr,e=Vt(),null!==e?(t=_(),null!==t?(n=ct(),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)):(e=null,Sr=r),e}function Vt(){var e,t,n;if(n=Sr,null!==(t=l()))for(e=[];null!==t;)e.push(t),t=l();else e=null;return null!==e&&(e=function(e,t){br.value=parseInt(t.join(""))}(0,e)),null===e&&(Sr=n),e}function zt(){var e,t,n;if(n=Sr,null!==(t=l()))for(e=[];null!==t;)e.push(t),t=l();else e=null;return null!==e&&(e=function(e,t){br.rvalue=parseInt(t.join(""))}(0,e)),null===e&&(Sr=n),e}function Kt(){var e,t,n,r,s,i;return i=Sr,e=zt(),null!==e?(t=_(),null!==t?(n=Vt(),null!==n?(r=_(),null!==r?(s=ct(),null!==s?e=[e,t,n,r,s]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function Jt(){var e,t;return t=Sr,e=yt(),null!==e&&(e=function(e,t){br=t}(0,e)),null===e&&(Sr=t),e}function Yt(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,null!==(e=$t())){for(t=[],l=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e,t){br.event=t.join("").toLowerCase()}(0,e[0])),null===e&&(Sr=s),e}function $t(){var e,t,r,i,l,o;if(l=Sr,null!==(e=w())){for(t=[],o=Sr,46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')),null!==r?(i=w(),null!==i?r=[r,i]:(r=null,Sr=o)):(r=null,Sr=o);null!==r;)t.push(r),o=Sr,46===n.charCodeAt(Sr)?(r=".",Sr++):(r=null,0===Cr&&s('"."')),null!==r?(i=w(),null!==i?r=[r,i]:(r=null,Sr=o)):(r=null,Sr=o);null!==t?e=[e,t]:(e=null,Sr=l)}else e=null,Sr=l;return e}function Xt(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,e=Y(),null===e&&(e=_t()),null!==e){for(t=[],l=Sr,n=H(),null!==n?(r=Qt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=H(),null!==n?(r=Qt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){var t=br.tag;try{br=new Rr(br.uri,br.display_name,br.params),t&&br.setParam("tag",t)}catch(e){br=-1}}()),null===e&&(Sr=s),e}function Qt(){var e;return e=Zt(),null===e&&(e=bt()),e}function Zt(){var e,t,r,i,l;return i=Sr,l=Sr,"tag"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"tag"')),null!==e?(t=U(),null!==t?(r=I(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.tag=t}(0,e[2])),null===e&&(Sr=i),e}function en(){var e,t,n;if(n=Sr,null!==(t=l()))for(e=[];null!==t;)e.push(t),t=l();else e=null;return null!==e&&(e=function(e,t){br=parseInt(t.join(""))}(0,e)),null===e&&(Sr=n),e}function tn(){var e,t;return t=Sr,e=yt(),null!==e&&(e=function(e,t){br=t}(0,e)),null===e&&(Sr=t),e}function nn(){var e,t,n,r,s,i,l,o,u,a;for(o=Sr,u=Sr,e=[],t=St();null!==t;)e.push(t),t=St();if(null!==e)if(null!==(t=k()))if(null!==(n=$()))if(null!==(r=q())){for(s=[],a=Sr,i=H(),null!==i?(l=bt(),null!==l?i=[i,l]:(i=null,Sr=a)):(i=null,Sr=a);null!==i;)s.push(i),a=Sr,i=H(),null!==i?(l=bt(),null!==l?i=[i,l]:(i=null,Sr=a)):(i=null,Sr=a);null!==s?e=[e,t,n,r,s]:(e=null,Sr=u)}else e=null,Sr=u;else e=null,Sr=u;else e=null,Sr=u;else e=null,Sr=u;return null!==e&&(e=function(e){try{br=new Rr(br.uri,br.display_name,br.params)}catch(e){br=-1}}()),null===e&&(Sr=o),e}function rn(){return sn()}function sn(){var e,t,r,i,l,o,u,a;if(u=Sr,"digest"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"Digest"')),null!==e)if(null!==(t=_()))if(null!==(r=un())){for(i=[],a=Sr,l=L(),null!==l?(o=un(),null!==o?l=[l,o]:(l=null,Sr=a)):(l=null,Sr=a);null!==l;)i.push(l),a=Sr,l=L(),null!==l?(o=un(),null!==o?l=[l,o]:(l=null,Sr=a)):(l=null,Sr=a);null!==i?e=[e,t,r,i]:(e=null,Sr=u)}else e=null,Sr=u;else e=null,Sr=u;else e=null,Sr=u;return null===e&&(e=ln()),e}function ln(){var e,t,n,r,s,i,l,o;if(l=Sr,null!==(e=I()))if(null!==(t=_()))if(null!==(n=on())){for(r=[],o=Sr,s=L(),null!==s?(i=on(),null!==i?s=[s,i]:(s=null,Sr=o)):(s=null,Sr=o);null!==s;)r.push(s),o=Sr,s=L(),null!==s?(i=on(),null!==i?s=[s,i]:(s=null,Sr=o)):(s=null,Sr=o);null!==r?e=[e,t,n,r]:(e=null,Sr=l)}else e=null,Sr=l;else e=null,Sr=l;else e=null,Sr=l;return e}function on(){var e,t,n,r;return r=Sr,e=I(),null!==e?(t=U(),null!==t?(n=I(),null===n&&(n=V()),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)):(e=null,Sr=r),e}function un(){var e;return e=an(),null===e&&null===(e=hn())&&null===(e=pn())&&null===(e=mn())&&null===(e=gn())&&null===(e=Tn())&&null===(e=vn())&&(e=on()),e}function an(){var e,t,r,i;return i=Sr,"realm"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"realm"')),null!==e?(t=U(),null!==t?(r=cn(),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function cn(){var e,t;return t=Sr,e=z(),null!==e&&(e=function(e,t){br.realm=t}(0,e)),null===e&&(Sr=t),e}function hn(){var e,t,r,i,l,o,u,a,c;if(a=Sr,"domain"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"domain"')),null!==e)if(null!==(t=U()))if(null!==(r=G()))if(null!==(i=dn())){if(l=[],c=Sr,null!==(u=d()))for(o=[];null!==u;)o.push(u),u=d();else o=null;for(null!==o?(u=dn(),null!==u?o=[o,u]:(o=null,Sr=c)):(o=null,Sr=c);null!==o;){if(l.push(o),c=Sr,null!==(u=d()))for(o=[];null!==u;)o.push(u),u=d();else o=null;null!==o?(u=dn(),null!==u?o=[o,u]:(o=null,Sr=c)):(o=null,Sr=c)}null!==l?(o=j(),null!==o?e=[e,t,r,i,l,o]:(e=null,Sr=a)):(e=null,Sr=a)}else e=null,Sr=a;else e=null,Sr=a;else e=null,Sr=a;else e=null,Sr=a;return e}function dn(){var e;return e=ke(),null===e&&(e=Fe()),e}function pn(){var e,t,r,i;return i=Sr,"nonce"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"nonce"')),null!==e?(t=U(),null!==t?(r=fn(),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function fn(){var e,t;return t=Sr,e=z(),null!==e&&(e=function(e,t){br.nonce=t}(0,e)),null===e&&(Sr=t),e}function mn(){var e,t,r,i,l;return i=Sr,l=Sr,"opaque"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"opaque"')),null!==e?(t=U(),null!==t?(r=z(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.opaque=t}(0,e[2])),null===e&&(Sr=i),e}function gn(){var e,t,r,i,l;return i=Sr,"stale"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"stale"')),null!==e?(t=U(),null!==t?(l=Sr,"true"===n.substr(Sr,4).toLowerCase()?(r=n.substr(Sr,4),Sr+=4):(r=null,0===Cr&&s('"true"')),null!==r&&(r=function(e){br.stale=!0}()),null===r&&(Sr=l),null===r&&(l=Sr,"false"===n.substr(Sr,5).toLowerCase()?(r=n.substr(Sr,5),Sr+=5):(r=null,0===Cr&&s('"false"')),null!==r&&(r=function(e){br.stale=!1}()),null===r&&(Sr=l)),null!==r?e=[e,t,r]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function Tn(){var e,t,r,i,l;return i=Sr,l=Sr,"algorithm"===n.substr(Sr,9).toLowerCase()?(e=n.substr(Sr,9),Sr+=9):(e=null,0===Cr&&s('"algorithm"')),null!==e?(t=U(),null!==t?("md5"===n.substr(Sr,3).toLowerCase()?(r=n.substr(Sr,3),Sr+=3):(r=null,0===Cr&&s('"MD5"')),null===r&&("md5-sess"===n.substr(Sr,8).toLowerCase()?(r=n.substr(Sr,8),Sr+=8):(r=null,0===Cr&&s('"MD5-sess"')),null===r&&(r=I())),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.algorithm=t.toUpperCase()}(0,e[2])),null===e&&(Sr=i),e}function vn(){var e,t,r,i,l,o,u,a,c,h;if(a=Sr,"qop"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"qop"')),null!==e)if(null!==(t=U()))if(null!==(r=G())){if(c=Sr,null!==(i=_n())){for(l=[],h=Sr,44===n.charCodeAt(Sr)?(o=",",Sr++):(o=null,0===Cr&&s('","')),null!==o?(u=_n(),null!==u?o=[o,u]:(o=null,Sr=h)):(o=null,Sr=h);null!==o;)l.push(o),h=Sr,44===n.charCodeAt(Sr)?(o=",",Sr++):(o=null,0===Cr&&s('","')),null!==o?(u=_n(),null!==u?o=[o,u]:(o=null,Sr=h)):(o=null,Sr=h);null!==l?i=[i,l]:(i=null,Sr=c)}else i=null,Sr=c;null!==i?(l=j(),null!==l?e=[e,t,r,i,l]:(e=null,Sr=a)):(e=null,Sr=a)}else e=null,Sr=a;else e=null,Sr=a;else e=null,Sr=a;return e}function _n(){var e,t;return t=Sr,"auth-int"===n.substr(Sr,8).toLowerCase()?(e=n.substr(Sr,8),Sr+=8):(e=null,0===Cr&&s('"auth-int"')),null===e&&("auth"===n.substr(Sr,4).toLowerCase()?(e=n.substr(Sr,4),Sr+=4):(e=null,0===Cr&&s('"auth"')),null===e&&(e=I())),null!==e&&(e=function(e,t){br.qop||(br.qop=[]),br.qop.push(t.toLowerCase())}(0,e)),null===e&&(Sr=t),e}function Sn(){var e,t,n,r,s,i;if(s=Sr,null!==(e=Cn())){for(t=[],i=Sr,n=L(),null!==n?(r=Cn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=L(),null!==n?(r=Cn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function Cn(){var e,t;return t=Sr,e=I(),null!==e&&(e=function(e,t){br.tag=t}(0,e)),null===e&&(Sr=t),e}function En(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,null!==(e=An())){for(t=[],l=Sr,n=L(),null!==n?(r=An(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=L(),null!==n?(r=An(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){var t,n;for(n=br.multi_header.length,t=0;t<n;t++)if(null===br.multi_header[t].parsed){br=null;break}br=null!==br?br.multi_header:-1}()),null===e&&(Sr=s),e}function An(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,null!==(e=_t())){for(t=[],l=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){var t;br.multi_header||(br.multi_header=[]);try{t=new Rr(br.uri,br.display_name,br.params),delete br.uri,delete br.display_name,delete br.params}catch(e){t=null}br.multi_header.push({possition:Sr,offset:e,parsed:t})}(s)),null===e&&(Sr=s),e}function yn(){var e,t,r,i,l,o,u;if(l=Sr,o=Sr,"sip"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"SIP"')),null===e&&(e=I()),null!==e){for(t=[],u=Sr,r=H(),null!==r?(i=Rn(),null!==i?r=[r,i]:(r=null,Sr=u)):(r=null,Sr=u);null!==r;)t.push(r),u=Sr,r=H(),null!==r?(i=Rn(),null!==i?r=[r,i]:(r=null,Sr=u)):(r=null,Sr=u);null!==t?e=[e,t]:(e=null,Sr=o)}else e=null,Sr=o;return null!==e&&(e=function(e,t){if(br.protocol=t.toLowerCase(),br.params||(br.params={}),br.params.text&&'"'===br.params.text[0]){var n=br.params.text;br.text=n.substring(1,n.length-1),delete br.params.text}}(0,e[0])),null===e&&(Sr=l),e}function Rn(){var e;return e=bn(),null===e&&(e=bt()),e}function bn(){var e,t,r,i,o,u;if(o=Sr,u=Sr,"cause"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"cause"')),null!==e)if(null!==(t=U())){if(null!==(i=l()))for(r=[];null!==i;)r.push(i),i=l();else r=null;null!==r?e=[e,t,r]:(e=null,Sr=u)}else e=null,Sr=u;else e=null,Sr=u;return null!==e&&(e=function(e,t){br.cause=parseInt(t.join(""))}(0,e[2])),null===e&&(Sr=o),e}function In(){var e,t,n,r,s,i,l,o;if(s=Sr,i=Sr,l=Sr,e=Cn(),null!==e&&(e=function(e){return br.tag}()),null===e&&(Sr=l),null!==e){for(t=[],l=Sr,o=Sr,n=L(),null!==n?(r=Cn(),null!==r?n=[n,r]:(n=null,Sr=o)):(n=null,Sr=o),null!==n&&(n=function(e,t){return br.tag}(0,n[1])),null===n&&(Sr=l);null!==n;)t.push(n),l=Sr,o=Sr,n=L(),null!==n?(r=Cn(),null!==r?n=[n,r]:(n=null,Sr=o)):(n=null,Sr=o),null!==n&&(n=function(e,t){return br.tag}(0,n[1])),null===n&&(Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e,t,n){br.tags=[t].concat(n),delete br.tag}(0,e[0],e[1])),null===e&&(Sr=s),e}function wn(){var e,t,n,r,s,i;if(s=Sr,null!==(e=Nn())){for(t=[],i=Sr,n=L(),null!==n?(r=Nn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=L(),null!==n?(r=Nn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function Nn(){var e,t,n,r,s,i;if(s=Sr,null!==(e=_t())){for(t=[],i=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function Dn(){var e,t,n,r,s,i;if(s=Sr,null!==(e=On())){for(t=[],i=Sr,n=H(),null!==n?(r=xn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=H(),null!==n?(r=xn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function On(){var e,t;return t=Sr,"active"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"active"')),null===e&&("pending"===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"pending"')),null===e&&("terminated"===n.substr(Sr,10).toLowerCase()?(e=n.substr(Sr,10),Sr+=10):(e=null,0===Cr&&s('"terminated"')),null===e&&(e=I()))),null!==e&&(e=function(e){br.state=n.substring(Sr,e)}(t)),null===e&&(Sr=t),e}function xn(){var e,t,r,i,l;return i=Sr,l=Sr,"reason"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"reason"')),null!==e?(t=U(),null!==t?(r=Un(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){void 0!==t&&(br.reason=t)}(0,e[2])),null===e&&(Sr=i),null===e&&(i=Sr,l=Sr,"expires"===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"expires"')),null!==e?(t=U(),null!==t?(r=yt(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){void 0!==t&&(br.expires=t)}(0,e[2])),null===e&&(Sr=i),null===e&&(i=Sr,l=Sr,"retry_after"===n.substr(Sr,11).toLowerCase()?(e=n.substr(Sr,11),Sr+=11):(e=null,0===Cr&&s('"retry_after"')),null!==e?(t=U(),null!==t?(r=yt(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){void 0!==t&&(br.retry_after=t)}(0,e[2])),null===e&&(Sr=i),null===e&&(e=bt()))),e}function Un(){var e;return"deactivated"===n.substr(Sr,11).toLowerCase()?(e=n.substr(Sr,11),Sr+=11):(e=null,0===Cr&&s('"deactivated"')),null===e&&("probation"===n.substr(Sr,9).toLowerCase()?(e=n.substr(Sr,9),Sr+=9):(e=null,0===Cr&&s('"probation"')),null===e&&("rejected"===n.substr(Sr,8).toLowerCase()?(e=n.substr(Sr,8),Sr+=8):(e=null,0===Cr&&s('"rejected"')),null===e&&("timeout"===n.substr(Sr,7).toLowerCase()?(e=n.substr(Sr,7),Sr+=7):(e=null,0===Cr&&s('"timeout"')),null===e&&("giveup"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"giveup"')),null===e&&("noresource"===n.substr(Sr,10).toLowerCase()?(e=n.substr(Sr,10),Sr+=10):(e=null,0===Cr&&s('"noresource"')),null===e&&("invariant"===n.substr(Sr,9).toLowerCase()?(e=n.substr(Sr,9),Sr+=9):(e=null,0===Cr&&s('"invariant"')),null===e&&(e=I()))))))),e}function Pn(){var e;return e=E(),e=null!==e?e:""}function Mn(){var e,t,n,r,s,i,l,o;if(s=Sr,i=Sr,l=Sr,e=Cn(),null!==e&&(e=function(e){return br.tag}()),null===e&&(Sr=l),null!==e){for(t=[],l=Sr,o=Sr,n=L(),null!==n?(r=Cn(),null!==r?n=[n,r]:(n=null,Sr=o)):(n=null,Sr=o),null!==n&&(n=function(e,t){return br.tag}(0,n[1])),null===n&&(Sr=l);null!==n;)t.push(n),l=Sr,o=Sr,n=L(),null!==n?(r=Cn(),null!==r?n=[n,r]:(n=null,Sr=o)):(n=null,Sr=o),null!==n&&(n=function(e,t){return br.tag}(0,n[1])),null===n&&(Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e,t,n){br.tags=[t].concat(n),delete br.tag}(0,e[0],e[1])),null===e&&(Sr=s),e=null!==e?e:""}function qn(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,e=Y(),null===e&&(e=_t()),null!==e){for(t=[],l=Sr,n=H(),null!==n?(r=kn(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=H(),null!==n?(r=kn(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){var t=br.tag;try{br=new Rr(br.uri,br.display_name,br.params),t&&br.setParam("tag",t)}catch(e){br=-1}}()),null===e&&(Sr=s),e}function kn(){var e;return e=Zt(),null===e&&(e=bt()),e}function Ln(){var e,t,n,r,s,i;if(s=Sr,null!==(e=Hn())){for(t=[],i=Sr,n=L(),null!==n?(r=Hn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=L(),null!==n?(r=Hn(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function Hn(){var e,t,n,r,s,i,l,o;if(l=Sr,null!==(e=zn()))if(null!==(t=_()))if(null!==(n=Yn())){for(r=[],o=Sr,s=H(),null!==s?(i=Fn(),null!==i?s=[s,i]:(s=null,Sr=o)):(s=null,Sr=o);null!==s;)r.push(s),o=Sr,s=H(),null!==s?(i=Fn(),null!==i?s=[s,i]:(s=null,Sr=o)):(s=null,Sr=o);null!==r?e=[e,t,n,r]:(e=null,Sr=l)}else e=null,Sr=l;else e=null,Sr=l;else e=null,Sr=l;return e}function Fn(){var e;return e=Gn(),null===e&&null===(e=jn())&&null===(e=Wn())&&null===(e=Bn())&&null===(e=Vn())&&(e=bt()),e}function Gn(){var e,t,r,i,l;return i=Sr,l=Sr,"ttl"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"ttl"')),null!==e?(t=U(),null!==t?(r=Qn(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.ttl=t}(0,e[2])),null===e&&(Sr=i),e}function jn(){var e,t,r,i,l;return i=Sr,l=Sr,"maddr"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"maddr"')),null!==e?(t=U(),null!==t?(r=ie(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.maddr=t}(0,e[2])),null===e&&(Sr=i),e}function Wn(){var e,t,r,i,l;return i=Sr,l=Sr,"received"===n.substr(Sr,8).toLowerCase()?(e=n.substr(Sr,8),Sr+=8):(e=null,0===Cr&&s('"received"')),null!==e?(t=U(),null!==t?(r=pe(),null===r&&(r=ce()),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.received=t}(0,e[2])),null===e&&(Sr=i),e}function Bn(){var e,t,r,i,l;return i=Sr,l=Sr,"branch"===n.substr(Sr,6).toLowerCase()?(e=n.substr(Sr,6),Sr+=6):(e=null,0===Cr&&s('"branch"')),null!==e?(t=U(),null!==t?(r=I(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.branch=t}(0,e[2])),null===e&&(Sr=i),e}function Vn(){var e,t,r,i,o,u,a;if(o=Sr,u=Sr,"rport"===n.substr(Sr,5).toLowerCase()?(e=n.substr(Sr,5),Sr+=5):(e=null,0===Cr&&s('"rport"')),null!==e){if(a=Sr,null!==(t=U())){for(r=[],i=l();null!==i;)r.push(i),i=l();null!==r?t=[t,r]:(t=null,Sr=a)}else t=null,Sr=a;t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=u)}else e=null,Sr=u;return null!==e&&(e=function(e){"undefined"!=typeof response_port&&(br.rport=response_port.join(""))}()),null===e&&(Sr=o),e}function zn(){var e,t,n,r,s,i;return i=Sr,e=Kn(),null!==e?(t=x(),null!==t?(n=I(),null!==n?(r=x(),null!==r?(s=Jn(),null!==s?e=[e,t,n,r,s]:(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i)):(e=null,Sr=i),e}function Kn(){var e,t;return t=Sr,"sip"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"SIP"')),null===e&&(e=I()),null!==e&&(e=function(e,t){br.protocol=t}(0,e)),null===e&&(Sr=t),e}function Jn(){var e,t;return t=Sr,"udp"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"UDP"')),null===e&&("tcp"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"TCP"')),null===e&&("tls"===n.substr(Sr,3).toLowerCase()?(e=n.substr(Sr,3),Sr+=3):(e=null,0===Cr&&s('"TLS"')),null===e&&("sctp"===n.substr(Sr,4).toLowerCase()?(e=n.substr(Sr,4),Sr+=4):(e=null,0===Cr&&s('"SCTP"')),null===e&&(e=I())))),null!==e&&(e=function(e,t){br.transport=t}(0,e)),null===e&&(Sr=t),e}function Yn(){var e,t,n,r,s;return r=Sr,e=$n(),null!==e?(s=Sr,t=F(),null!==t?(n=Xn(),null!==n?t=[t,n]:(t=null,Sr=s)):(t=null,Sr=s),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),e}function $n(){var e,t;return t=Sr,e=pe(),null===e&&null===(e=ae())&&(e=le()),null!==e&&(e=function(e){br.host=n.substring(Sr,e)}(t)),null===e&&(Sr=t),e}function Xn(){var e,t,n,r,s,i,o;return i=Sr,o=Sr,e=l(),e=null!==e?e:"",null!==e?(t=l(),t=null!==t?t:"",null!==t?(n=l(),n=null!==n?n:"",null!==n?(r=l(),r=null!==r?r:"",null!==r?(s=l(),s=null!==s?s:"",null!==s?e=[e,t,n,r,s]:(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o)):(e=null,Sr=o),null!==e&&(e=function(e,t){br.port=parseInt(t.join(""))}(0,e)),null===e&&(Sr=i),e}function Qn(){var e,t,n,r,s;return r=Sr,s=Sr,e=l(),null!==e?(t=l(),t=null!==t?t:"",null!==t?(n=l(),n=null!==n?n:"",null!==n?e=[e,t,n]:(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s),null!==e&&(e=function(e,t){return parseInt(t.join(""))}(0,e)),null===e&&(Sr=r),e}function Zn(){return sn()}function er(){var e,t,n,r,s,i;if(s=Sr,null!==(e=tr())){for(t=[],i=Sr,n=H(),null!==n?(r=nr(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=H(),null!==n?(r=nr(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function tr(){var e,t;return t=Sr,e=yt(),null!==e&&(e=function(e,t){br.expires=t}(0,e)),null===e&&(Sr=t),e}function nr(){var e;return e=rr(),null===e&&(e=bt()),e}function rr(){var e,t,r,i,l;return i=Sr,l=Sr,"refresher"===n.substr(Sr,9).toLowerCase()?(e=n.substr(Sr,9),Sr+=9):(e=null,0===Cr&&s('"refresher"')),null!==e?(t=U(),null!==t?("uac"===n.substr(Sr,3).toLowerCase()?(r=n.substr(Sr,3),Sr+=3):(r=null,0===Cr&&s('"uac"')),null===r&&("uas"===n.substr(Sr,3).toLowerCase()?(r=n.substr(Sr,3),Sr+=3):(r=null,0===Cr&&s('"uas"'))),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.refresher=t.toLowerCase()}(0,e[2])),null===e&&(Sr=i),e}function sr(){var e,t,n,r;return r=Sr,e=I(),null!==e?(t=C(),null!==t?(n=ir(),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)):(e=null,Sr=r),e}function ir(){var e,t;for(e=[],t=A(),null===t&&null===(t=R())&&(t=_());null!==t;)e.push(t),null===(t=A())&&null===(t=R())&&(t=_());return e}function lr(){var e,t;for(e=[],t=c();null!==t;)e.push(t),t=c();return e}function or(){var e,t,r;return r=Sr,"uuid:"===n.substr(Sr,5)?(e="uuid:",Sr+=5):(e=null,0===Cr&&s('"uuid:"')),null!==e?(t=ur(),null!==t?e=[e,t]:(e=null,Sr=r)):(e=null,Sr=r),e}function ur(){var e,t,r,i,l,o,u,a,c,h,d;return h=Sr,d=Sr,e=cr(),null!==e?(45===n.charCodeAt(Sr)?(t="-",Sr++):(t=null,0===Cr&&s('"-"')),null!==t?(r=ar(),null!==r?(45===n.charCodeAt(Sr)?(i="-",Sr++):(i=null,0===Cr&&s('"-"')),null!==i?(l=ar(),null!==l?(45===n.charCodeAt(Sr)?(o="-",Sr++):(o=null,0===Cr&&s('"-"')),null!==o?(u=ar(),null!==u?(45===n.charCodeAt(Sr)?(a="-",Sr++):(a=null,0===Cr&&s('"-"')),null!==a?(c=hr(),null!==c?e=[e,t,r,i,l,o,u,a,c]:(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d)):(e=null,Sr=d),null!==e&&(e=function(e,t){br=n.substring(Sr+5,e)}(h,e[0])),null===e&&(Sr=h),e}function ar(){var e,t,n,r,s;return s=Sr,e=u(),null!==e?(t=u(),null!==t?(n=u(),null!==n?(r=u(),null!==r?e=[e,t,n,r]:(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s)):(e=null,Sr=s),e}function cr(){var e,t,n;return n=Sr,e=ar(),null!==e?(t=ar(),null!==t?e=[e,t]:(e=null,Sr=n)):(e=null,Sr=n),e}function hr(){var e,t,n,r;return r=Sr,e=ar(),null!==e?(t=ar(),null!==t?(n=ar(),null!==n?e=[e,t,n]:(e=null,Sr=r)):(e=null,Sr=r)):(e=null,Sr=r),e}function dr(){var e,t,n,r,s,i,l;if(s=Sr,i=Sr,e=Y(),null===e&&(e=_t()),null!==e){for(t=[],l=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==n;)t.push(n),l=Sr,n=H(),null!==n?(r=bt(),null!==r?n=[n,r]:(n=null,Sr=l)):(n=null,Sr=l);null!==t?e=[e,t]:(e=null,Sr=i)}else e=null,Sr=i;return null!==e&&(e=function(e){try{br=new Rr(br.uri,br.display_name,br.params)}catch(e){br=-1}}()),null===e&&(Sr=s),e}function pr(){var e,t,n,r,s,i;if(s=Sr,null!==(e=fr())){for(t=[],i=Sr,n=H(),null!==n?(r=mr(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==n;)t.push(n),i=Sr,n=H(),null!==n?(r=mr(),null!==r?n=[n,r]:(n=null,Sr=i)):(n=null,Sr=i);null!==t?e=[e,t]:(e=null,Sr=s)}else e=null,Sr=s;return e}function fr(){var e,t,r,i,l,o;return i=Sr,l=Sr,e=D(),null!==e?(o=Sr,64===n.charCodeAt(Sr)?(t="@",Sr++):(t=null,0===Cr&&s('"@"')),null!==t?(r=D(),null!==r?t=[t,r]:(t=null,Sr=o)):(t=null,Sr=o),t=null!==t?t:"",null!==t?e=[e,t]:(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e){br.call_id=n.substring(Sr,e)}(i)),null===e&&(Sr=i),e}function mr(){var e;return e=gr(),null===e&&null===(e=Tr())&&null===(e=vr())&&(e=bt()),e}function gr(){var e,t,r,i,l;return i=Sr,l=Sr,"to-tag"===n.substr(Sr,6)?(e="to-tag",Sr+=6):(e=null,0===Cr&&s('"to-tag"')),null!==e?(t=U(),null!==t?(r=I(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.to_tag=t}(0,e[2])),null===e&&(Sr=i),e}function Tr(){var e,t,r,i,l;return i=Sr,l=Sr,"from-tag"===n.substr(Sr,8)?(e="from-tag",Sr+=8):(e=null,0===Cr&&s('"from-tag"')),null!==e?(t=U(),null!==t?(r=I(),null!==r?e=[e,t,r]:(e=null,Sr=l)):(e=null,Sr=l)):(e=null,Sr=l),null!==e&&(e=function(e,t){br.from_tag=t}(0,e[2])),null===e&&(Sr=i),e}function vr(){var e,t;return t=Sr,"early-only"===n.substr(Sr,10)?(e="early-only",Sr+=10):(e=null,0===Cr&&s('"early-only"')),null!==e&&(e=function(e){br.early_only=!0}()),null===e&&(Sr=t),e}var _r={CRLF:i,DIGIT:l,ALPHA:o,HEXDIG:u,WSP:a,OCTET:c,DQUOTE:h,SP:d,HTAB:p,alphanum:f,reserved:m,unreserved:g,mark:T,escaped:v,LWS:_,SWS:S,HCOLON:C,TEXT_UTF8_TRIM:E,TEXT_UTF8char:A,UTF8_NONASCII:y,UTF8_CONT:R,LHEX:b,
token:I,token_nodot:w,separators:N,word:D,STAR:O,SLASH:x,EQUAL:U,LPAREN:P,RPAREN:M,RAQUOT:q,LAQUOT:k,COMMA:L,SEMI:H,COLON:F,LDQUOT:G,RDQUOT:j,comment:W,ctext:B,quoted_string:V,quoted_string_clean:z,qdtext:K,quoted_pair:J,SIP_URI_noparams:Y,SIP_URI:$,uri_scheme:X,uri_scheme_sips:Q,uri_scheme_sip:Z,userinfo:ee,user:te,user_unreserved:ne,password:re,hostport:se,host:ie,hostname:le,domainlabel:oe,toplabel:ue,IPv6reference:ae,IPv6address:ce,h16:he,ls32:de,IPv4address:pe,dec_octet:fe,port:me,uri_parameters:ge,uri_parameter:Te,transport_param:ve,user_param:_e,method_param:Se,ttl_param:Ce,maddr_param:Ee,lr_param:Ae,other_param:ye,pname:Re,pvalue:be,paramchar:Ie,param_unreserved:we,headers:Ne,header:De,hname:Oe,hvalue:xe,hnv_unreserved:Ue,Request_Response:Pe,Request_Line:Me,Request_URI:qe,absoluteURI:ke,hier_part:Le,net_path:He,abs_path:Fe,opaque_part:Ge,uric:je,uric_no_slash:We,path_segments:Be,segment:Ve,param:ze,pchar:Ke,scheme:Je,authority:Ye,srvr:$e,reg_name:Xe,query:Qe,SIP_Version:Ze,INVITEm:et,ACKm:tt,PRACKm:nt,OPTIONSm:rt,BYEm:st,CANCELm:it,REGISTERm:lt,SUBSCRIBEm:ot,NOTIFYm:ut,REFERm:at,Method:ct,Status_Line:ht,Status_Code:dt,extension_code:pt,Reason_Phrase:ft,Allow_Events:mt,Call_ID:gt,Contact:Tt,contact_param:vt,name_addr:_t,display_name:St,contact_params:Ct,c_p_q:Et,c_p_expires:At,delta_seconds:yt,qvalue:Rt,generic_param:bt,gen_value:It,Content_Disposition:wt,disp_type:Nt,disp_param:Dt,handling_param:Ot,Content_Encoding:xt,Content_Length:Ut,Content_Type:Pt,media_type:Mt,m_type:qt,discrete_type:kt,composite_type:Lt,extension_token:Ht,x_token:Ft,m_subtype:Gt,m_parameter:jt,m_value:Wt,CSeq:Bt,CSeq_value:Vt,RSeq:zt,RAck:Kt,Expires:Jt,Event:Yt,event_type:$t,From:Xt,from_param:Qt,tag_param:Zt,Max_Forwards:en,Min_Expires:tn,Name_Addr_Header:nn,Proxy_Authenticate:rn,challenge:sn,other_challenge:ln,auth_param:on,digest_cln:un,realm:an,realm_value:cn,domain:hn,URI:dn,nonce:pn,nonce_value:fn,opaque:mn,stale:gn,algorithm:Tn,qop_options:vn,qop_value:_n,Proxy_Require:Sn,option_tag:Cn,Record_Route:En,rec_route:An,Reason:yn,reason_param:Rn,reason_cause:bn,Require:In,Route:wn,route_param:Nn,Subscription_State:Dn,substate_value:On,subexp_params:xn,event_reason_value:Un,Subject:Pn,Supported:Mn,To:qn,to_param:kn,Via:Ln,via_param:Hn,via_params:Fn,via_ttl:Gn,via_maddr:jn,via_received:Wn,via_branch:Bn,response_port:Vn,sent_protocol:zn,protocol_name:Kn,transport:Jn,sent_by:Yn,via_host:$n,via_port:Xn,ttl:Qn,WWW_Authenticate:Zn,Session_Expires:er,s_e_expires:tr,s_e_params:nr,s_e_refresher:rr,extension_header:sr,header_value:ir,message_body:lr,uuid_URI:or,uuid:ur,hex4:ar,hex8:cr,hex12:hr,Refer_To:dr,Replaces:pr,call_id:fr,replaces_param:mr,to_tag:gr,from_tag:Tr,early_flag:vr};if(void 0!==r){if(void 0===_r[r])throw new Error("Invalid rule name: "+t(r)+".")}else r="CRLF";var Sr=0,Cr=0,Er=0,Ar=[],yr=e("./URI"),Rr=e("./NameAddrHeader"),br={};if(null===_r[r]()||Sr!==n.length){var Ir=Math.max(Sr,Er),wr=Ir<n.length?n.charAt(Ir):null,Nr=function(){for(var e=1,t=1,r=!1,s=0;s<Math.max(Sr,Er);s++){var i=n.charAt(s);"\n"===i?(r||e++,t=1,r=!1):"\r"===i||"\u2028"===i||"\u2029"===i?(e++,t=1,r=!0):(t++,r=!1)}return{line:e,column:t}}();return new this.SyntaxError(function(e){e.sort();for(var t=null,n=[],r=0;r<e.length;r++)e[r]!==t&&(n.push(e[r]),t=e[r]);return n}(Ar),wr,Ir,Nr.line,Nr.column),-1}return br},toSource:function(){return this._source}};return n.SyntaxError=function(e,n,r,s,i){this.name="SyntaxError",this.expected=e,this.found=n,this.message=function(e,n){var r,s;switch(e.length){case 0:r="end of input";break;case 1:r=e[0];break;default:r=e.slice(0,e.length-1).join(", ")+" or "+e[e.length-1]}return s=n?t(n):"end of input","Expected "+r+" but "+s+" found."}(e,n),this.offset=r,this.line=s,this.column=i},n.SyntaxError.prototype=Error.prototype,n}()},{"./NameAddrHeader":9,"./URI":24}],7:[function(e,t,n){var r=e("debug")("JsSIP"),s=e("../package.json");r("version %s",s.version);var i=e("rtcninja");i({useIsacoPlugin:!0});var l=e("./Constants"),o=e("./Exceptions"),u=e("./Utils"),a=e("./UA"),c=e("./URI"),h=e("./NameAddrHeader"),d=e("./Grammar"),p=e("./WebSocketInterface"),f=t.exports={C:l,Exceptions:o,Utils:u,UA:a,URI:c,NameAddrHeader:h,WebSocketInterface:p,Grammar:d,debug:e("debug"),rtcninja:i};Object.defineProperties(f,{name:{get:function(){return s.title}},version:{get:function(){return s.version}}})},{"../package.json":47,"./Constants":1,"./Exceptions":5,"./Grammar":6,"./NameAddrHeader":9,"./UA":23,"./URI":24,"./Utils":25,"./WebSocketInterface":26,debug:29,rtcninja:38}],8:[function(e,t,n){function r(e){this.ua=e,this.data={},i.EventEmitter.call(this)}t.exports=r;var s=e("util"),i=e("events"),l=e("./Constants"),o=e("./SIPMessage"),u=e("./Utils"),a=e("./RequestSender"),c=e("./Transactions"),h=e("./Exceptions");s.inherits(r,i.EventEmitter),r.prototype.send=function(e,t,n){var r,s,i,u,c,h=e;if(void 0===e||void 0===t)throw new TypeError("Not enough arguments");if(!(e=this.ua.normalizeTarget(e)))throw new TypeError("Invalid target: "+h);n=n||{},c=n.extraHeaders&&n.extraHeaders.slice()||[],u=n.eventHandlers||{},i=n.contentType||"text/plain",this.content_type=i;for(s in u)this.on(s,u[s]);this.closed=!1,this.ua.applicants[this]=this,c.push("Content-Type: "+i),this.request=new o.OutgoingRequest(l.MESSAGE,e,this.ua,null,c),t?(this.request.body=t,this.content=t):this.content=null,r=new a(this,this.ua),this.newMessage("local",this.request),r.send()},r.prototype.receiveResponse=function(e){var t;if(!this.closed)switch(!0){case/^1[0-9]{2}$/.test(e.status_code):break;case/^2[0-9]{2}$/.test(e.status_code):delete this.ua.applicants[this],this.emit("succeeded",{originator:"remote",response:e});break;default:delete this.ua.applicants[this],t=u.sipErrorCause(e.status_code),this.emit("failed",{originator:"remote",response:e,cause:t})}},r.prototype.onRequestTimeout=function(){this.closed||this.emit("failed",{originator:"system",cause:l.causes.REQUEST_TIMEOUT})},r.prototype.onTransportError=function(){this.closed||this.emit("failed",{originator:"system",cause:l.causes.CONNECTION_ERROR})},r.prototype.close=function(){this.closed=!0,delete this.ua.applicants[this]},r.prototype.init_incoming=function(e){var t;this.request=e,this.content_type=e.getHeader("Content-Type"),e.body?this.content=e.body:this.content=null,this.newMessage("remote",e),!(t=this.ua.transactions.nist[e.via_branch])||t.state!==c.C.STATUS_TRYING&&t.state!==c.C.STATUS_PROCEEDING||e.reply(200)},r.prototype.accept=function(e){e=e||{};var t=e.extraHeaders&&e.extraHeaders.slice()||[],n=e.body;if("incoming"!==this.direction)throw new h.NotSupportedError('"accept" not supported for outgoing Message');this.request.reply(200,null,t,n)},r.prototype.reject=function(e){e=e||{};var t=e.status_code||480,n=e.reason_phrase,r=e.extraHeaders&&e.extraHeaders.slice()||[],s=e.body;if("incoming"!==this.direction)throw new h.NotSupportedError('"reject" not supported for outgoing Message');if(t<300||t>=700)throw new TypeError("Invalid status_code: "+t);this.request.reply(t,n,r,s)},r.prototype.newMessage=function(e,t){"remote"===e?(this.direction="incoming",this.local_identity=t.to,this.remote_identity=t.from):"local"===e&&(this.direction="outgoing",this.local_identity=t.from,this.remote_identity=t.to),this.ua.newMessage({originator:e,message:this,request:t})}},{"./Constants":1,"./Exceptions":5,"./RequestSender":17,"./SIPMessage":18,"./Transactions":21,"./Utils":25,events:31,util:46}],9:[function(e,t,n){function r(e,t,n){var r;if(!(e&&e instanceof s))throw new TypeError('missing or invalid "uri" parameter');this.uri=e,this.parameters={};for(r in n)this.setParam(r,n[r]);Object.defineProperties(this,{display_name:{get:function(){return t},set:function(e){t=0===e?"0":e}}})}t.exports=r;var s=e("./URI"),i=e("./Grammar");r.prototype={setParam:function(e,t){e&&(this.parameters[e.toLowerCase()]=void 0===t||null===t?null:t.toString())},getParam:function(e){if(e)return this.parameters[e.toLowerCase()]},hasParam:function(e){if(e)return this.parameters.hasOwnProperty(e.toLowerCase())&&!0||!1},deleteParam:function(e){var t;if(e=e.toLowerCase(),this.parameters.hasOwnProperty(e))return t=this.parameters[e],delete this.parameters[e],t},clearParams:function(){this.parameters={}},clone:function(){return new r(this.uri.clone(),this.display_name,JSON.parse(JSON.stringify(this.parameters)))},toString:function(){var e,t;e=this.display_name||0===this.display_name?'"'+this.display_name+'" ':"",e+="<"+this.uri.toString()+">";for(t in this.parameters)e+=";"+t,null!==this.parameters[t]&&(e+="="+this.parameters[t]);return e}},r.parse=function(e){return e=i.parse(e,"Name_Addr_Header"),-1!==e?e:void 0}},{"./Grammar":6,"./URI":24}],10:[function(e,t,n){function r(e,t){var n=t,r=0,s=0;if(e.substring(n,n+2).match(/(^\r\n)/))return-2;for(;0===r;){if(-1===(s=e.indexOf("\r\n",n)))return s;!e.substring(s+2,s+4).match(/(^\r\n)/)&&e.charAt(s+2).match(/(^\s+)/)?n=s+2:r=s}return r}function s(e,t,n,r){var s,i,l,a,c=t.indexOf(":",n),h=t.substring(n,c).trim(),d=t.substring(c+1,r).trim();switch(h.toLowerCase()){case"via":case"v":e.addHeader("via",d),1===e.getHeaders("via").length?(a=e.parseHeader("Via"))&&(e.via=a,e.via_branch=a.branch):a=0;break;case"from":case"f":e.setHeader("from",d),a=e.parseHeader("from"),a&&(e.from=a,e.from_tag=a.getParam("tag"));break;case"to":case"t":e.setHeader("to",d),a=e.parseHeader("to"),a&&(e.to=a,e.to_tag=a.getParam("tag"));break;case"record-route":for(a=o.parse(d,"Record_Route"),-1===a&&(a=void 0),l=a.length,i=0;i<l;i++)s=a[i],e.addHeader("record-route",d.substring(s.possition,s.offset)),e.headers["Record-Route"][e.getHeaders("record-route").length-1].parsed=s.parsed;break;case"call-id":case"i":e.setHeader("call-id",d),a=e.parseHeader("call-id"),a&&(e.call_id=d);break;case"contact":case"m":for(a=o.parse(d,"Contact"),-1===a&&(a=void 0),l=a.length,i=0;i<l;i++)s=a[i],e.addHeader("contact",d.substring(s.possition,s.offset)),e.headers.Contact[e.getHeaders("contact").length-1].parsed=s.parsed;break;case"content-length":case"l":e.setHeader("content-length",d),a=e.parseHeader("content-length");break;case"content-type":case"c":e.setHeader("content-type",d),a=e.parseHeader("content-type");break;case"cseq":e.setHeader("cseq",d),a=e.parseHeader("cseq"),a&&(e.cseq=a.value),e instanceof u.IncomingResponse&&(e.method=a.method);break;case"rseq":e.setHeader("rseq",d),a=e.parseHeader("rseq"),a&&(e.rseq=a.rvalue);break;case"rack":e.setHeader("rack",d),a=e.parseHeader("rack"),a&&(e.rack=a);break;case"max-forwards":e.setHeader("max-forwards",d),a=e.parseHeader("max-forwards");break;case"www-authenticate":e.setHeader("www-authenticate",d),a=e.parseHeader("www-authenticate");break;case"proxy-authenticate":e.setHeader("proxy-authenticate",d),a=e.parseHeader("proxy-authenticate");break;case"session-expires":case"x":e.setHeader("session-expires",d),a=e.parseHeader("session-expires"),a&&(e.session_expires=a.expires,e.session_expires_refresher=a.refresher);break;case"refer-to":case"r":e.setHeader("refer-to",d),a=e.parseHeader("refer-to"),a&&(e.refer_to=a);break;case"replaces":e.setHeader("replaces",d),a=e.parseHeader("replaces"),a&&(e.replaces=a);break;case"event":case"o":e.setHeader("event",d),a=e.parseHeader("event"),a&&(e.event=a);break;case"supported":e.setHeader("supported",d),a=e.parseHeader("supported"),a&&(e.supported=(e.supported||[]).concat(a.tags));break;case"require":e.setHeader("require",d),a=e.parseHeader("require"),a&&(e.require=(e.require||[]).concat(a.tags));break;default:e.setHeader(h,d),a=0}return void 0!==a||{error:'error parsing header "'+h+'"'}}var i={};t.exports=i;var l=e("debug")("JsSIP:ERROR:Parser");l.log=console.warn.bind(console);var o=e("./Grammar"),u=e("./SIPMessage");i.parseMessage=function(e,t){var n,i,a,c,h,d=0,p=e.indexOf("\r\n");if(-1===p)return void l("parseMessage() | no CRLF found, not a SIP message");if(i=e.substring(0,p),-1===(h=o.parse(i,"Request_Response")))return void l('parseMessage() | error parsing first line of SIP message: "'+i+'"');for(h.status_code?(n=new u.IncomingResponse,n.status_code=h.status_code,n.reason_phrase=h.reason_phrase):(n=new u.IncomingRequest(t),n.method=h.method,n.ruri=h.uri),n.data=e,d=p+2;;){if(-2===(p=r(e,d))){c=d+2;break}if(-1===p)return void l("parseMessage() | malformed message");if(!0!==(h=s(n,e,d,p)))return void l("parseMessage() |",h.error);d=p+2}return n.hasHeader("content-length")?(a=n.getHeader("content-length"),n.body=e.substr(c,a)):n.body=e.substring(c),n}},{"./Grammar":6,"./SIPMessage":18,debug:29}],11:[function(e,t,n){function r(e){G("new"),this.ua=e,this.status=L.STATUS_NULL,this.dialog=null,this.earlyDialogs={},this.connection=null,this.is_confirmed=!1,this.late_sdp=!1,this.rtcOfferConstraints=null,this.rtcAnswerConstraints=null,this.localMediaStream=null,this.localMediaStreamLocallyGenerated=!1,this.rtcReady=!0,this.timers={ackTimer:null,expiresTimer:null,invite2xxTimer:null,userNoAnswerTimer:null},this.direction=null,this.local_identity=null,this.remote_identity=null,this.start_time=null,this.end_time=null,this.tones=null,this.audioMuted=!1,this.videoMuted=!1,this.localHold=!1,this.remoteHold=!1,this.sessionTimers={enabled:this.ua.configuration.session_timers,defaultExpires:V.SESSION_EXPIRES,currentExpires:null,running:!1,refresher:!1,timer:null},this.support100rel={enabled:this.ua.configuration.support_100rel},this.referSubscribers={},this.data={},F.EventEmitter.call(this)}function s(e,t){var n=this,r=Y.T1;this.timers.invite2xxTimer=setTimeout(function s(){n.status===L.STATUS_WAITING_FOR_ACK&&(e.reply(200,null,["Contact: "+n.contact],t),r<Y.T2&&(r*=2)>Y.T2&&(r=Y.T2),n.timers.invite2xxTimer=setTimeout(s,r))},r)}function i(){var e=this;this.timers.ackTimer=setTimeout(function(){e.status===L.STATUS_WAITING_FOR_ACK&&(G("no ACK received, terminating the session"),clearTimeout(e.timers.invite2xxTimer),_.call(e,V.BYE),x.call(e,"remote",null,V.causes.NO_ACK))},Y.TIMER_H)}function l(e,t){var n=this;this.connection=new W.RTCPeerConnection(e,t),this.connection.onaddstream=function(e,t){n.emit("addstream",{stream:t})},this.connection.onremovestream=function(e,t){n.emit("removestream",{stream:t})},this.connection.oniceconnectionstatechange=function(e,t){n.emit("iceconnectionstatechange",{state:t}),"failed"===t&&n.terminate({cause:V.causes.RTP_TIMEOUT,status_code:200,reason_phrase:V.causes.RTP_TIMEOUT})}}function o(e,t,n,r){function s(r){l.onicecandidate=function(n,r){if(!r){if(l.onicecandidate=null,i.rtcReady=!0,t){var s={originator:"local",type:e,sdp:l.localDescription.sdp};i.emit("sdp",s),t(s.sdp)}t=null}},l.setLocalDescription(r,function(){if("complete"===l.iceGatheringState){if(i.rtcReady=!0,t){var n={originator:"local",type:e,sdp:l.localDescription.sdp};i.emit("sdp",n),t(n.sdp)}t=null}},function(e){i.rtcReady=!0,n&&n(e)})}G("createLocalDescription()");var i=this,l=this.connection;if(this.rtcReady=!1,"offer"===e)l.createOffer(s,function(e){i.rtcReady=!0,n&&n(e)},r);else{if("answer"!==e)throw new Error('createLocalDescription() | type must be "offer" or "answer", but "'+e+'" was given');l.createAnswer(s,function(e){i.rtcReady=!0,n&&n(e)},r)}}function u(e,t,n){var r,s,i="UAS"===t?e.to_tag:e.from_tag,l="UAS"===t?e.from_tag:e.to_tag,o=e.call_id+i+l;return s=this.earlyDialogs[o],n?!!s||(s=new X(this,e,t,X.C.STATUS_EARLY),s.error?(G(s.error),U.call(this,"remote",e,V.causes.INTERNAL_ERROR),!1):(this.earlyDialogs[o]=s,!0)):(this.from_tag=e.from_tag,this.to_tag=e.to_tag,s?(s.update(e,t),this.dialog=s,delete this.earlyDialogs[o],!0):(r=new X(this,e,t),r.error?(G(r.error),U.call(this,"remote",e,V.causes.INTERNAL_ERROR),!1):(this.dialog=r,!0)))}function a(e){function t(t){t=t||{},f=!0;var n=t.status_code||403,r=t.reason_phrase||"",s=t.extraHeaders&&t.extraHeaders.slice()||[];if(this.status!==L.STATUS_CONFIRMED)return!1;if(n<300||n>=700)throw new TypeError("Invalid status_code: "+n);e.reply(n,r,s)}function n(){r(function(t){var n=["Contact: "+h.contact];E.call(h,e,n),h.late_sdp&&(t=S.call(h,t)),e.reply(200,null,n,t,function(){h.status=L.STATUS_WAITING_FOR_ACK,s.call(h,e,t),i.call(h)}),"function"==typeof m.callback&&m.callback()},function(){e.reply(500)})}function r(e,t){h.late_sdp?o.call(h,"offer",e,t,h.rtcOfferConstraints):(!0===h.remoteHold&&!1===p?(h.remoteHold=!1,M.call(h,"remote")):!1===h.remoteHold&&!0===p&&(h.remoteHold=!0,P.call(h,"remote")),o.call(h,"answer",e,t,h.rtcAnswerConstraints))}G("receiveReinvite()");var l,u,a,c,h=this,d=e.getHeader("Content-Type"),p=!1,f=!1,m={request:e,callback:void 0,reject:t.bind(this)};if(this.emit("reinvite",m),!f)if(e.body){if(this.late_sdp=!1,"application/sdp"!==d)return G("invalid Content-Type"),void e.reply(415);for(l=e.parseSDP(),u=0;u<l.media.length;u++)if(c=l.media[u],-1!==re.indexOf(c.type)){if("sendonly"!==(a=c.direction||l.direction||"sendrecv")&&"inactive"!==a){p=!1;break}p=!0}var g={originator:"remote",type:"offer",sdp:e.body};this.emit("sdp",g),this.connection.setRemoteDescription(new W.RTCSessionDescription({type:"offer",sdp:g.sdp}),n,function(){e.reply(488)})}else this.late_sdp=!0,n()}function c(e){function t(t){t=t||{},a=!0;var n=t.status_code||403,r=t.reason_phrase||"",s=t.extraHeaders&&t.extraHeaders.slice()||[];if(this.status!==L.STATUS_CONFIRMED)return!1;if(n<300||n>=700)throw new TypeError("Invalid status_code: "+n);e.reply(n,r,s)}G("receiveUpdate()");var n,r,s,i,l=this,u=e.getHeader("Content-Type"),a=!1,c=!1,h={request:e,callback:void 0,reject:t.bind(this)};if(this.emit("update",h),!a){if(!e.body){var d=[];return E.call(this,e,d),void e.reply(200,null,d)}if("application/sdp"!==u)return G("invalid Content-Type"),void e.reply(415);for(n=e.parseSDP(),r=0;r<n.media.length;r++)if(i=n.media[r],-1!==re.indexOf(i.type)){if("sendonly"!==(s=i.direction||n.direction||"sendrecv")&&"inactive"!==s){c=!1;break}c=!0}var p={originator:"remote",type:"offer",sdp:e.body};this.emit("sdp",p),this.connection.setRemoteDescription(new W.RTCSessionDescription({type:"offer",sdp:p.sdp}),function(){!0===l.remoteHold&&!1===c?(l.remoteHold=!1,M.call(l,"remote")):!1===l.remoteHold&&!0===c&&(l.remoteHold=!0,P.call(l,"remote")),o.call(l,"answer",function(t){var n=["Contact: "+l.contact];E.call(l,e,n),e.reply(200,null,n,t),"function"==typeof h.callback&&h.callback()},function(){e.reply(500)})},function(){e.reply(488)},this.rtcAnswerConstraints)}}function h(e){function t(t,n){var i,l;if(n=n||{},t="function"==typeof t?t:null,this.status!==L.STATUS_WAITING_FOR_ACK&&this.status!==L.STATUS_CONFIRMED)return!1;i=new r(this.ua),i.on("progress",function(e){s.notify(e.response.status_code,e.response.reason_phrase)}),i.on("accepted",function(e){s.notify(e.response.status_code,e.response.reason_phrase)}),i.on("failed",function(e){e.message?s.notify(e.message.status_code,e.message.reason_phrase):s.notify(487,e.cause)}),e.refer_to.uri.hasHeader("replaces")&&(l=decodeURIComponent(e.refer_to.uri.getHeader("replaces")),n.extraHeaders=n.extraHeaders||[],n.extraHeaders.push("Replaces: "+l)),i.connect(e.refer_to.uri.toAor(),n,t)}function n(){s.notify(603)}G("receiveRefer()");var s,i=this;return void 0===typeof e.refer_to?(G("no Refer-To header field present in REFER"),void e.reply(400)):e.refer_to.uri.scheme!==V.SIP?(G("Refer-To header field points to a non-SIP URI scheme"),void e.reply(416)):(e.reply(202),s=new te(this,e.cseq),void this.emit("refer",{request:e,accept:function(e,n){t.call(i,e,n)},reject:function(){n.call(i)}}))}function d(e){switch(G("receiveNotify()"),void 0===typeof e.event&&e.reply(400),e.event.event){case"refer":var t=e.event.params.id,n=this.referSubscribers[t];if(!n)return void e.reply(481,"Subscription does not exist");n.receiveNotify(e),e.reply(200);break;default:e.reply(489)}}function p(e){function t(t){var n;if(this.status!==L.STATUS_WAITING_FOR_ACK&&this.status!==L.STATUS_CONFIRMED)return!1;n=new r(this.ua),n.on("confirmed",function(){s.terminate()}),n.init_incoming(e,t)}function n(){G("Replaced INVITE rejected by the user"),e.reply(486)}G("receiveReplaces()");var s=this;this.emit("replaces",{request:e,accept:function(e){t.call(s,e)},reject:function(){n.call(s)}})}function f(e,t,n){function r(e){u.status!==L.STATUS_TERMINATED&&(u.localMediaStream=e,e&&u.connection.addStream(e),u.emit("peerconnection",{peerconnection:u.connection}),w.call(u,u.request),o.call(u,"offer",i,l,t))}function s(){u.status!==L.STATUS_TERMINATED&&U.call(u,"local",null,V.causes.USER_DENIED_MEDIA_ACCESS)}function i(e){u.isCanceled||u.status===L.STATUS_TERMINATED||(u.request.body=e,u.status=L.STATUS_INVITE_SENT,u.emit("sending",{request:u.request}),a.send())}function l(){u.status!==L.STATUS_TERMINATED&&U.call(u,"system",null,V.causes.WEBRTC_ERROR)}var u=this,a=new Q(u,this.ua);this.receiveResponse=function(e){m.call(u,e)},n?setTimeout(function(){r(n)}):e.audio||e.video?(this.localMediaStreamLocallyGenerated=!0,W.getUserMedia(e,r,s)):r(null)}function m(e){G("receiveInviteResponse()");var t,n,r,s=this;if(this.dialog&&e.status_code>=200&&e.status_code<=299)return this.dialog.id.call_id===e.call_id&&this.dialog.id.local_tag===e.from_tag&&this.dialog.id.remote_tag===e.to_tag?void _.call(this,V.ACK):(n=new X(this,e,"UAC"),void 0!==n.error?void G(n.error):(n.sendRequest({owner:{status:L.STATUS_TERMINATED},onRequestTimeout:function(){},onTransportError:function(){},onDialogError:function(){},receiveResponse:function(){}},V.ACK),void n.sendRequest({owner:{status:L.STATUS_TERMINATED},onRequestTimeout:function(){},onTransportError:function(){},onDialogError:function(){},receiveResponse:function(){}},V.BYE)));if(this.isCanceled)return this.isCanceled=!1,void(e.status_code>=100&&e.status_code<200?this.request.cancel(this.cancelReason):e.status_code>=200&&e.status_code<299&&v.call(this,e));if(this.status===L.STATUS_INVITE_SENT||this.status===L.STATUS_1XX_RECEIVED||this.status===L.STATUS_PROGRESS_RECEIVED)switch(!0){case/^100$/.test(e.status_code):this.status=L.STATUS_1XX_RECEIVED;break;case/^1[0-9]{2}$/.test(e.status_code):if(!e.to_tag){G("1xx response received without to tag");break}if(e.hasHeader("contact")&&!u.call(this,e,"UAC",!0))break;var i=e.from_tag,l=e.to_tag,o=e.call_id+i+l,a=this.earlyDialogs[o],c=!1;if(-1!==e.require.indexOf("100rel")||void 0!==a.last_received_rseq){if(void 0!==a.last_received_rseq&&e.rseq<=a.last_received_rseq)break;a.last_received_rseq=e.rseq,c=!0}if(this.status=L.STATUS_PROGRESS_RECEIVED,N.call(this,"remote",e),!e.body){c&&_.call(s,V.PRACK,{extraHeaders:["RAck: "+e.rseq+" "+e.cseq+" "+e.method],dialog:a});break}var h=c?"answer":"pranswer";r={originator:"remote",type:h,sdp:e.body},this.emit("sdp",r),this.connection.setRemoteDescription(new W.RTCSessionDescription({type:h,sdp:r.sdp}),function(){c&&_.call(s,V.PRACK,{extraHeaders:["RAck: "+e.rseq+" "+e.cseq+" "+e.method],dialog:a})},function(){c&&(_.call(s,V.PRACK,{extraHeaders:["RAck: "+e.rseq+" "+e.cseq+" "+e.method],dialog:a}),s.terminate({cause:V.causes.BAD_MEDIA_DESCRIPTION,status_code:400,reason_phrase:"Bad media description"}),U.call(this,"remote",e,V.causes.BAD_MEDIA_DESCRIPTION))});break;case/^2[0-9]{2}$/.test(e.status_code):if(this.status=L.STATUS_CONFIRMED,!e.body&&"stable"!==this.connection.signalingState){v.call(this,e,400,V.causes.MISSING_SDP),U.call(this,"remote",e,V.causes.BAD_MEDIA_DESCRIPTION);break}if(!u.call(this,e,"UAC"))break;if(!e.body){D.call(s,"remote",e),_.call(s,V.ACK),O.call(s,"local",null);break}r={originator:"remote",type:"answer",sdp:e.body},this.emit("sdp",r),this.connection.setRemoteDescription(new W.RTCSessionDescription({type:"answer",sdp:r.sdp}),function(){A.call(s,e),D.call(s,"remote",e),_.call(s,V.ACK),O.call(s,"local",null)},function(){v.call(s,e,488,"Not Acceptable Here"),U.call(s,"remote",e,V.causes.BAD_MEDIA_DESCRIPTION)});break;default:t=J.sipErrorCause(e.status_code),U.call(this,"remote",e,t)}}function g(e){function t(e){if(r.status!==L.STATUS_TERMINATED&&(_.call(r,V.ACK),!u)){if(A.call(r,e),!e.body)return void n();if("application/sdp"!==e.getHeader("Content-Type"))return void n();var t={originator:"remote",type:"answer",sdp:e.body};r.emit("sdp",t),r.connection.setRemoteDescription(new W.RTCSessionDescription({type:"answer",sdp:t.sdp}),function(){i.succeeded&&i.succeeded(e)},function(){n()})}}function n(e){i.failed&&i.failed(e)}G("sendReinvite()"),e=e||{};var r=this,s=e.extraHeaders||[],i=e.eventHandlers||{},l=e.rtcOfferConstraints||this.rtcOfferConstraints||null,u=!1;s.push("Contact: "+this.contact),s.push("Content-Type: application/sdp"),this.sessionTimers.running&&s.push("Session-Expires: "+this.sessionTimers.currentExpires+";refresher="+(this.sessionTimers.refresher?"uac":"uas")),o.call(this,"offer",function(e){e=S.call(r,e),new Z(r,V.INVITE).send({extraHeaders:s,body:e,eventHandlers:{onSuccessResponse:function(e){t(e),u=!0},onErrorResponse:function(e){n(e)},onTransportError:function(){r.onTransportError()},onRequestTimeout:function(){r.onRequestTimeout()},onDialogError:function(){r.onDialogError()}}})},function(){n()},l)}function T(e){function t(e){if(r.status!==L.STATUS_TERMINATED&&!a)if(A.call(r,e),u){if(!e.body)return void n();if("application/sdp"!==e.getHeader("Content-Type"))return void n();var t={originator:"remote",type:"answer",sdp:e.body};r.emit("sdp",t),r.connection.setRemoteDescription(new W.RTCSessionDescription({type:"answer",sdp:t.sdp}),function(){i.succeeded&&i.succeeded(e)},function(){n()})}else i.succeeded&&i.succeeded(e)}function n(e){i.failed&&i.failed(e)}G("sendUpdate()"),e=e||{};var r=this,s=e.extraHeaders||[],i=e.eventHandlers||{},l=e.rtcOfferConstraints||this.rtcOfferConstraints||null,u=e.sdpOffer||!1,a=!1;if(s.push("Contact: "+this.contact),this.sessionTimers.running&&s.push("Session-Expires: "+this.sessionTimers.currentExpires+";refresher="+(this.sessionTimers.refresher?"uac":"uas")),u)s.push("Content-Type: application/sdp"),o.call(this,"offer",function(e){e=S.call(r,e),new Z(r,V.UPDATE).send({extraHeaders:s,body:e,eventHandlers:{onSuccessResponse:function(e){t(e),a=!0},onErrorResponse:function(e){n(e)},onTransportError:function(){r.onTransportError()},onRequestTimeout:function(){r.onRequestTimeout()},onDialogError:function(){r.onDialogError()}}})},function(){n()},l);else{new Z(r,V.UPDATE).send({extraHeaders:s,eventHandlers:{onSuccessResponse:function(e){t(e)},onErrorResponse:function(e){n(e)},onTransportError:function(){r.onTransportError()},onRequestTimeout:function(){r.onRequestTimeout()},onDialogError:function(){r.onDialogError()}}})}}function v(e,t,n){G("acceptAndTerminate()");var r=[];t&&(n=n||V.REASON_PHRASE[t]||"",r.push("Reason: SIP ;cause="+t+'; text="'+n+'"')),(this.dialog||u.call(this,e,"UAC"))&&(_.call(this,V.ACK),_.call(this,V.BYE,{extraHeaders:r})),this.status=L.STATUS_TERMINATED}function _(e,t){G("sendRequest()"),new Z(this,e).send(t)}function S(e){var t,n,r;if(!this.localHold&&!this.remoteHold)return e;if(e=B.parse(e),this.localHold&&!this.remoteHold)for(G("mangleOffer() | me on hold, mangling offer"),n=e.media.length,t=0;t<n;t++)r=e.media[t],-1!==re.indexOf(r.type)&&(r.direction?"sendrecv"===r.direction?r.direction="sendonly":"recvonly"===r.direction&&(r.direction="inactive"):r.direction="sendonly");else if(this.localHold&&this.remoteHold)for(G("mangleOffer() | both on hold, mangling offer"),n=e.media.length,t=0;t<n;t++)r=e.media[t],-1!==re.indexOf(r.type)&&(r.direction="inactive");else if(this.remoteHold)for(G("mangleOffer() | remote on hold, mangling offer"),n=e.media.length,t=0;t<n;t++)r=e.media[t],-1!==re.indexOf(r.type)&&(r.direction?"sendrecv"===r.direction?r.direction="recvonly":"recvonly"===r.direction&&(r.direction="inactive"):r.direction="recvonly");return B.write(e)}function C(){var e=!0,t=!0;(this.localHold||this.remoteHold)&&(e=!1,t=!1),this.audioMuted&&(e=!1),this.videoMuted&&(t=!1),R.call(this,!e),b.call(this,!t)}function E(e,t){if(this.sessionTimers.enabled){var n;e.session_expires&&e.session_expires>=V.MIN_SESSION_EXPIRES?(this.sessionTimers.currentExpires=e.session_expires,n=e.session_expires_refresher||"uas"):(this.sessionTimers.currentExpires=this.sessionTimers.defaultExpires,n="uas"),t.push("Session-Expires: "+this.sessionTimers.currentExpires+";refresher="+n),this.sessionTimers.refresher="uas"===n,y.call(this)}}function A(e){if(this.sessionTimers.enabled){var t;e.session_expires&&e.session_expires>=V.MIN_SESSION_EXPIRES?(this.sessionTimers.currentExpires=e.session_expires,t=e.session_expires_refresher||"uac"):(this.sessionTimers.currentExpires=this.sessionTimers.defaultExpires,t="uac"),this.sessionTimers.refresher="uac"===t,y.call(this)}}function y(){var e=this,t=this.sessionTimers.currentExpires;this.sessionTimers.running=!0,clearTimeout(this.sessionTimers.timer),this.sessionTimers.refresher?this.sessionTimers.timer=setTimeout(function(){e.status!==L.STATUS_TERMINATED&&(G("runSessionTimer() | sending session refresh request"),T.call(e,{eventHandlers:{succeeded:function(t){A.call(e,t)}}}))},500*t):this.sessionTimers.timer=setTimeout(function(){e.status!==L.STATUS_TERMINATED&&(j("runSessionTimer() | timer expired, terminating the session"),e.terminate({cause:V.causes.REQUEST_TIMEOUT,status_code:408,reason_phrase:"Session Timer Expired"}))},1100*t)}function R(e){var t,n,r,s,i,l=this.connection.getLocalStreams();for(r=l.length,t=0;t<r;t++)for(i=l[t].getAudioTracks(),s=i.length,n=0;n<s;n++)i[n].enabled=!e}function b(e){var t,n,r,s,i,l=this.connection.getLocalStreams();for(r=l.length,t=0;t<r;t++)for(i=l[t].getVideoTracks(),s=i.length,n=0;n<s;n++)i[n].enabled=!e}function I(e,t){G("newRTCSession"),this.ua.newRTCSession({originator:e,session:this,request:t})}function w(e){G("session connecting"),this.emit("connecting",{request:e})}function N(e,t){G("session progress"),this.emit("progress",{originator:e,response:t||null})}function D(e,t){G("session accepted"),this.start_time=new Date,this.emit("accepted",{originator:e,response:t||null})}function O(e,t){G("session confirmed"),this.is_confirmed=!0,this.emit("confirmed",{originator:e,ack:t||null})}function x(e,t,n){G("session ended"),this.end_time=new Date,this.close(),this.emit("ended",{originator:e,message:t||null,cause:n})}function U(e,t,n){G("session failed"),this.close(),this.emit("failed",{originator:e,message:t||null,cause:n})}function P(e){G("session onhold"),C.call(this),this.emit("hold",{originator:e})}function M(e){G("session onunhold"),C.call(this),this.emit("unhold",{originator:e})}function q(e){G("session onmute"),C.call(this),this.emit("muted",{audio:e.audio,video:e.video})}function k(e){G("session onunmute"),C.call(this),this.emit("unmuted",{audio:e.audio,video:e.video})}t.exports=r;var L={STATUS_NULL:0,STATUS_INVITE_SENT:1,STATUS_1XX_RECEIVED:2,STATUS_PROGRESS_RECEIVED:3,STATUS_INVITE_RECEIVED:4,STATUS_WAITING_FOR_ANSWER:5,STATUS_ANSWERED:6,STATUS_WAITING_FOR_ACK:7,STATUS_CANCELED:8,STATUS_TERMINATED:9,STATUS_CONFIRMED:10};r.C=L;var H=e("util"),F=e("events"),G=e("debug")("JsSIP:RTCSession"),j=e("debug")("JsSIP:ERROR:RTCSession");j.log=console.warn.bind(console);var W=e("rtcninja"),B=e("sdp-transform"),V=e("./Constants"),z=e("./Exceptions"),K=e("./Transactions"),J=e("./Utils"),Y=e("./Timers"),$=e("./SIPMessage"),X=e("./Dialog"),Q=e("./RequestSender"),Z=e("./RTCSession/Request"),ee=e("./RTCSession/DTMF"),te=e("./RTCSession/ReferNotifier"),ne=e("./RTCSession/ReferSubscriber"),re=["audio","video"];H.inherits(r,F.EventEmitter),r.prototype.isInProgress=function(){switch(this.status){case L.STATUS_NULL:case L.STATUS_INVITE_SENT:case L.STATUS_1XX_RECEIVED:case L.STATUS_PROGRESS_RECEIVED:case L.STATUS_INVITE_RECEIVED:case L.STATUS_WAITING_FOR_ANSWER:return!0;default:return!1}},r.prototype.isEstablished=function(){switch(this.status){case L.STATUS_ANSWERED:case L.STATUS_WAITING_FOR_ACK:case L.STATUS_CONFIRMED:return!0;default:return!1}},r.prototype.isEnded=function(){switch(this.status){case L.STATUS_CANCELED:case L.STATUS_TERMINATED:return!0;default:return!1}},r.prototype.isMuted=function(){return{audio:this.audioMuted,video:this.videoMuted}},r.prototype.isOnHold=function(){return{local:this.localHold,remote:this.remoteHold}},r.prototype.isReadyToReOffer=function(){
return this.rtcReady?this.dialog?!0!==this.dialog.uac_pending_reply&&!0!==this.dialog.uas_pending_reply||(G("isReadyToReOffer() | there is another INVITE/UPDATE transaction in progress"),!1):(G("isReadyToReOffer() | session not established yet"),!1):(G("isReadyToReOffer() | internal WebRTC status not ready"),!1)},r.prototype.connect=function(e,t,n){G("connect()"),t=t||{};var r,s,i=e,o=t.eventHandlers||{},u=t.extraHeaders&&t.extraHeaders.slice()||[],a=t.mediaConstraints||{audio:!0,video:!0},c=t.mediaStream||null,h=t.pcConfig||{iceServers:[]},d=t.rtcConstraints||null,p=t.rtcOfferConstraints||null;if(this.rtcOfferConstraints=p,this.rtcAnswerConstraints=t.rtcAnswerConstraints||null,this.sessionTimers.enabled&&J.isDecimal(t.sessionTimersExpires)&&(t.sessionTimersExpires>=V.MIN_SESSION_EXPIRES?this.sessionTimers.defaultExpires=t.sessionTimersExpires:this.sessionTimers.defaultExpires=V.SESSION_EXPIRES),this.data=t.data||this.data,void 0===e)throw new TypeError("Not enough arguments");if(!W.hasWebRTC())throw new z.NotSupportedError("WebRTC not supported");if(!(e=this.ua.normalizeTarget(e)))throw new TypeError("Invalid target: "+i);if(this.status!==L.STATUS_NULL)throw new z.InvalidStateError(this.status);for(r in o)this.on(r,o[r]);this.from_tag=J.newTag(),this.anonymous=t.anonymous||!1,this.isCanceled=!1,s={from_tag:this.from_tag},this.contact=this.ua.contact.toString({anonymous:this.anonymous,outbound:!0}),this.anonymous&&(s.from_display_name="Anonymous",s.from_uri="sip:anonymous@anonymous.invalid",u.push("P-Preferred-Identity: "+this.ua.configuration.uri.toString()),u.push("Privacy: id")),this.contact+=";reg-id=1",this.contact+=';+sip.instance="<urn:uuid:'+this.ua.configuration.instance_id+'>"',u.push("Contact: "+this.contact),u.push("Content-Type: application/sdp"),this.sessionTimers.enabled&&u.push("Session-Expires: "+this.sessionTimers.defaultExpires),this.support100rel.enabled&&u.push("Supported: 100rel"),this.request=new $.OutgoingRequest(V.INVITE,e,this.ua,s,u),this.id=this.request.call_id+this.from_tag,l.call(this,h,d),this.ua.sessions[this.id]=this,this.direction="outgoing",this.local_identity=this.request.from,this.remote_identity=this.request.to,n?n(this):I.call(this,"local",this.request),f.call(this,a,p,c)},r.prototype.init_incoming=function(e,t){G("init_incoming()");var n,r=this,s=e.getHeader("Content-Type");return e.body&&"application/sdp"!==s?void e.reply(415):(this.status=L.STATUS_INVITE_RECEIVED,this.from_tag=e.from_tag,this.id=e.call_id+this.from_tag,this.request=e,this.contact=this.ua.contact.toString(),this.ua.sessions[this.id]=this,e.hasHeader("expires")&&(n=1e3*e.getHeader("expires")),e.to_tag=J.newTag(),-1===e.require.indexOf("100rel")||this.support100rel.enabled?u.call(this,e,"UAS",!0)?(e.body?this.late_sdp=!1:this.late_sdp=!0,this.status=L.STATUS_WAITING_FOR_ANSWER,this.timers.userNoAnswerTimer=setTimeout(function(){e.reply(408),U.call(r,"local",null,V.causes.NO_ANSWER)},this.ua.configuration.no_answer_timeout),n&&(this.timers.expiresTimer=setTimeout(function(){r.status===L.STATUS_WAITING_FOR_ANSWER&&(e.reply(487),U.call(r,"system",null,V.causes.EXPIRES))},n)),this.direction="incoming",this.local_identity=e.to,this.remote_identity=e.from,t?t(this):I.call(this,"remote",e),void(this.status!==L.STATUS_TERMINATED&&(e.reply(180,null,["Contact: "+r.contact]),N.call(r,"local",null)))):void e.reply(500,"Missing Contact header field"):void e.reply(420,"Bad extension"))},r.prototype.answer=function(e){function t(e){if(_.status!==L.STATUS_TERMINATED)if(_.localMediaStream=e,e&&_.connection.addStream(e),_.request.body||_.emit("peerconnection",{peerconnection:_.connection}),_.late_sdp)r();else{var t={originator:"remote",type:"offer",sdp:S.body};_.emit("sdp",t),_.connection.setRemoteDescription(new W.RTCSessionDescription({type:"offer",sdp:t.sdp}),r,function(){S.reply(488),U.call(_,"system",null,V.causes.WEBRTC_ERROR)})}}function n(){_.status!==L.STATUS_TERMINATED&&(S.reply(480),U.call(_,"local",null,V.causes.USER_DENIED_MEDIA_ACCESS))}function r(){w.call(_,S),_.late_sdp?o.call(_,"offer",a,c,_.rtcOfferConstraints):o.call(_,"answer",a,c,I)}function a(e){function t(){_.status=L.STATUS_WAITING_FOR_ACK,s.call(_,S,e),i.call(_),D.call(_,"local")}function n(){U.call(_,"system",null,V.causes.CONNECTION_ERROR)}_.status!==L.STATUS_TERMINATED&&(E.call(_,S,C),S.reply(200,null,C,e,t,n))}function c(){_.status!==L.STATUS_TERMINATED&&(S.reply(500),U.call(_,"system",null,V.causes.WEBRTC_ERROR))}G("answer()"),e=e||{};var h,d,p,f,m=!1,g=!1,T=!1,v=!1,_=this,S=this.request,C=e.extraHeaders&&e.extraHeaders.slice()||[],A=e.mediaConstraints||{},y=e.mediaStream||null,R=e.pcConfig||{iceServers:[]},b=e.rtcConstraints||null,I=e.rtcAnswerConstraints||null;if(this.rtcAnswerConstraints=I,this.rtcOfferConstraints=e.rtcOfferConstraints||null,this.sessionTimers.enabled&&J.isDecimal(e.sessionTimersExpires)&&(e.sessionTimersExpires>=V.MIN_SESSION_EXPIRES?this.sessionTimers.defaultExpires=e.sessionTimersExpires:this.sessionTimers.defaultExpires=V.SESSION_EXPIRES),this.data=e.data||this.data,"incoming"!==this.direction)throw new z.NotSupportedError('"answer" not supported for outgoing RTCSession');if(this.status!==L.STATUS_WAITING_FOR_ANSWER)throw new z.InvalidStateError(this.status);if(this.status=L.STATUS_ANSWERED,!u.call(this,S,"UAS"))return void S.reply(500,"Error creating dialog");for(clearTimeout(this.timers.userNoAnswerTimer),C.unshift("Contact: "+_.contact),p=S.parseSDP(),Array.isArray(p.media)||(p.media=[p.media]),h=p.media.length;h--;){var N=p.media[h];"audio"===N.type&&(m=!0,N.direction&&"sendrecv"!==N.direction||(T=!0)),"video"===N.type&&(g=!0,N.direction&&"sendrecv"!==N.direction||(v=!0))}if(y&&!1===A.audio)for(f=y.getAudioTracks(),d=f.length,h=0;h<d;h++)y.removeTrack(f[h]);if(y&&!1===A.video)for(f=y.getVideoTracks(),d=f.length,h=0;h<d;h++)y.removeTrack(f[h]);y||void 0!==A.audio||(A.audio=T),y||void 0!==A.video||(A.video=v),y||m||(A.audio=!1),y||g||(A.video=!1),l.call(this,R,b),y?t(y):A.audio||A.video?(_.localMediaStreamLocallyGenerated=!0,W.getUserMedia(A,t,n)):t(null)},r.prototype.terminate=function(e){G("terminate()"),e=e||{};var t,n,r=e.cause||V.causes.BYE,s=e.status_code,i=e.reason_phrase,l=e.extraHeaders&&e.extraHeaders.slice()||[],o=e.body,u=this;if(this.status===L.STATUS_TERMINATED)throw new z.InvalidStateError(this.status);switch(this.status){case L.STATUS_NULL:case L.STATUS_INVITE_SENT:case L.STATUS_1XX_RECEIVED:case L.STATUS_PROGRESS_RECEIVED:if(G("canceling session"),s&&(s<200||s>=700))throw new TypeError("Invalid status_code: "+s);s&&(i=i||V.REASON_PHRASE[s]||"",t="SIP ;cause="+s+' ;text="'+i+'"'),this.status===L.STATUS_NULL?(this.isCanceled=!0,this.cancelReason=t):this.status===L.STATUS_INVITE_SENT?(this.isCanceled=!0,this.cancelReason=t):this.status!==L.STATUS_1XX_RECEIVED&&this.status!==L.STATUS_PROGRESS_RECEIVED||this.request.cancel(t),this.status=L.STATUS_CANCELED,U.call(this,"local",null,V.causes.CANCELED);break;case L.STATUS_WAITING_FOR_ANSWER:case L.STATUS_ANSWERED:if(G("rejecting session"),(s=s||480)<300||s>=700)throw new TypeError("Invalid status_code: "+s);this.request.reply(s,i,l,o),U.call(this,"local",null,V.causes.REJECTED);break;case L.STATUS_WAITING_FOR_ACK:case L.STATUS_CONFIRMED:if(G("terminating session"),i=e.reason_phrase||V.REASON_PHRASE[s]||"",s&&(s<200||s>=700))throw new TypeError("Invalid status_code: "+s);s&&l.push("Reason: SIP ;cause="+s+'; text="'+i+'"'),this.status===L.STATUS_WAITING_FOR_ACK&&"incoming"===this.direction&&this.request.server_transaction.state!==K.C.STATUS_TERMINATED?(n=this.dialog,this.receiveRequest=function(e){e.method===V.ACK&&(_.call(this,V.BYE,{extraHeaders:l,body:o}),n.terminate())},this.request.server_transaction.on("stateChanged",function(){this.state===K.C.STATUS_TERMINATED&&(_.call(u,V.BYE,{extraHeaders:l,body:o}),n.terminate())}),x.call(this,"local",null,r),this.dialog=n,this.ua.dialogs[n.id.toString()]=n):(_.call(this,V.BYE,{extraHeaders:l,body:o}),x.call(this,"local",null,r))}},r.prototype.close=function(){G("close()");var e;if(this.status!==L.STATUS_TERMINATED){if(this.connection)try{this.connection.close()}catch(e){j("close() | error closing the RTCPeerConnection: %o",e)}this.localMediaStream&&this.localMediaStreamLocallyGenerated&&(G("close() | closing local MediaStream"),W.closeMediaStream(this.localMediaStream));for(e in this.timers)clearTimeout(this.timers[e]);clearTimeout(this.sessionTimers.timer),this.dialog&&(this.dialog.terminate(),delete this.dialog);for(e in this.earlyDialogs)this.earlyDialogs[e].terminate(),delete this.earlyDialogs[e];this.status=L.STATUS_TERMINATED,delete this.ua.sessions[this.id]}},r.prototype.sendDTMF=function(e,t){function n(){var e,r;if(o.status===L.STATUS_TERMINATED||!o.tones||l>=o.tones.length)return void(o.tones=null);if(e=o.tones[l],l+=1,","===e)r=2e3;else{var u=new ee(o);t.eventHandlers={failed:function(){o.tones=null}},u.send(e,t),r=s+i}setTimeout(n,r)}G("sendDTMF() | tones: %s",e);var r,s,i,l=0,o=this;if(t=t||{},r=void 0===t.usertp||t.usertp,s=t.duration||null,i=t.interToneGap||null,void 0===e)throw new TypeError("Not enough arguments");if(this.status!==L.STATUS_CONFIRMED&&this.status!==L.STATUS_WAITING_FOR_ACK)throw new z.InvalidStateError(this.status);if("number"==typeof e&&(e=e.toString()),!e||"string"!=typeof e||!e.match(/^[0-9A-D#*,]+$/i))throw new TypeError("Invalid tones: "+e);if(s&&!J.isDecimal(s))throw new TypeError("Invalid tone duration: "+s);if(s?s<ee.C.MIN_DURATION?(G('"duration" value is lower than the minimum allowed, setting it to '+ee.C.MIN_DURATION+" milliseconds"),s=ee.C.MIN_DURATION):s>ee.C.MAX_DURATION?(G('"duration" value is greater than the maximum allowed, setting it to '+ee.C.MAX_DURATION+" milliseconds"),s=ee.C.MAX_DURATION):s=Math.abs(s):s=ee.C.DEFAULT_DURATION,t.duration=s,i&&!J.isDecimal(i))throw new TypeError("Invalid interToneGap: "+i);if(i?i<ee.C.MIN_INTER_TONE_GAP?(G('"interToneGap" value is lower than the minimum allowed, setting it to '+ee.C.MIN_INTER_TONE_GAP+" milliseconds"),i=ee.C.MIN_INTER_TONE_GAP):i=Math.abs(i):i=ee.C.DEFAULT_INTER_TONE_GAP,r){if(void 0!==this.dtmfSender)return void this.dtmfSender.insertDTMF(e,s,i);if("function"!=typeof this.connection.createDTMFSender)throw new TypeError("Invalid method for sending DTMF: createDTMFSender API not supported");var u=this.connection.getLocalStreams()[0],a=u.getAudioTracks()[0];return this.dtmfSender=this.connection.createDTMFSender(a),void this.dtmfSender.insertDTMF(e,s,i)}if(this.tones)return void(this.tones+=e);this.tones=e,n()},r.prototype.mute=function(e){G("mute()"),e=e||{audio:!0,video:!1};var t=!1,n=!1;!1===this.audioMuted&&e.audio&&(t=!0,this.audioMuted=!0,R.call(this,!0)),!1===this.videoMuted&&e.video&&(n=!0,this.videoMuted=!0,b.call(this,!0)),!0!==t&&!0!==n||q.call(this,{audio:t,video:n})},r.prototype.unmute=function(e){G("unmute()"),e=e||{audio:!0,video:!0};var t=!1,n=!1;!0===this.audioMuted&&e.audio&&(t=!0,this.audioMuted=!1,!1===this.localHold&&R.call(this,!1)),!0===this.videoMuted&&e.video&&(n=!0,this.videoMuted=!1,!1===this.localHold&&b.call(this,!1)),!0!==t&&!0!==n||k.call(this,{audio:t,video:n})},r.prototype.hold=function(e,t){G("hold()"),e=e||{};var n,r=this;return(this.status===L.STATUS_WAITING_FOR_ACK||this.status===L.STATUS_CONFIRMED)&&(!0!==this.localHold&&(!!this.isReadyToReOffer()&&(this.localHold=!0,P.call(this,"local"),n={succeeded:function(){t&&t()},failed:function(){r.terminate({cause:V.causes.WEBRTC_ERROR,status_code:500,reason_phrase:"Hold Failed"})}},e.useUpdate?T.call(this,{sdpOffer:!0,eventHandlers:n,extraHeaders:e.extraHeaders}):g.call(this,{eventHandlers:n,extraHeaders:e.extraHeaders}),!0)))},r.prototype.unhold=function(e,t){G("unhold()"),e=e||{};var n,r=this;return(this.status===L.STATUS_WAITING_FOR_ACK||this.status===L.STATUS_CONFIRMED)&&(!1!==this.localHold&&(!!this.isReadyToReOffer()&&(this.localHold=!1,M.call(this,"local"),n={succeeded:function(){t&&t()},failed:function(){r.terminate({cause:V.causes.WEBRTC_ERROR,status_code:500,reason_phrase:"Unhold Failed"})}},e.useUpdate?T.call(this,{sdpOffer:!0,eventHandlers:n,extraHeaders:e.extraHeaders}):g.call(this,{eventHandlers:n,extraHeaders:e.extraHeaders}),!0)))},r.prototype.renegotiate=function(e,t){G("renegotiate()"),e=e||{};var n,r=this,s=e.rtcOfferConstraints||null;return(this.status===L.STATUS_WAITING_FOR_ACK||this.status===L.STATUS_CONFIRMED)&&(!!this.isReadyToReOffer()&&(n={succeeded:function(){t&&t()},failed:function(){r.terminate({cause:V.causes.WEBRTC_ERROR,status_code:500,reason_phrase:"Media Renegotiation Failed"})}},C.call(this),e.useUpdate?T.call(this,{sdpOffer:!0,eventHandlers:n,rtcOfferConstraints:s,extraHeaders:e.extraHeaders}):g.call(this,{eventHandlers:n,rtcOfferConstraints:s,extraHeaders:e.extraHeaders}),!0))},r.prototype.refer=function(e,t){G("refer()");var n,r,s=this,i=e;if(this.status!==L.STATUS_WAITING_FOR_ACK&&this.status!==L.STATUS_CONFIRMED)return!1;if(!(e=this.ua.normalizeTarget(e)))throw new TypeError("Invalid target: "+i);return n=new ne(this),n.sendRefer(e,t),r=n.outgoingRequest.cseq,this.referSubscribers[r]=n,n.on("requestFailed",function(){delete s.referSubscribers[r]}),n.on("accepted",function(){delete s.referSubscribers[r]}),n.on("failed",function(){delete s.referSubscribers[r]}),n},r.prototype.receiveRequest=function(e){G("receiveRequest()");var t,n=this;if(e.method===V.CANCEL)this.status!==L.STATUS_WAITING_FOR_ANSWER&&this.status!==L.STATUS_ANSWERED||(this.status=L.STATUS_CANCELED,this.request.reply(487),U.call(this,"remote",e,V.causes.CANCELED));else switch(e.method){case V.ACK:if(this.status<L.STATUS_WAITING_FOR_ACK)return;if(this.status=L.STATUS_CONFIRMED,clearTimeout(this.timers.ackTimer),clearTimeout(this.timers.invite2xxTimer),this.late_sdp){if(!e.body){this.terminate({cause:V.causes.MISSING_SDP,status_code:400});break}var r={originator:"remote",type:"answer",sdp:e.body};this.emit("sdp",r),this.connection.setRemoteDescription(new W.RTCSessionDescription({type:"answer",sdp:r.sdp}),function(){n.is_confirmed||O.call(n,"remote",e)},function(){n.terminate({cause:V.causes.BAD_MEDIA_DESCRIPTION,status_code:488})})}else this.is_confirmed||O.call(this,"remote",e);break;case V.BYE:this.status===L.STATUS_CONFIRMED?(e.reply(200),x.call(this,"remote",e,V.causes.BYE)):this.status===L.STATUS_INVITE_RECEIVED?(e.reply(200),this.request.reply(487,"BYE Received"),x.call(this,"remote",e,V.causes.BYE)):e.reply(403,"Wrong Status");break;case V.INVITE:this.status===L.STATUS_CONFIRMED?e.hasHeader("replaces")?p.call(this,e):a.call(this,e):e.reply(403,"Wrong Status");break;case V.PRACK:e.reply(200);break;case V.INFO:this.status===L.STATUS_CONFIRMED||this.status===L.STATUS_WAITING_FOR_ACK||this.status===L.STATUS_INVITE_RECEIVED?(t=e.getHeader("content-type"),t&&t.match(/^application\/dtmf-relay/i)?new ee(this).init_incoming(e):e.reply(415)):e.reply(403,"Wrong Status");break;case V.UPDATE:this.status===L.STATUS_CONFIRMED||this.status===L.STATUS_PROGRESS_RECEIVED?c.call(this,e):e.reply(403,"Wrong Status");break;case V.REFER:this.status===L.STATUS_CONFIRMED?h.call(this,e):e.reply(403,"Wrong Status");break;case V.NOTIFY:this.status===L.STATUS_CONFIRMED?d.call(this,e):e.reply(403,"Wrong Status");break;default:e.reply(501)}},r.prototype.onTransportError=function(){j("onTransportError()"),this.status!==L.STATUS_TERMINATED&&this.terminate({status_code:500,reason_phrase:V.causes.CONNECTION_ERROR,cause:V.causes.CONNECTION_ERROR})},r.prototype.onRequestTimeout=function(){G("onRequestTimeout"),this.status!==L.STATUS_TERMINATED&&this.terminate({status_code:408,reason_phrase:V.causes.REQUEST_TIMEOUT,cause:V.causes.REQUEST_TIMEOUT})},r.prototype.onDialogError=function(){j("onDialogError()"),this.status!==L.STATUS_TERMINATED&&this.terminate({status_code:500,reason_phrase:V.causes.DIALOG_ERROR,cause:V.causes.DIALOG_ERROR})},r.prototype.newDTMF=function(e){G("newDTMF()"),this.emit("newDTMF",e)},r.prototype.resetLocalMedia=function(){G("resetLocalMedia()"),this.localHold=!1,this.audioMuted=!1,this.videoMuted=!1,C.call(this)}},{"./Constants":1,"./Dialog":2,"./Exceptions":5,"./RTCSession/DTMF":12,"./RTCSession/ReferNotifier":13,"./RTCSession/ReferSubscriber":14,"./RTCSession/Request":15,"./RequestSender":17,"./SIPMessage":18,"./Timers":20,"./Transactions":21,"./Utils":25,debug:29,events:31,rtcninja:38,"sdp-transform":42,util:46}],12:[function(e,t,n){function r(e){this.owner=e,this.direction=null,this.tone=null,this.duration=null}t.exports=r;var s={MIN_DURATION:70,MAX_DURATION:6e3,DEFAULT_DURATION:100,MIN_INTER_TONE_GAP:50,DEFAULT_INTER_TONE_GAP:500};r.C=s;var i=e("debug")("JsSIP:RTCSession:DTMF"),l=e("debug")("JsSIP:ERROR:RTCSession:DTMF");l.log=console.warn.bind(console);var o=e("../Constants"),u=e("../Exceptions"),a=e("../RTCSession");r.prototype.send=function(e,t){var n,r;if(void 0===e)throw new TypeError("Not enough arguments");if(this.direction="outgoing",this.owner.status!==a.C.STATUS_CONFIRMED&&this.owner.status!==a.C.STATUS_WAITING_FOR_ACK)throw new u.InvalidStateError(this.owner.status);if(t=t||{},n=t.extraHeaders?t.extraHeaders.slice():[],this.eventHandlers=t.eventHandlers||{},"string"==typeof e)e=e.toUpperCase();else{if("number"!=typeof e)throw new TypeError("Invalid tone: "+e);e=e.toString()}if(!e.match(/^[0-9A-D#*]$/))throw new TypeError("Invalid tone: "+e);this.tone=e,this.duration=t.duration,n.push("Content-Type: application/dtmf-relay"),r="Signal="+this.tone+"\r\n",r+="Duration="+this.duration,this.owner.newDTMF({originator:"local",dtmf:this,request:this.request}),this.owner.dialog.sendRequest(this,o.INFO,{extraHeaders:n,body:r})},r.prototype.receiveResponse=function(e){switch(!0){case/^1[0-9]{2}$/.test(e.status_code):break;case/^2[0-9]{2}$/.test(e.status_code):i("onSuccessResponse"),this.eventHandlers.onSuccessResponse&&this.eventHandlers.onSuccessResponse(e);break;default:this.eventHandlers.onErrorResponse&&this.eventHandlers.onErrorResponse(e)}},r.prototype.onRequestTimeout=function(){l("onRequestTimeout"),this.eventHandlers.onRequestTimeout&&this.eventHandlers.onRequestTimeout()},r.prototype.onTransportError=function(){l("onTransportError"),this.eventHandlers.onTransportError&&this.eventHandlers.onTransportError()},r.prototype.onDialogError=function(){l("onDialogError"),this.eventHandlers.onDialogError&&this.eventHandlers.onDialogError()},r.prototype.init_incoming=function(e){var t,n=/^(Signal\s*?=\s*?)([0-9A-D#*]{1})(\s)?.*/,r=/^(Duration\s?=\s?)([0-9]{1,4})(\s)?.*/;this.direction="incoming",this.request=e,e.reply(200),e.body&&(t=e.body.split("\n"),t.length>=1&&n.test(t[0])&&(this.tone=t[0].replace(n,"$2")),t.length>=2&&r.test(t[1])&&(this.duration=parseInt(t[1].replace(r,"$2"),10))),this.duration||(this.duration=s.DEFAULT_DURATION),this.tone?this.owner.newDTMF({originator:"remote",dtmf:this,request:e}):i("invalid INFO DTMF received, discarded")}},{"../Constants":1,"../Exceptions":5,"../RTCSession":11,debug:29}],13:[function(e,t,n){function r(e,t,n){this.session=e,this.id=t,this.expires=n||s.expires,this.active=!0,this.notify(100)}t.exports=r;var s={event_type:"refer",body_type:"message/sipfrag;version=2.0",expires:300},i=e("debug")("JsSIP:RTCSession:ReferNotifier"),l=e("../Constants"),o=e("./Request");r.prototype.notify=function(e,t){i("notify()");var n,r=this;if(!1!==this.active){t=t||l.REASON_PHRASE[e]||"",n=e>=200?"terminated;reason=noresource":"active;expires="+this.expires;new o(this.session,l.NOTIFY).send({extraHeaders:["Event: "+s.event_type+";id="+r.id,"Subscription-State: "+n,"Content-Type: "+s.body_type],body:"SIP/2.0 "+e+" "+t,eventHandlers:{onErrorResponse:function(){r.active=!1}}})}}},{"../Constants":1,"./Request":15,debug:29}],14:[function(e,t,n){function r(e){this.session=e,this.timer=null,this.outgoingRequest=null,o.EventEmitter.call(this)}function s(){console.log("removeSubscriber()"),clearTimeout(this.timer),this.session.referSubscriber=null}t.exports=r;var i={expires:120},l=e("util"),o=e("events"),u=e("debug")("JsSIP:RTCSession:ReferSubscriber"),a=e("../Constants"),c=e("../Grammar"),h=e("./Request");l.inherits(r,o.EventEmitter),r.prototype.sendRefer=function(e,t){u("sendRefer()");var n,r,l,o=null,c=this;t=t||{},n=t.extraHeaders?t.extraHeaders.slice():[],r=t.eventHandlers||{};for(var d in r)this.on(d,r[d]);t.replaces&&(o=t.replaces.request.call_id,o+=";to-tag="+t.replaces.to_tag,o+=";from-tag="+t.replaces.from_tag,o=encodeURIComponent(o)),l="Refer-To: <"+e+(o?"?Replaces="+o:"")+">",n.push(l);var p=new h(this.session,a.REFER);this.timer=setTimeout(function(){s.call(c)},1e3*i.expires),p.send({extraHeaders:n,eventHandlers:{onSuccessResponse:function(e){c.emit("requestSucceeded",{response:e})},onErrorResponse:function(e){c.emit("requestFailed",{response:e,cause:a.causes.REJECTED})},onTransportError:function(){s.call(c),c.emit("requestFailed",{response:null,cause:a.causes.CONNECTION_ERROR})},onRequestTimeout:function(){s.call(c),c.emit("requestFailed",{response:null,cause:a.causes.REQUEST_TIMEOUT})},onDialogError:function(){s.call(c),c.emit("requestFailed",{response:null,cause:a.causes.DIALOG_ERROR})}}}),this.outgoingRequest=p.outgoingRequest},r.prototype.receiveNotify=function(e){u("receiveNotify()");var t;if(e.body){if(-1===(t=c.parse(e.body,"Status_Line")))return void u('receiveNotify() | error parsing NOTIFY body: "'+e.body+'"');switch(!0){case/^100$/.test(t.status_code):this.emit("trying",{request:e,status_line:t});break;case/^1[0-9]{2}$/.test(t.status_code):this.emit("progress",{request:e,status_line:t});break;case/^2[0-9]{2}$/.test(t.status_code):s.call(this),this.emit("accepted",{request:e,status_line:t});break;default:s.call(this),this.emit("failed",{request:e,status_line:t})}}}},{"../Constants":1,"../Grammar":6,"./Request":15,debug:29,events:31,util:46}],15:[function(e,t,n){function r(e,t){if(s("new | %s",t),this.session=e,this.method=t,this.outgoingRequest=null,this.session.status!==u.C.STATUS_1XX_RECEIVED&&this.session.status!==u.C.STATUS_PROGRESS_RECEIVED&&this.session.status!==u.C.STATUS_WAITING_FOR_ANSWER&&this.session.status!==u.C.STATUS_WAITING_FOR_ACK&&this.session.status!==u.C.STATUS_CONFIRMED&&this.session.status!==u.C.STATUS_TERMINATED)throw new o.InvalidStateError(this.session.status);if(this.session.status===u.C.STATUS_TERMINATED&&t!==l.BYE&&t!==l.ACK)throw new o.InvalidStateError(this.session.status)}t.exports=r;var s=e("debug")("JsSIP:RTCSession:Request"),i=e("debug")("JsSIP:ERROR:RTCSession:Request");i.log=console.warn.bind(console);var l=e("../Constants"),o=e("../Exceptions"),u=e("../RTCSession");r.prototype.send=function(e){e=e||{};var t=e.extraHeaders&&e.extraHeaders.slice()||[],n=e.body||null,r=e.dialog||this.session.dialog;this.eventHandlers=e.eventHandlers||{},this.outgoingRequest=r.sendRequest(this,this.method,{extraHeaders:t,body:n})},r.prototype.receiveResponse=function(e){switch(!0){case/^1[0-9]{2}$/.test(e.status_code):s("onProgressResponse"),this.eventHandlers.onProgressResponse&&this.eventHandlers.onProgressResponse(e);break;case/^2[0-9]{2}$/.test(e.status_code):s("onSuccessResponse"),this.eventHandlers.onSuccessResponse&&this.eventHandlers.onSuccessResponse(e);break;default:s("onErrorResponse"),this.eventHandlers.onErrorResponse&&this.eventHandlers.onErrorResponse(e)}},r.prototype.onRequestTimeout=function(){i("onRequestTimeout"),this.eventHandlers.onRequestTimeout&&this.eventHandlers.onRequestTimeout()},r.prototype.onTransportError=function(){i("onTransportError"),this.eventHandlers.onTransportError&&this.eventHandlers.onTransportError()},r.prototype.onDialogError=function(){i("onDialogError"),this.eventHandlers.onDialogError&&this.eventHandlers.onDialogError()}},{"../Constants":1,"../Exceptions":5,"../RTCSession":11,debug:29}],16:[function(e,t,n){function r(e,t){this.ua=e,this.transport=t,this.registrar=e.configuration.registrar_server,this.expires=e.configuration.register_expires,this.call_id=i.createRandomToken(22),this.cseq=0,this.to_uri=e.configuration.uri,this.registrationTimer=null,this.registered=!1,this.contact=this.ua.contact.toString(),this.contact+=";+sip.ice",this.extraHeaders=[],this.extraContactParams=""}t.exports=r;var s=e("debug")("JsSIP:Registrator"),i=e("./Utils"),l=e("./Constants"),o=e("./SIPMessage"),u=e("./RequestSender");r.prototype={setExtraHeaders:function(e){Array.isArray(e)||(e=[]),this.extraHeaders=e.slice()},setExtraContactParams:function(e){e instanceof Object||(e={}),this.extraContactParams="";for(var t in e){var n=e[t];this.extraContactParams+=";"+t,n&&(this.extraContactParams+="="+n)}},register:function(){var e,t,n,r=this;n=this.extraHeaders.slice(),n.push("Contact: "+this.contact+";expires="+this.expires+this.extraContactParams),n.push("Expires: "+this.expires),this.request=new o.OutgoingRequest(l.REGISTER,this.registrar,this.ua,{to_uri:this.to_uri,call_id:this.call_id,cseq:this.cseq+=1},n),e=new u(this,this.ua),this.receiveResponse=function(e){var n,o,u=e.getHeaders("contact").length;if(e.cseq===this.cseq)switch(null!==this.registrationTimer&&(clearTimeout(this.registrationTimer),this.registrationTimer=null),!0){case/^1[0-9]{2}$/.test(e.status_code):break;case/^2[0-9]{2}$/.test(e.status_code):if(e.hasHeader("expires")&&(o=e.getHeader("expires")),!u){s("no Contact header in response to REGISTER, response ignored");break}for(;u--;){if(n=e.parseHeader("contact",u),n.uri.user===this.ua.contact.uri.user){o=n.getParam("expires");break}n=null}if(!n){s("no Contact header pointing to us, response ignored");break}o||(o=this.expires),this.registrationTimer=setTimeout(function(){r.registrationTimer=null,r.register()},1e3*o-3e3),n.hasParam("temp-gruu")&&(this.ua.contact.temp_gruu=n.getParam("temp-gruu").replace(/"/g,"")),n.hasParam("pub-gruu")&&(this.ua.contact.pub_gruu=n.getParam("pub-gruu").replace(/"/g,"")),this.registered||(this.registered=!0,this.ua.registered({response:e}));break;case/^423$/.test(e.status_code):e.hasHeader("min-expires")?(this.expires=e.getHeader("min-expires"),this.register()):(s("423 response received for REGISTER without Min-Expires"),this.registrationFailure(e,l.causes.SIP_FAILURE_CODE));break;default:t=i.sipErrorCause(e.status_code),this.registrationFailure(e,t)}},this.onRequestTimeout=function(){this.registrationFailure(null,l.causes.REQUEST_TIMEOUT)},this.onTransportError=function(){this.registrationFailure(null,l.causes.CONNECTION_ERROR)},e.send()},unregister:function(e){var t;if(!this.registered)return void s("already unregistered");e=e||{},this.registered=!1,null!==this.registrationTimer&&(clearTimeout(this.registrationTimer),this.registrationTimer=null),t=this.extraHeaders.slice(),e.all?(t.push("Contact: *"+this.extraContactParams),t.push("Expires: 0"),this.request=new o.OutgoingRequest(l.REGISTER,this.registrar,this.ua,{to_uri:this.to_uri,call_id:this.call_id,cseq:this.cseq+=1},t)):(t.push("Contact: "+this.contact+";expires=0"+this.extraContactParams),t.push("Expires: 0"),this.request=new o.OutgoingRequest(l.REGISTER,this.registrar,this.ua,{to_uri:this.to_uri,call_id:this.call_id,cseq:this.cseq+=1},t));var n=new u(this,this.ua);this.receiveResponse=function(e){var t;switch(!0){case/^1[0-9]{2}$/.test(e.status_code):break;case/^2[0-9]{2}$/.test(e.status_code):this.unregistered(e);break;default:t=i.sipErrorCause(e.status_code),this.unregistered(e,t)}},this.onRequestTimeout=function(){this.unregistered(null,l.causes.REQUEST_TIMEOUT)},this.onTransportError=function(){this.unregistered(null,l.causes.CONNECTION_ERROR)},n.send()},registrationFailure:function(e,t){this.ua.registrationFailed({response:e||null,cause:t}),this.registered&&(this.registered=!1,this.ua.unregistered({response:e||null,cause:t}))},unregistered:function(e,t){this.registered=!1,this.ua.unregistered({response:e||null,cause:t||null})},onTransportClosed:function(){null!==this.registrationTimer&&(clearTimeout(this.registrationTimer),this.registrationTimer=null),this.registered&&(this.registered=!1,this.ua.unregistered({}))},close:function(){this.registered&&this.unregister()}}},{"./Constants":1,"./RequestSender":17,"./SIPMessage":18,"./Utils":25,debug:29}],17:[function(e,t,n){function r(e,t){this.ua=t,this.applicant=e,this.method=e.request.method,this.request=e.request,this.auth=null,this.challenged=!1,this.staled=!1,t.status!==l.C.STATUS_USER_CLOSED||this.method===i.BYE&&this.method===i.ACK||this.onTransportError()}t.exports=r;var s=e("debug")("JsSIP:RequestSender"),i=e("./Constants"),l=e("./UA"),o=e("./DigestAuthentication"),u=e("./Transactions");r.prototype={send:function(){switch(this.method){case"INVITE":this.clientTransaction=new u.InviteClientTransaction(this,this.request,this.ua.transport);break;case"ACK":this.clientTransaction=new u.AckClientTransaction(this,this.request,this.ua.transport);break;default:this.clientTransaction=new u.NonInviteClientTransaction(this,this.request,this.ua.transport)}this.clientTransaction.send()},onRequestTimeout:function(){this.applicant.onRequestTimeout()},onTransportError:function(){this.applicant.onTransportError()},receiveResponse:function(e){var t,n,r,l=e.status_code;if(401!==l&&407!==l||null===this.ua.configuration.password&&null===this.ua.configuration.ha1)this.applicant.receiveResponse(e);else{if(401===e.status_code?(n=e.parseHeader("www-authenticate"),r="authorization"):(n=e.parseHeader("proxy-authenticate"),r="proxy-authorization"),!n)return s(e.status_code+" with wrong or missing challenge, cannot authenticate"),void this.applicant.receiveResponse(e);if(!this.challenged||!this.staled&&!0===n.stale){if(this.auth||(this.auth=new o({username:this.ua.configuration.authorization_user,password:this.ua.configuration.password,realm:this.ua.configuration.realm,ha1:this.ua.configuration.ha1})),!this.auth.authenticate(this.request,n))return void this.applicant.receiveResponse(e);this.challenged=!0,this.ua.set("realm",this.auth.get("realm")),this.ua.set("ha1",this.auth.get("ha1")),n.stale&&(this.staled=!0),t=e.method===i.REGISTER?this.applicant.cseq+=1:this.request.dialog?this.request.dialog.local_seqnum+=1:this.request.cseq+1,this.request=this.applicant.request=this.request.clone(),this.request.cseq=t,this.request.setHeader("cseq",t+" "+this.method),this.request.setHeader(r,this.auth.toString()),this.send()}else this.applicant.receiveResponse(e)}}}},{"./Constants":1,"./DigestAuthentication":4,"./Transactions":21,"./UA":23,debug:29}],18:[function(e,t,n){function r(e,t,n,r,s,i){var l,o,u,d;if(r=r||{},!e||!t||!n)return null;this.ua=n,this.headers={},this.method=e,this.ruri=t,this.body=i,this.extraHeaders=s&&s.slice()||[],r.route_set?this.setHeader("route",r.route_set):n.configuration.use_preloaded_route&&this.setHeader("route","<"+n.transport.sip_uri+";lr>"),this.setHeader("via",""),this.setHeader("max-forwards",a.MAX_FORWARDS),l=r.to_display_name||0===r.to_display_name?'"'+r.to_display_name+'" ':"",l+="<"+(r.to_uri||t)+">",l+=r.to_tag?";tag="+r.to_tag:"",this.to=new h.parse(l),this.setHeader("to",l),o=r.from_display_name||0===r.from_display_name?'"'+r.from_display_name+'" ':n.configuration.display_name?'"'+n.configuration.display_name+'" ':"",o+="<"+(r.from_uri||n.configuration.uri)+">;tag=",o+=r.from_tag||c.newTag(),this.from=new h.parse(o),this.setHeader("from",o),u=r.call_id||n.configuration.jssip_id+c.createRandomToken(15),this.call_id=u,this.setHeader("call-id",u),d=r.cseq||Math.floor(1e4*Math.random()),this.cseq=d,this.setHeader("cseq",d+" "+e)}function s(){this.data=null,this.headers=null,this.method=null,this.via=null,this.via_branch=null,this.call_id=null,this.cseq=null,this.rseq=null,this.from=null,this.from_tag=null,this.to=null,this.to_tag=null,this.supported=[],this.require=[],this.body=null,this.sdp=null}function i(e){this.ua=e,this.headers={},this.ruri=null,this.transport=null,this.server_transaction=null}function l(){this.headers={},this.status_code=null,this.reason_phrase=null}t.exports={OutgoingRequest:r,IncomingRequest:i,IncomingResponse:l};var o=e("debug")("JsSIP:SIPMessage"),u=e("sdp-transform"),a=e("./Constants"),c=e("./Utils"),h=e("./NameAddrHeader"),d=e("./Grammar");r.prototype={setHeader:function(e,t){var n,r;for(n=new RegExp("^\\s*"+e+"\\s*:","i"),
r=0;r<this.extraHeaders.length;r++)n.test(this.extraHeaders[r])&&this.extraHeaders.splice(r,1);this.headers[c.headerize(e)]=Array.isArray(t)?t:[t]},getHeader:function(e){var t,n,r=this.extraHeaders.length,s=this.headers[c.headerize(e)];if(s){if(s[0])return s[0]}else for(t=new RegExp("^\\s*"+e+"\\s*:","i"),n=0;n<r;n++)if(s=this.extraHeaders[n],t.test(s))return s.substring(s.indexOf(":")+1).trim()},getHeaders:function(e){var t,n,r,s=this.headers[c.headerize(e)],i=[];if(s){for(n=s.length,t=0;t<n;t++)i.push(s[t]);return i}for(n=this.extraHeaders.length,r=new RegExp("^\\s*"+e+"\\s*:","i"),t=0;t<n;t++)s=this.extraHeaders[t],r.test(s)&&i.push(s.substring(s.indexOf(":")+1).trim());return i},hasHeader:function(e){var t,n,r=this.extraHeaders.length;if(this.headers[c.headerize(e)])return!0;for(t=new RegExp("^\\s*"+e+"\\s*:","i"),n=0;n<r;n++)if(t.test(this.extraHeaders[n]))return!0;return!1},parseSDP:function(e){return!e&&this.sdp?this.sdp:(this.sdp=u.parse(this.body||""),this.sdp)},toString:function(){var e,t,n,r="",s=[];r+=this.method+" "+this.ruri+" SIP/2.0\r\n";for(e in this.headers)for(t=this.headers[e].length,n=0;n<t;n++)r+=e+": "+this.headers[e][n]+"\r\n";for(t=this.extraHeaders.length,n=0;n<t;n++)r+=this.extraHeaders[n].trim()+"\r\n";switch(this.method){case a.REGISTER:s.push("path","gruu");break;case a.INVITE:this.ua.configuration.session_timers&&s.push("timer"),(this.ua.contact.pub_gruu||this.ua.contact.temp_gruu)&&s.push("gruu"),s.push("ice","replaces");break;case a.UPDATE:this.ua.configuration.session_timers&&s.push("timer"),s.push("ice")}return r+="Allow: "+a.ALLOWED_METHODS+"\r\n",s.length&&(r+="Supported: "+s+"\r\n"),r+="User-Agent: "+a.USER_AGENT+"\r\n",this.body?(t=c.str_utf8_length(this.body),r+="Content-Length: "+t+"\r\n\r\n",r+=this.body):r+="Content-Length: 0\r\n\r\n",r},clone:function(){var e=new r(this.method,this.ruri,this.ua);return Object.keys(this.headers).forEach(function(t){e.headers[t]=this.headers[t].slice()},this),e.body=this.body,e.extraHeaders=this.extraHeaders&&this.extraHeaders.slice()||[],e.to=this.to,e.from=this.from,e.call_id=this.call_id,e.cseq=this.cseq,e}},s.prototype={addHeader:function(e,t){var n={raw:t};e=c.headerize(e),this.headers[e]?this.headers[e].push(n):this.headers[e]=[n]},getHeader:function(e){var t=this.headers[c.headerize(e)];if(t)return t[0]?t[0].raw:void 0},getHeaders:function(e){var t,n,r=this.headers[c.headerize(e)],s=[];if(!r)return[];for(n=r.length,t=0;t<n;t++)s.push(r[t].raw);return s},hasHeader:function(e){return!!this.headers[c.headerize(e)]},parseHeader:function(e,t){var n,r,s;return e=c.headerize(e),t=t||0,this.headers[e]?t>=this.headers[e].length?void o('not so many "'+e+'" headers present'):(n=this.headers[e][t],r=n.raw,n.parsed?n.parsed:(s=d.parse(r,e.replace(/-/g,"_")),-1===s?(this.headers[e].splice(t,1),void o('error parsing "'+e+'" header field with value "'+r+'"')):(n.parsed=s,s))):void o('header "'+e+'" not present')},s:function(e,t){return this.parseHeader(e,t)},setHeader:function(e,t){var n={raw:t};this.headers[c.headerize(e)]=[n]},parseSDP:function(e){return!e&&this.sdp?this.sdp:(this.sdp=u.parse(this.body||""),this.sdp)},toString:function(){return this.data}},i.prototype=new s,i.prototype.reply=function(e,t,n,r,s,i){var l,o,u,h,d,p,f=[],m=[],g=this.getHeader("To"),T=0,v=0;if(e=e||null,t=t||null,!e||e<100||e>699)throw new TypeError("Invalid status_code: "+e);if(t&&"string"!=typeof t&&!(t instanceof String))throw new TypeError("Invalid reason_phrase: "+t);if(t=t||a.REASON_PHRASE[e]||"",n=n&&n.slice()||[],d="SIP/2.0 "+e+" "+t+"\r\n",this.method===a.INVITE&&e>100&&e<=200)for(l=this.getHeaders("record-route"),u=l.length,T;T<u;T++)d+="Record-Route: "+l[T]+"\r\n";for(o=this.getHeaders("via"),u=o.length,v;v<u;v++)d+="Via: "+o[v]+"\r\n";for(!this.to_tag&&e>100?g+=";tag="+c.newTag():this.to_tag&&!this.s("to").hasParam("tag")&&(g+=";tag="+this.to_tag),d+="To: "+g+"\r\n",d+="From: "+this.getHeader("From")+"\r\n",d+="Call-ID: "+this.call_id+"\r\n",d+="CSeq: "+this.cseq+" "+this.method+"\r\n",-1===this.supported.indexOf("100rel")&&-1===this.require.indexOf("100rel")||(p=this.server_transaction.getNextRSeq(),m.push("100rel"),d+="RSeq: "+p+"\r\n"),u=n.length,h=0;h<u;h++)d+=n[h].trim()+"\r\n";switch(this.method){case a.INVITE:this.ua.configuration.session_timers&&f.push("timer"),(this.ua.contact.pub_gruu||this.ua.contact.temp_gruu)&&f.push("gruu"),f.push("ice","replaces");break;case a.UPDATE:this.ua.configuration.session_timers&&f.push("timer"),r&&f.push("ice"),f.push("replaces")}this.method===a.OPTIONS?(d+="Allow: "+a.ALLOWED_METHODS+"\r\n",d+="Accept: "+a.ACCEPTED_BODY_TYPES+"\r\n"):405===e?d+="Allow: "+a.ALLOWED_METHODS+"\r\n":415===e&&(d+="Accept: "+a.ACCEPTED_BODY_TYPES+"\r\n"),f.length&&(d+="Supported: "+f+"\r\n"),m.length&&(d+="Require: "+m+"\r\n"),r?(u=c.str_utf8_length(r),d+="Content-Type: application/sdp\r\n",d+="Content-Length: "+u+"\r\n\r\n",d+=r):d+="Content-Length: 0\r\n\r\n",this.server_transaction.receiveResponse(e,d,s,i,p)},i.prototype.reply_sl=function(e,t){var n,r,s=0,i=this.getHeaders("via"),l=i.length;if(e=e||null,t=t||null,!e||e<100||e>699)throw new TypeError("Invalid status_code: "+e);if(t&&"string"!=typeof t&&!(t instanceof String))throw new TypeError("Invalid reason_phrase: "+t);for(t=t||a.REASON_PHRASE[e]||"",r="SIP/2.0 "+e+" "+t+"\r\n",s;s<l;s++)r+="Via: "+i[s]+"\r\n";n=this.getHeader("To"),!this.to_tag&&e>100?n+=";tag="+c.newTag():this.to_tag&&!this.s("to").hasParam("tag")&&(n+=";tag="+this.to_tag),r+="To: "+n+"\r\n",r+="From: "+this.getHeader("From")+"\r\n",r+="Call-ID: "+this.call_id+"\r\n",r+="CSeq: "+this.cseq+" "+this.method+"\r\n",r+="Content-Length: 0\r\n\r\n",this.transport.send(r)},l.prototype=new s},{"./Constants":1,"./Grammar":6,"./NameAddrHeader":9,"./Utils":25,debug:29,"sdp-transform":42}],19:[function(e,t,n){function r(){}t.exports=r;var s=e("./Utils"),i=e("./Grammar"),l=e("debug")("JsSIP:ERROR:Socket");l.log=console.warn.bind(console),r.isSocket=function(e){if(Array.isArray(e))return!1;if(void 0===e)return l("undefined JsSIP.Socket instance"),!1;try{if(!s.isString(e.url))throw l("missing or invalid JsSIP.Socket url property"),new Error;if(!s.isString(e.via_transport))throw l("missing or invalid JsSIP.Socket via_transport property"),new Error;if(-1===i.parse(e.sip_uri,"SIP_URI"))throw l("missing or invalid JsSIP.Socket sip_uri property"),new Error}catch(e){return!1}try{["connect","disconnect","send"].forEach(function(t){if(!s.isFunction(e[t]))throw l("missing or invalid JsSIP.Socket method: "+t),new Error})}catch(e){return!1}return!0}},{"./Grammar":6,"./Utils":25,debug:29}],20:[function(e,t,n){var r=500,s={T1:r,T2:4e3,T4:5e3,TIMER_B:32e3,TIMER_D:0,TIMER_F:32e3,TIMER_H:32e3,TIMER_I:0,TIMER_J:0,TIMER_K:0,TIMER_L:32e3,TIMER_M:32e3,PROVISIONAL_RESPONSE_INTERVAL:6e4};t.exports=s},{}],21:[function(e,t,n){function r(e,t,n){var r;this.type=a.NON_INVITE_CLIENT,this.transport=n,this.id="z9hG4bK"+Math.floor(1e7*Math.random()),this.request_sender=e,this.request=t,r="SIP/2.0/"+n.via_transport,r+=" "+e.ua.configuration.via_host+";branch="+this.id,this.request.setHeader("via",r),this.request_sender.ua.newTransaction(this),h.EventEmitter.call(this)}function s(e,t,n){var r,s=this;this.type=a.INVITE_CLIENT,this.transport=n,this.id="z9hG4bK"+Math.floor(1e7*Math.random()),this.request_sender=e,this.request=t,r="SIP/2.0/"+n.via_transport,r+=" "+e.ua.configuration.via_host+";branch="+this.id,this.request.setHeader("via",r),this.request_sender.ua.newTransaction(this),this.request.cancel=function(e){s.cancel_request(s,e)},h.EventEmitter.call(this)}function i(e,t,n){var r;this.transport=n,this.id="z9hG4bK"+Math.floor(1e7*Math.random()),this.request_sender=e,this.request=t,r="SIP/2.0/"+n.via_transport,r+=" "+e.ua.configuration.via_host+";branch="+this.id,this.request.setHeader("via",r),h.EventEmitter.call(this)}function l(e,t){this.type=a.NON_INVITE_SERVER,this.id=e.via_branch,this.request=e,this.transport=e.transport,this.ua=t,this.last_response="",e.server_transaction=this,this.state=a.STATUS_TRYING,t.newTransaction(this),h.EventEmitter.call(this)}function o(e,t){this.type=a.INVITE_SERVER,this.id=e.via_branch,this.request=e,this.transport=e.transport,this.ua=t,this.last_response="",this.resend100relTimers={},e.server_transaction=this,this.state=a.STATUS_PROCEEDING,t.newTransaction(this),this.resendProvisionalTimer=null,e.reply(100),h.EventEmitter.call(this)}function u(e,t){var n;switch(t.method){case T.INVITE:if(n=e.transactions.ist[t.via_branch]){switch(n.state){case a.STATUS_PROCEEDING:n.transport.send(n.last_response);break;case a.STATUS_ACCEPTED:}return!0}break;case T.ACK:if(!(n=e.transactions.ist[t.via_branch]))return!1;if(n.state===a.STATUS_ACCEPTED)return!1;if(n.state===a.STATUS_COMPLETED)return n.state=a.STATUS_CONFIRMED,n.I=setTimeout(function(){n.timer_I()},v.TIMER_I),!0;break;case T.CANCEL:return n=e.transactions.ist[t.via_branch],n?(t.reply_sl(200),n.state!==a.STATUS_PROCEEDING):(t.reply_sl(481),!0);default:if(n=e.transactions.nist[t.via_branch]){switch(n.state){case a.STATUS_TRYING:break;case a.STATUS_PROCEEDING:case a.STATUS_COMPLETED:n.transport.send(n.last_response)}return!0}}}t.exports={C:null,NonInviteClientTransaction:r,InviteClientTransaction:s,AckClientTransaction:i,NonInviteServerTransaction:l,InviteServerTransaction:o,checkTransaction:u};var a={STATUS_TRYING:1,STATUS_PROCEEDING:2,STATUS_CALLING:3,STATUS_ACCEPTED:4,STATUS_COMPLETED:5,STATUS_TERMINATED:6,STATUS_CONFIRMED:7,NON_INVITE_CLIENT:"nict",NON_INVITE_SERVER:"nist",INVITE_CLIENT:"ict",INVITE_SERVER:"ist"};t.exports.C=a;var c=e("util"),h=e("events"),d=e("debug")("JsSIP:NonInviteClientTransaction"),p=e("debug")("JsSIP:InviteClientTransaction"),f=e("debug")("JsSIP:AckClientTransaction"),m=e("debug")("JsSIP:NonInviteServerTransaction"),g=e("debug")("JsSIP:InviteServerTransaction"),T=e("./Constants"),v=e("./Timers"),_=e("./Utils");c.inherits(r,h.EventEmitter),r.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},r.prototype.send=function(){var e=this;this.stateChanged(a.STATUS_TRYING),this.F=setTimeout(function(){e.timer_F()},v.TIMER_F),this.transport.send(this.request)||this.onTransportError()},r.prototype.onTransportError=function(){d("transport error occurred, deleting transaction "+this.id),clearTimeout(this.F),clearTimeout(this.K),this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.request_sender.onTransportError()},r.prototype.timer_F=function(){d("Timer F expired for transaction "+this.id),this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.request_sender.onRequestTimeout()},r.prototype.timer_K=function(){this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this)},r.prototype.receiveResponse=function(e){var t=this,n=e.status_code;if(n<200)switch(this.state){case a.STATUS_TRYING:case a.STATUS_PROCEEDING:this.stateChanged(a.STATUS_PROCEEDING),this.request_sender.receiveResponse(e)}else switch(this.state){case a.STATUS_TRYING:case a.STATUS_PROCEEDING:this.stateChanged(a.STATUS_COMPLETED),clearTimeout(this.F),408===n?this.request_sender.onRequestTimeout():this.request_sender.receiveResponse(e),this.K=setTimeout(function(){t.timer_K()},v.TIMER_K);break;case a.STATUS_COMPLETED:}},c.inherits(s,h.EventEmitter),s.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},s.prototype.send=function(){var e=this;this.stateChanged(a.STATUS_CALLING),this.B=setTimeout(function(){e.timer_B()},v.TIMER_B),this.transport.send(this.request)||this.onTransportError()},s.prototype.onTransportError=function(){clearTimeout(this.B),clearTimeout(this.D),clearTimeout(this.M),this.state!==a.STATUS_ACCEPTED&&(p("transport error occurred, deleting transaction "+this.id),this.request_sender.onTransportError()),this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this)},s.prototype.timer_M=function(){p("Timer M expired for transaction "+this.id),this.state===a.STATUS_ACCEPTED&&(clearTimeout(this.B),this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this))},s.prototype.timer_B=function(){p("Timer B expired for transaction "+this.id),this.state===a.STATUS_CALLING&&(this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this),this.request_sender.onRequestTimeout())},s.prototype.timer_D=function(){p("Timer D expired for transaction "+this.id),clearTimeout(this.B),this.stateChanged(a.STATUS_TERMINATED),this.request_sender.ua.destroyTransaction(this)},s.prototype.sendACK=function(e){var t=this;this.ack="ACK "+this.request.ruri+" SIP/2.0\r\n",this.ack+="Via: "+this.request.headers.Via.toString()+"\r\n",this.request.headers.Route&&(this.ack+="Route: "+this.request.headers.Route.toString()+"\r\n"),this.ack+="To: "+e.getHeader("to")+"\r\n",this.ack+="From: "+this.request.headers.From.toString()+"\r\n",this.ack+="Call-ID: "+this.request.headers["Call-ID"].toString()+"\r\n",this.ack+="CSeq: "+this.request.headers.CSeq.toString().split(" ")[0],this.ack+=" ACK\r\n",this.ack+="Content-Length: 0\r\n\r\n",this.D=setTimeout(function(){t.timer_D()},v.TIMER_D),this.transport.send(this.ack)},s.prototype.cancel_request=function(e,t){var n=e.request;this.cancel=T.CANCEL+" "+n.ruri+" SIP/2.0\r\n",this.cancel+="Via: "+n.headers.Via.toString()+"\r\n",this.request.headers.Route&&(this.cancel+="Route: "+n.headers.Route.toString()+"\r\n"),this.cancel+="To: "+n.headers.To.toString()+"\r\n",this.cancel+="From: "+n.headers.From.toString()+"\r\n",this.cancel+="Call-ID: "+n.headers["Call-ID"].toString()+"\r\n",this.cancel+="CSeq: "+n.headers.CSeq.toString().split(" ")[0]+" CANCEL\r\n",t&&(this.cancel+="Reason: "+t+"\r\n"),this.cancel+="Content-Length: 0\r\n\r\n",this.state===a.STATUS_PROCEEDING&&this.transport.send(this.cancel)},s.prototype.receiveResponse=function(e){var t=this,n=e.status_code;if(n>=100&&n<=199)switch(this.state){case a.STATUS_CALLING:this.stateChanged(a.STATUS_PROCEEDING),this.request_sender.receiveResponse(e);break;case a.STATUS_PROCEEDING:this.request_sender.receiveResponse(e)}else if(n>=200&&n<=299)switch(this.state){case a.STATUS_CALLING:case a.STATUS_PROCEEDING:this.stateChanged(a.STATUS_ACCEPTED),this.M=setTimeout(function(){t.timer_M()},v.TIMER_M),this.request_sender.receiveResponse(e);break;case a.STATUS_ACCEPTED:this.request_sender.receiveResponse(e)}else if(n>=300&&n<=699)switch(this.state){case a.STATUS_CALLING:case a.STATUS_PROCEEDING:this.stateChanged(a.STATUS_COMPLETED),this.sendACK(e),this.request_sender.receiveResponse(e);break;case a.STATUS_COMPLETED:this.sendACK(e)}},c.inherits(i,h.EventEmitter),i.prototype.send=function(){this.transport.send(this.request)||this.onTransportError()},i.prototype.onTransportError=function(){f("transport error occurred for transaction "+this.id),this.request_sender.onTransportError()},c.inherits(l,h.EventEmitter),l.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},l.prototype.timer_J=function(){m("Timer J expired for transaction "+this.id),this.stateChanged(a.STATUS_TERMINATED),this.ua.destroyTransaction(this)},l.prototype.onTransportError=function(){this.transportError||(this.transportError=!0,m("transport error occurred, deleting transaction "+this.id),clearTimeout(this.J),this.stateChanged(a.STATUS_TERMINATED),this.ua.destroyTransaction(this))},l.prototype.receiveResponse=function(e,t,n,r){var s=this;if(100===e)switch(this.state){case a.STATUS_TRYING:this.stateChanged(a.STATUS_PROCEEDING),this.transport.send(t)||this.onTransportError();break;case a.STATUS_PROCEEDING:this.last_response=t,this.transport.send(t)?n&&n():(this.onTransportError(),r&&r())}else if(e>=200&&e<=699)switch(this.state){case a.STATUS_TRYING:case a.STATUS_PROCEEDING:this.stateChanged(a.STATUS_COMPLETED),this.last_response=t,this.J=setTimeout(function(){s.timer_J()},v.TIMER_J),this.transport.send(t)?n&&n():(this.onTransportError(),r&&r());break;case a.STATUS_COMPLETED:}},c.inherits(o,h.EventEmitter),o.prototype.stateChanged=function(e){this.state=e,this.emit("stateChanged")},o.prototype.timer_H=function(){g("Timer H expired for transaction "+this.id),this.state===a.STATUS_COMPLETED&&g("ACK not received, dialog will be terminated"),this.stateChanged(a.STATUS_TERMINATED),this.ua.destroyTransaction(this)},o.prototype.timer_I=function(){this.stateChanged(a.STATUS_TERMINATED)},o.prototype.timer_L=function(){g("Timer L expired for transaction "+this.id),this.state===a.STATUS_ACCEPTED&&(this.stateChanged(a.STATUS_TERMINATED),this.ua.destroyTransaction(this))},o.prototype.onTransportError=function(){if(!this.transportError){this.transportError=!0,g("transport error occurred, deleting transaction "+this.id),null!==this.resendProvisionalTimer&&(clearInterval(this.resendProvisionalTimer),this.resendProvisionalTimer=null),clearTimeout(this.L),clearTimeout(this.H),clearTimeout(this.I);for(var e in this.resend100relTimers)clearTimeout(this.resend100relTimers[e]),delete this.resend100relTimers[e];this.stateChanged(a.STATUS_TERMINATED),this.ua.destroyTransaction(this)}},o.prototype.resend_provisional=function(e){e=e||this.last_response,this.transport.send(e)||this.onTransportError()},o.prototype.getNextRSeq=function(){var e=this.rseq||null;return null===e&&(this.rseq=e=_.getRandomInt(0,Math.pow(2,31)-2)),this.rseq=e+1,this.rseq},o.prototype.acknowledge100rel=function(e){var t=this.resend100relTimers[e.rvalue]||null;return null!==t&&clearTimeout(t),delete this.resend100relTimers[e.rvalue],null!==t},o.prototype.receiveResponse=function(e,t,n,r,s){var i=this;if(s=s||0,e>=100&&e<=199)switch(this.state){case a.STATUS_PROCEEDING:this.transport.send(t)||this.onTransportError(),this.last_response=t}if(s>0&&e>100&&e<=199&&this.state===a.STATUS_PROCEEDING){var l=function(e,t){i.resend_provisional(t);var n=Math.min(v.T2,2*e),r=i.resend100relTimers[s]||null;null!==r&&(i.resend100relTimers[s]=setTimeout(function(){r(n,t)},n))};this.resend100relTimers[s]=setTimeout(function(){l(v.T1,t)},v.T1)}else if(e>100&&e<=199&&this.state===a.STATUS_PROCEEDING)null===this.resendProvisionalTimer&&(this.resendProvisionalTimer=setInterval(function(){i.resend_provisional()},v.PROVISIONAL_RESPONSE_INTERVAL));else if(e>=200&&e<=299)switch(this.state){case a.STATUS_PROCEEDING:this.stateChanged(a.STATUS_ACCEPTED),this.last_response=t,this.L=setTimeout(function(){i.timer_L()},v.TIMER_L),null!==this.resendProvisionalTimer&&(clearInterval(this.resendProvisionalTimer),this.resendProvisionalTimer=null);case a.STATUS_ACCEPTED:this.transport.send(t)?n&&n():(this.onTransportError(),r&&r())}else if(e>=300&&e<=699)switch(this.state){case a.STATUS_PROCEEDING:null!==this.resendProvisionalTimer&&(clearInterval(this.resendProvisionalTimer),this.resendProvisionalTimer=null),this.transport.send(t)?(this.stateChanged(a.STATUS_COMPLETED),this.H=setTimeout(function(){i.timer_H()},v.TIMER_H),n&&n()):(this.onTransportError(),r&&r())}}},{"./Constants":1,"./Timers":20,"./Utils":25,debug:29,events:31,util:46}],22:[function(e,t,n){function r(e,t){if(c("new()"),this.status=d.STATUS_DISCONNECTED,this.socket=null,this.sockets=[],this.recovery_options=t||d.recovery_options,this.recover_attempts=0,this.recovery_timer=null,this.close_requested=!1,void 0===e)throw new TypeError("Invalid argument. undefined 'sockets' argument");e instanceof Array||(e=[e]),e.forEach(function(e){if(!a.isSocket(e.socket))throw new TypeError("Invalid argument. invalid 'JsSIP.Socket' instance");if(e.weight&&!Number(e.weight))throw new TypeError("Invalid argument. 'weight' attribute is not a number");this.sockets.push({socket:e.socket,weight:e.weight||0,status:d.SOCKET_STATUS_READY})},this),Object.defineProperties(this,{via_transport:{get:function(){return this.socket.via_transport}},url:{get:function(){return this.socket.url}},sip_uri:{get:function(){return this.socket.sip_uri}}}),u.call(this)}function s(){this.recover_attempts=0,this.status=d.STATUS_CONNECTED,null!==this.recovery_timer&&(clearTimeout(this.recovery_timer),this.recovery_timer=null),this.onconnect({socket:this})}function i(e,t,n){this.status=d.STATUS_DISCONNECTED,this.ondisconnect({socket:this.socket,error:e,code:t,reason:n}),this.close_requested||(e&&(this.socket.status=d.SOCKET_STATUS_ERROR),o.call(this,e))}function l(e){if("\r\n"===e)return void c("received message with CRLF Keep Alive response");if("string"!=typeof e){try{e=String.fromCharCode.apply(null,new Uint8Array(e))}catch(e){return void c("received binary message failed to be converted into string, message discarded")}c("received binary message:\n\n"+e+"\n")}else c("received text message:\n\n"+e+"\n");this.ondata({transport:this,message:e})}function o(){var e,t=this;this.recover_attempts+=1,e=Math.floor(Math.random()*Math.pow(2,this.recover_attempts)+1),e<this.recovery_options.min_interval?e=this.recovery_options.min_interval:e>this.recovery_options.max_interval&&(e=this.recovery_options.max_interval),c("reconnection attempt: "+this.recover_attempts+". next connection attempt in "+e+" seconds"),this.recovery_timer=setTimeout(function(){t.close_requested||t.isConnected()||t.isConnecting()||(u.call(t),t.connect())},1e3*e)}function u(){var e=[];if(this.sockets.forEach(function(t){t.status!==d.SOCKET_STATUS_ERROR&&(0===e.length?e.push(t):t.weight>e[0].weight?e=[t]:t.weight===e[0].weight&&e.push(t))}),0===e.length)return this.sockets.forEach(function(e){e.status=d.SOCKET_STATUS_READY}),void u.call(this);var t=Math.floor(Math.random()*e.length);this.socket=e[t].socket}t.exports=r;var a=e("./Socket"),c=e("debug")("JsSIP:Transport"),h=e("debug")("JsSIP:ERROR:Transport"),d={STATUS_CONNECTED:0,STATUS_CONNECTING:1,STATUS_DISCONNECTED:2,SOCKET_STATUS_READY:0,SOCKET_STATUS_ERROR:1,recovery_options:{min_interval:2,max_interval:30}};r.prototype.connect=function(){return c("connect()"),this.isConnected()?void c("Transport is already connected"):this.isConnecting()?void c("Transport is connecting"):(this.close_requested=!1,this.status=d.STATUS_CONNECTING,this.onconnecting({socket:this.socket,attempts:this.recover_attempts}),void(this.close_requested||(this.socket.onconnect=s.bind(this),this.socket.ondisconnect=i.bind(this),this.socket.ondata=l.bind(this),this.socket.connect())))},r.prototype.disconnect=function(){c("close()"),this.close_requested=!0,this.recover_attempts=0,this.status=d.STATUS_DISCONNECTED,null!==this.recovery_timer&&(clearTimeout(this.recovery_timer),this.recovery_timer=null),this.socket.onconnect=function(){},this.socket.ondisconnect=function(){},this.socket.ondata=function(){},this.socket.disconnect(),this.ondisconnect()},r.prototype.send=function(e){if(c("send()"),!this.isConnected())return h("unable to send message, transport is not connected"),!1;var t=e.toString();return c("sending message:\n\n"+t+"\n"),this.socket.send(t)},r.prototype.isConnected=function(){return this.status===d.STATUS_CONNECTED},r.prototype.isConnecting=function(){return this.status===d.STATUS_CONNECTING}},{"./Socket":19,debug:29}],23:[function(e,t,n){function r(e){if(h("new() [configuration:%o]",e),this.cache={credentials:{}},this.configuration={},this.dynConfiguration={},this.dialogs={},this.applicants={},this.sessions={},this.transport=null,this.contact=null,this.status=u.STATUS_INIT,this.error=null,this.transactions={nist:{},nict:{},ist:{},ict:{}},this.serverTransactions={},this.data={},Object.defineProperties(this,{transactionsCount:{get:function(){var e,t=["nist","nict","ist","ict"],n=0;for(e in t)n+=Object.keys(this.transactions[t[e]]).length;return n}},nictTransactionsCount:{get:function(){return Object.keys(this.transactions.nict).length}},nistTransactionsCount:{get:function(){return Object.keys(this.transactions.nist).length}},ictTransactionsCount:{get:function(){return Object.keys(this.transactions.ict).length}},istTransactionsCount:{get:function(){return Object.keys(this.transactions.ist).length}}}),void 0===e)throw new TypeError("Not enough arguments");try{this.loadConfig(e)}catch(e){throw this.status=u.STATUS_NOT_READY,this.error=u.CONFIGURATION_ERROR,e}this._registrator=new m(this),c.EventEmitter.call(this),p.called||p()}function s(e){this.emit("connecting",e)}function i(e){this.status!==u.STATUS_USER_CLOSED&&(this.status=u.STATUS_READY,this.error=null,this.emit("connected",e),this.dynConfiguration.register&&this._registrator.register())}function l(e){var t,n,r,s=["nict","ict","nist","ist"];for(r=s.length,t=0;t<r;t++)for(n in this.transactions[s[t]])this.transactions[s[t]][n].onTransportError();this.emit("disconnected",e),this._registrator.onTransportClosed(),this.status!==u.STATUS_USER_CLOSED&&(this.status=u.STATUS_NOT_READY,this.error=u.NETWORK_ERROR)}function o(e){var t,n=e.transport,s=e.message;if((s=b.parseMessage(s,this))&&!(this.status===r.C.STATUS_USER_CLOSED&&s instanceof I.IncomingRequest)&&w(s,this,n))if(s instanceof I.IncomingRequest)s.transport=n,this.receiveRequest(s);else if(s instanceof I.IncomingResponse)switch(s.method){case f.INVITE:t=this.transactions.ict[s.via_branch],t&&t.receiveResponse(s);break;case f.ACK:break;default:t=this.transactions.nict[s.via_branch],t&&t.receiveResponse(s)}}t.exports=r;var u={STATUS_INIT:0,STATUS_READY:1,STATUS_USER_CLOSED:2,STATUS_NOT_READY:3,CONFIGURATION_ERROR:1,NETWORK_ERROR:2};r.C=u;var a=e("util"),c=e("events"),h=e("debug")("JsSIP:UA"),d=e("debug")("JsSIP:ERROR:UA");d.log=console.warn.bind(console);var p=e("rtcninja"),f=e("./Constants"),m=e("./Registrator"),g=e("./RTCSession"),T=e("./Message"),v=e("./Transactions"),_=e("./Transport"),S=e("./WebSocketInterface"),C=e("./Socket"),E=e("./Utils"),A=e("./Exceptions"),y=e("./URI"),R=e("./Grammar"),b=e("./Parser"),I=e("./SIPMessage"),w=e("./sanityCheck");a.inherits(r,c.EventEmitter),r.prototype.start=function(){function e(){h("restarting UA"),t.status=u.STATUS_READY,t.transport.connect()}h("start()");var t=this;this.status===u.STATUS_INIT?this.transport.connect():this.status===u.STATUS_USER_CLOSED?this.isConnected()?this.once("disconnected",e):e():h(this.status===u.STATUS_READY?"UA is in READY status, not restarted":"ERROR: connection is down, Auto-Recovery system is trying to reconnect"),this.dynConfiguration.register=this.configuration.register},r.prototype.register=function(){h("register()"),this.dynConfiguration.register=!0,this._registrator.register()},r.prototype.unregister=function(e){h("unregister()"),this.dynConfiguration.register=!1,this._registrator.unregister(e)},r.prototype.registrator=function(){return this._registrator},r.prototype.isRegistered=function(){return!!this._registrator.registered},r.prototype.isConnected=function(){return this.transport.isConnected()},r.prototype.call=function(e,t){h("call()");var n;return n=new g(this),n.connect(e,t),n},r.prototype.sendMessage=function(e,t,n){h("sendMessage()");var r;return r=new T(this),r.send(e,t,n),r},r.prototype.terminateSessions=function(e){h("terminateSessions()");for(var t in this.sessions)this.sessions[t].isEnded()||this.sessions[t].terminate(e)},r.prototype.stop=function(e){h("stop()");var t,n,r,s=this;if(this.dynConfiguration={},this.status===u.STATUS_USER_CLOSED)return void h("UA already closed");e||this._registrator.close(),r=Object.keys(this.sessions).length;for(t in this.sessions){h("closing session "+t);try{this.sessions[t].terminate()}catch(e){}}for(n in this.applicants)try{this.applicants[n].close()}catch(e){}this.status=u.STATUS_USER_CLOSED,0===this.nistTransactionsCount&&0===this.nictTransactionsCount&&0===this.ictTransactionsCount&&0===this.istTransactionsCount&&0===r?s.transport.disconnect():setTimeout(function(){s.transport.disconnect()},2e3)},r.prototype.normalizeTarget=function(e){return E.normalizeTarget(e,this.configuration.hostport_params)},r.prototype.get=function(e){switch(e){case"realm":return this.configuration.realm;case"ha1":return this.configuration.ha1;default:return void d('get() | cannot get "%s" parameter in runtime',e)}return!0},r.prototype.set=function(e,t){switch(e){case"password":this.configuration.password=String(t);break;case"realm":this.configuration.realm=String(t);break;case"ha1":this.configuration.ha1=String(t),this.configuration.password=null;break;case"display_name":if(-1===R.parse('"'+t+'"',"display_name"))return d('set() | wrong "display_name"'),!1;this.configuration.display_name=t;break;default:return d('set() | cannot set "%s" parameter in runtime',e),!1}return!0},r.prototype.newTransaction=function(e){this.transactions[e.type][e.id]=e,this.emit("newTransaction",{transaction:e})},r.prototype.registerServerTransaction=function(e,t,n,r){this.serverTransactions[e+"-"+t+"-"+n]=r},r.prototype.lookupServerTransaction=function(e,t,n){return this.serverTransactions[e+"-"+t+"-"+n]||null},r.prototype.destroyTransaction=function(e){if(delete this.transactions[e.type][e.id],this.emit("transactionDestroyed",{transaction:e}),e instanceof v.InviteServerTransaction){var t=e.request.to_tag+"-"+e.request.cseq+"-"+e.request.method;delete this.serverTransactions[t]}},r.prototype.newMessage=function(e){this.emit("newMessage",e)},r.prototype.newRTCSession=function(e){this.emit("newRTCSession",e)},r.prototype.registered=function(e){this.emit("registered",e)},r.prototype.unregistered=function(e){this.emit("unregistered",e)},r.prototype.registrationFailed=function(e){this.emit("registrationFailed",e)},r.prototype.receiveRequest=function(e){var t,n,r,s,i=e.method;if(e.ruri.user!==this.configuration.uri.user&&e.ruri.user!==this.contact.uri.user)return h("Request-URI does not point to us"),void(e.method!==f.ACK&&e.reply_sl(404));if(e.ruri.scheme===f.SIPS)return void e.reply_sl(416);if(!v.checkTransaction(this,e)){if(i===f.INVITE?new v.InviteServerTransaction(e,this):i!==f.ACK&&i!==f.CANCEL&&new v.NonInviteServerTransaction(e,this),i===f.OPTIONS)e.reply(200);else if(i===f.MESSAGE){if(0===this.listeners("newMessage").length)return void e.reply(405);r=new T(this),r.init_incoming(e)}else if(i===f.INVITE&&!e.to_tag&&0===this.listeners("newRTCSession").length)return void e.reply(405);if(e.to_tag)t=this.findDialog(e.call_id,e.from_tag,e.to_tag),t?t.receiveRequest(e):i===f.NOTIFY?(n=this.findSession(e),n?n.receiveRequest(e):(h("received NOTIFY request for a non existent subscription"),e.reply(481,"Subscription does not exist"))):i!==f.ACK&&e.reply(481);else switch(i){case f.INVITE:p.hasWebRTC()?e.hasHeader("replaces")?(s=e.replaces,t=this.findDialog(s.call_id,s.from_tag,s.to_tag),t?(n=t.owner,n.isEnded()?e.reply(603):n.receiveRequest(e)):e.reply(481)):(n=new g(this),n.init_incoming(e)):(h("INVITE received but WebRTC is not supported"),e.reply(488));break;case f.BYE:e.reply(481);break;case f.CANCEL:n=this.findSession(e),n?n.receiveRequest(e):h("received CANCEL request for a non existent session");break;case f.ACK:break;default:e.reply(405)}}},r.prototype.findSession=function(e){var t=e.call_id+e.from_tag,n=this.sessions[t],r=e.call_id+e.to_tag,s=this.sessions[r];return n||(s||null)},r.prototype.findDialog=function(e,t,n){var r=e+t+n,s=this.dialogs[r];return s||(r=e+n+t,(s=this.dialogs[r])||null)},r.prototype.loadConfig=function(e){var t,n,u,a,c,p={via_host:E.createRandomToken(12)+".invalid",contact_uri:null,password:null,realm:null,ha1:null,register_expires:600,register:!0,registrar_server:null,use_preloaded_route:!1,no_answer_timeout:60,session_timers:!0,support_100rel:!1};for(t in r.configuration_check.mandatory){if(!e.hasOwnProperty(t))throw new A.ConfigurationError(t);if(n=e[t],void 0===(u=r.configuration_check.mandatory[t].call(this,n)))throw new A.ConfigurationError(t,n);p[t]=u}for(t in r.configuration_check.optional)if(e.hasOwnProperty(t)){if(n=e[t],E.isEmpty(n))continue;if(void 0===(u=r.configuration_check.optional[t].call(this,n,e)))throw new A.ConfigurationError(t,n);p[t]=u}0===p.display_name&&(p.display_name="0"),p.instance_id||(p.instance_id=E.newUUID()),p.jssip_id=E.createRandomToken(5),a=p.uri.clone(),a.user=null,p.hostport_params=a.toString().replace(/^sip:/i,"");var f=[];if(p.ws_servers&&Array.isArray(p.ws_servers)&&(f=f.concat(p.ws_servers)),p.sockets&&Array.isArray(p.sockets)&&(f=f.concat(p.sockets)),
0===f.length)throw new A.ConfigurationError("sockets");try{this.transport=new _(f,{max_interval:p.connection_recovery_max_interval,min_interval:p.connection_recovery_min_interval}),this.transport.onconnecting=s.bind(this),this.transport.onconnect=i.bind(this),this.transport.ondisconnect=l.bind(this),this.transport.ondata=o.bind(this),delete p.connection_recovery_max_interval,delete p.connection_recovery_min_interval,delete p.ws_servers,delete p.sockets}catch(e){throw d(e),new A.ConfigurationError("sockets",f)}p.authorization_user||(p.authorization_user=p.uri.user),p.registrar_server||(c=p.uri.clone(),c.user=null,c.clearParams(),c.clearHeaders(),p.registrar_server=c),p.no_answer_timeout=1e3*p.no_answer_timeout,p.contact_uri?p.via_host=p.contact_uri.host:p.contact_uri=new y("sip",E.createRandomToken(8),p.via_host,null,{transport:"ws"}),this.contact={pub_gruu:null,temp_gruu:null,uri:p.contact_uri,toString:function(e){e=e||{};var t=e.anonymous||null,n=e.outbound||null,r="<";return r+=t?this.temp_gruu||"sip:anonymous@anonymous.invalid;transport=ws":this.pub_gruu||this.uri.toString(),!n||(t?this.temp_gruu:this.pub_gruu)||(r+=";ob"),r+=">",r+=';reg_id=1;+sip.instance="<urn:uuid:'+p.instance_id+'>"'}};for(t in p)r.configuration_skeleton[t].value=p[t];Object.defineProperties(this.configuration,r.configuration_skeleton);for(t in p)r.configuration_skeleton[t].value="";h("configuration parameters after validation:");for(t in p)switch(t){case"uri":case"registrar_server":h("- "+t+": "+p[t]);break;case"password":case"ha1":h("- "+t+": NOT SHOWN");break;default:h("- "+t+": "+JSON.stringify(p[t]))}},r.configuration_skeleton=function(){var e,t,n,r={},s=["jssip_id","hostport_params","uri","authorization_user","contact_uri","display_name","instance_id","no_answer_timeout","session_timers","support_100rel","password","realm","ha1","register_expires","registrar_server","sockets","use_preloaded_route","ws_servers","via_core_value","via_host"],i=["password","realm","ha1","display_name"];for(e in s)t=s[e],n=-1!==i.indexOf(t),r[t]={value:"",writable:n,configurable:!1};return r.register={value:"",writable:!0,configurable:!1},r}(),r.configuration_check={mandatory:{uri:function(e){var t;return/^sip:/i.test(e)||(e=f.SIP+":"+e),t=y.parse(e),t&&t.user?t:void 0}},optional:{authorization_user:function(e){return-1===R.parse('"'+e+'"',"quoted_string")?void 0:e},connection_recovery_max_interval:function(e){var t;if(E.isDecimal(e)&&(t=Number(e))>0)return t},connection_recovery_min_interval:function(e){var t;if(E.isDecimal(e)&&(t=Number(e))>0)return t},contact_uri:function(e){if("string"==typeof e){var t=R.parse(e,"SIP_URI");if(-1!==t)return t}},display_name:function(e){return-1===R.parse('"'+e+'"',"display_name")?void 0:e},instance_id:function(e){return/^uuid:/i.test(e)&&(e=e.substr(5)),-1===R.parse(e,"uuid")?void 0:e},no_answer_timeout:function(e){var t;if(E.isDecimal(e)&&(t=Number(e))>0)return t},session_timers:function(e){if("boolean"==typeof e)return e},support_100rel:function(e){if("boolean"==typeof e)return e},password:function(e){return String(e)},realm:function(e){return String(e)},ha1:function(e){return String(e)},register:function(e){if("boolean"==typeof e)return e},register_expires:function(e){var t;if(E.isDecimal(e)&&(t=Number(e))>0)return t},registrar_server:function(e){var t;return/^sip:/i.test(e)||(e=f.SIP+":"+e),t=y.parse(e),t?t.user?void 0:t:void 0},sockets:function(e){var t,n;if(C.isSocket(e))e=[{socket:e}];else{if(!Array.isArray(e)||!e.length)return;for(n=e.length,t=0;t<n;t++)C.isSocket(e[t])&&(e[t]={socket:e[t]})}return e},use_preloaded_route:function(e){if("boolean"==typeof e)return e},ws_servers:function(e){var t,n,r=[];if("string"==typeof e)e=[{ws_uri:e}];else{if(!Array.isArray(e)||!e.length)return;for(n=e.length,t=0;t<n;t++)"string"==typeof e[t]&&(e[t]={ws_uri:e[t]})}for(n=e.length,t=0;t<n;t++)try{r.push({socket:new S(e[t].ws_uri),weight:e[t].weight||0})}catch(e){return void d(e)}return r}}}},{"./Constants":1,"./Exceptions":5,"./Grammar":6,"./Message":8,"./Parser":10,"./RTCSession":11,"./Registrator":16,"./SIPMessage":18,"./Socket":19,"./Transactions":21,"./Transport":22,"./URI":24,"./Utils":25,"./WebSocketInterface":26,"./sanityCheck":27,debug:29,events:31,rtcninja:38,util:46}],24:[function(e,t,n){function r(e,t,n,r,i,l){var o,u;if(!n)throw new TypeError('missing or invalid "host" parameter');e=e||s.SIP,this.parameters={},this.headers={};for(o in i)this.setParam(o,i[o]);for(u in l)this.setHeader(u,l[u]);Object.defineProperties(this,{scheme:{get:function(){return e},set:function(t){e=t.toLowerCase()}},user:{get:function(){return t},set:function(e){t=e}},host:{get:function(){return n},set:function(e){n=e.toLowerCase()}},port:{get:function(){return r},set:function(e){r=0===e?e:parseInt(e,10)||null}}})}t.exports=r;var s=e("./Constants"),i=e("./Utils"),l=e("./Grammar");r.prototype={setParam:function(e,t){e&&(this.parameters[e.toLowerCase()]=void 0===t||null===t?null:t.toString())},getParam:function(e){if(e)return this.parameters[e.toLowerCase()]},hasParam:function(e){if(e)return this.parameters.hasOwnProperty(e.toLowerCase())&&!0||!1},deleteParam:function(e){var t;if(e=e.toLowerCase(),this.parameters.hasOwnProperty(e))return t=this.parameters[e],delete this.parameters[e],t},clearParams:function(){this.parameters={}},setHeader:function(e,t){this.headers[i.headerize(e)]=Array.isArray(t)?t:[t]},getHeader:function(e){if(e)return this.headers[i.headerize(e)]},hasHeader:function(e){if(e)return this.headers.hasOwnProperty(i.headerize(e))&&!0||!1},deleteHeader:function(e){var t;if(e=i.headerize(e),this.headers.hasOwnProperty(e))return t=this.headers[e],delete this.headers[e],t},clearHeaders:function(){this.headers={}},clone:function(){return new r(this.scheme,this.user,this.host,this.port,JSON.parse(JSON.stringify(this.parameters)),JSON.parse(JSON.stringify(this.headers)))},toString:function(){var e,t,n,r,s=[];r=this.scheme+":",this.user&&(r+=i.escapeUser(this.user)+"@"),r+=this.host,(this.port||0===this.port)&&(r+=":"+this.port);for(t in this.parameters)r+=";"+t,null!==this.parameters[t]&&(r+="="+this.parameters[t]);for(e in this.headers)for(n=0;n<this.headers[e].length;n++)s.push(e+"="+this.headers[e][n]);return s.length>0&&(r+="?"+s.join("&")),r},toAor:function(e){var t;return t=this.scheme+":",this.user&&(t+=i.escapeUser(this.user)+"@"),t+=this.host,e&&(this.port||0===this.port)&&(t+=":"+this.port),t}},r.parse=function(e){return e=l.parse(e,"SIP_URI"),-1!==e?e:void 0}},{"./Constants":1,"./Grammar":6,"./Utils":25}],25:[function(e,t,n){var r={};t.exports=r;var s=e("./Constants"),i=e("./URI"),l=e("./Grammar");r.str_utf8_length=function(e){return unescape(encodeURIComponent(e)).length},r.isFunction=function(e){return void 0!==e&&"[object Function]"===Object.prototype.toString.call(e)},r.isString=function(e){return void 0!==e&&"[object String]"===Object.prototype.toString.call(e)},r.isDecimal=function(e){return!isNaN(e)&&parseFloat(e)===parseInt(e,10)},r.isEmpty=function(e){if(null===e||""===e||void 0===e||Array.isArray(e)&&0===e.length||"number"==typeof e&&isNaN(e))return!0},r.hasMethods=function(e){for(var t,n=1;t=arguments[n++];)if(this.isFunction(e[t]))return!1;return!0},r.createRandomToken=function(e,t){var n,r,s="";for(t=t||32,n=0;n<e;n++)r=Math.random()*t|0,s+=r.toString(t);return s},r.newTag=function(){return r.createRandomToken(10)},r.newUUID=function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return("x"===e?t:3&t|8).toString(16)})},r.hostType=function(e){if(e)return-1!==(e=l.parse(e,"host"))?e.host_type:void 0},r.normalizeTarget=function(e,t){var n,l,o,u;if(e){if(e instanceof i)return e;if("string"==typeof e){switch(l=e.split("@"),l.length){case 1:if(!t)return;o=e,u=t;break;case 2:o=l[0],u=l[1];break;default:o=l.slice(0,l.length-1).join("@"),u=l[l.length-1]}return o=o.replace(/^(sips?|tel):/i,""),/^[\-\.\(\)]*\+?[0-9\-\.\(\)]+$/.test(o)&&(o=o.replace(/[\-\.\(\)]/g,"")),e=s.SIP+":"+r.escapeUser(o)+"@"+u,(n=i.parse(e))?n:void 0}}else;},r.escapeUser=function(e){return encodeURIComponent(decodeURIComponent(e)).replace(/%3A/gi,":").replace(/%2B/gi,"+").replace(/%3F/gi,"?").replace(/%2F/gi,"/")},r.headerize=function(e){var t,n={"Call-Id":"Call-ID",Cseq:"CSeq",Rseq:"RSeq",Rack:"RAck","Www-Authenticate":"WWW-Authenticate"},r=e.toLowerCase().replace(/_/g,"-").split("-"),s="",i=r.length;for(t=0;t<i;t++)0!==t&&(s+="-"),s+=r[t].charAt(0).toUpperCase()+r[t].substring(1);return n[s]&&(s=n[s]),s},r.sipErrorCause=function(e){var t;for(t in s.SIP_ERROR_CAUSES)if(-1!==s.SIP_ERROR_CAUSES[t].indexOf(e))return s.causes[t];return s.causes.SIP_FAILURE_CODE},r.getRandomTestNetIP=function(){return"192.0.2."+function(e,t){return Math.floor(Math.random()*(t-e+1)+e)}(1,254)},r.calculateMD5=function(e){function t(e,t){return e<<t|e>>>32-t}function n(e,t){var n,r,s,i,l;return s=2147483648&e,i=2147483648&t,n=1073741824&e,r=1073741824&t,l=(1073741823&e)+(1073741823&t),n&r?2147483648^l^s^i:n|r?1073741824&l?3221225472^l^s^i:1073741824^l^s^i:l^s^i}function r(e,t,n){return e&t|~e&n}function s(e,t,n){return e&n|t&~n}function i(e,t,n){return e^t^n}function l(e,t,n){return t^(e|~n)}function o(e,s,i,l,o,u,a){return e=n(e,n(n(r(s,i,l),o),a)),n(t(e,u),s)}function u(e,r,i,l,o,u,a){return e=n(e,n(n(s(r,i,l),o),a)),n(t(e,u),r)}function a(e,r,s,l,o,u,a){return e=n(e,n(n(i(r,s,l),o),a)),n(t(e,u),r)}function c(e,r,s,i,o,u,a){return e=n(e,n(n(l(r,s,i),o),a)),n(t(e,u),r)}function h(e){var t,n,r="",s="";for(n=0;n<=3;n++)t=e>>>8*n&255,s="0"+t.toString(16),r+=s.substr(s.length-2,2);return r}var d,p,f,m,g,T,v,_,S,C=[];for(e=function(e){e=e.replace(/\r\n/g,"\n");for(var t="",n=0;n<e.length;n++){var r=e.charCodeAt(n);r<128?t+=String.fromCharCode(r):r>127&&r<2048?(t+=String.fromCharCode(r>>6|192),t+=String.fromCharCode(63&r|128)):(t+=String.fromCharCode(r>>12|224),t+=String.fromCharCode(r>>6&63|128),t+=String.fromCharCode(63&r|128))}return t}(e),C=function(e){for(var t,n=e.length,r=n+8,s=(r-r%64)/64,i=16*(s+1),l=new Array(i-1),o=0,u=0;u<n;)t=(u-u%4)/4,o=u%4*8,l[t]=l[t]|e.charCodeAt(u)<<o,u++;return t=(u-u%4)/4,o=u%4*8,l[t]=l[t]|128<<o,l[i-2]=n<<3,l[i-1]=n>>>29,l}(e),T=1732584193,v=4023233417,_=2562383102,S=271733878,d=0;d<C.length;d+=16)p=T,f=v,m=_,g=S,T=o(T,v,_,S,C[d+0],7,3614090360),S=o(S,T,v,_,C[d+1],12,3905402710),_=o(_,S,T,v,C[d+2],17,606105819),v=o(v,_,S,T,C[d+3],22,3250441966),T=o(T,v,_,S,C[d+4],7,4118548399),S=o(S,T,v,_,C[d+5],12,1200080426),_=o(_,S,T,v,C[d+6],17,2821735955),v=o(v,_,S,T,C[d+7],22,4249261313),T=o(T,v,_,S,C[d+8],7,1770035416),S=o(S,T,v,_,C[d+9],12,2336552879),_=o(_,S,T,v,C[d+10],17,4294925233),v=o(v,_,S,T,C[d+11],22,2304563134),T=o(T,v,_,S,C[d+12],7,1804603682),S=o(S,T,v,_,C[d+13],12,4254626195),_=o(_,S,T,v,C[d+14],17,2792965006),v=o(v,_,S,T,C[d+15],22,1236535329),T=u(T,v,_,S,C[d+1],5,4129170786),S=u(S,T,v,_,C[d+6],9,3225465664),_=u(_,S,T,v,C[d+11],14,643717713),v=u(v,_,S,T,C[d+0],20,3921069994),T=u(T,v,_,S,C[d+5],5,3593408605),S=u(S,T,v,_,C[d+10],9,38016083),_=u(_,S,T,v,C[d+15],14,3634488961),v=u(v,_,S,T,C[d+4],20,3889429448),T=u(T,v,_,S,C[d+9],5,568446438),S=u(S,T,v,_,C[d+14],9,3275163606),_=u(_,S,T,v,C[d+3],14,4107603335),v=u(v,_,S,T,C[d+8],20,1163531501),T=u(T,v,_,S,C[d+13],5,2850285829),S=u(S,T,v,_,C[d+2],9,4243563512),_=u(_,S,T,v,C[d+7],14,1735328473),v=u(v,_,S,T,C[d+12],20,2368359562),T=a(T,v,_,S,C[d+5],4,4294588738),S=a(S,T,v,_,C[d+8],11,2272392833),_=a(_,S,T,v,C[d+11],16,1839030562),v=a(v,_,S,T,C[d+14],23,4259657740),T=a(T,v,_,S,C[d+1],4,2763975236),S=a(S,T,v,_,C[d+4],11,1272893353),_=a(_,S,T,v,C[d+7],16,4139469664),v=a(v,_,S,T,C[d+10],23,3200236656),T=a(T,v,_,S,C[d+13],4,681279174),S=a(S,T,v,_,C[d+0],11,3936430074),_=a(_,S,T,v,C[d+3],16,3572445317),v=a(v,_,S,T,C[d+6],23,76029189),T=a(T,v,_,S,C[d+9],4,3654602809),S=a(S,T,v,_,C[d+12],11,3873151461),_=a(_,S,T,v,C[d+15],16,530742520),v=a(v,_,S,T,C[d+2],23,3299628645),T=c(T,v,_,S,C[d+0],6,4096336452),S=c(S,T,v,_,C[d+7],10,1126891415),_=c(_,S,T,v,C[d+14],15,2878612391),v=c(v,_,S,T,C[d+5],21,4237533241),T=c(T,v,_,S,C[d+12],6,1700485571),S=c(S,T,v,_,C[d+3],10,2399980690),_=c(_,S,T,v,C[d+10],15,4293915773),v=c(v,_,S,T,C[d+1],21,2240044497),T=c(T,v,_,S,C[d+8],6,1873313359),S=c(S,T,v,_,C[d+15],10,4264355552),_=c(_,S,T,v,C[d+6],15,2734768916),v=c(v,_,S,T,C[d+13],21,1309151649),T=c(T,v,_,S,C[d+4],6,4149444226),S=c(S,T,v,_,C[d+11],10,3174756917),_=c(_,S,T,v,C[d+2],15,718787259),v=c(v,_,S,T,C[d+9],21,3951481745),T=n(T,p),v=n(v,f),_=n(_,m),S=n(S,g);return(h(T)+h(v)+h(_)+h(S)).toLowerCase()},r.getRandomInt=function(e,t){return e=Math.ceil(e),t=Math.floor(t),Math.floor(Math.random()*(t-e))+e}},{"./Constants":1,"./Grammar":6,"./URI":24}],26:[function(e,t,n){function r(e){a('new() [url:"%s"]',e);var t=null,n=null;this.ws=null,Object.defineProperties(this,{via_transport:{get:function(){return n},set:function(e){n=e.toUpperCase()}},sip_uri:{get:function(){return t}},url:{get:function(){return e}}});var r=u.parse(e,"absoluteURI");if(-1===r)throw c("invalid WebSocket URI: "+e),new TypeError("Invalid argument: "+e);if("wss"!==r.scheme&&"ws"!==r.scheme)throw c("invalid WebSocket URI scheme: "+r.scheme),new TypeError("Invalid argument: "+e);t="sip:"+r.host+(r.port?":"+r.port:"")+";transport=ws",this.via_transport=r.scheme}function s(){a("WebSocket "+this.url+" connected"),this.onconnect()}function i(e){a("WebSocket "+this.url+" closed"),!1===e.wasClean&&a("WebSocket abrupt disconnection"),this.ondisconnect(e.wasClean,e.code,e.reason)}function l(e){a("received WebSocket message"),this.ondata(e.data)}function o(e){c("WebSocket "+this.url+" error: "+e)}t.exports=r;var u=e("./Grammar"),a=e("debug")("JsSIP:WebSocketInterface"),c=e("debug")("JsSIP:ERROR:WebSocketInterface");c.log=console.warn.bind(console),r.prototype.connect=function(){if(a("connect()"),this.isConnected())return void a("WebSocket "+this.url+" is already connected");if(this.isConnecting())return void a("WebSocket "+this.url+" is connecting");this.ws&&this.ws.close(),a("connecting to WebSocket "+this.url);try{this.ws=new WebSocket(this.url,"sip"),this.ws.binaryType="arraybuffer",this.ws.onopen=s.bind(this),this.ws.onclose=i.bind(this),this.ws.onmessage=l.bind(this),this.ws.onerror=o.bind(this)}catch(e){o.call(this,e)}},r.prototype.disconnect=function(){a("disconnect()"),this.ws&&(this.ws.close(),this.ws=null)},r.prototype.send=function(e){return a("send()"),this.isConnected()?(this.ws.send(e),!0):(c("unable to send message, WebSocket is not open"),!1)},r.prototype.isConnected=function(){return this.ws&&this.ws.readyState===this.ws.OPEN},r.prototype.isConnecting=function(){return this.ws&&this.ws.readyState===this.ws.CONNECTING}},{"./Grammar":6,debug:29}],27:[function(e,t,n){function r(e,t,n){var r;for(d=e,p=t,f=n,r=C.length;r--;)if(!1===C[r](d))return!1;if(d instanceof T.IncomingRequest){for(r=_.length;r--;)if(!1===_[r](d))return!1}else if(d instanceof T.IncomingResponse)for(r=S.length;r--;)if(!1===S[r](d))return!1;return!0}function s(){if("sip"!==d.s("to").uri.scheme)return h(416),!1}function i(){if(!d.to_tag&&d.call_id.substr(0,5)===p.configuration.jssip_id)return h(482),!1}function l(){if(v.str_utf8_length(d.body)<d.getHeader("content-length"))return h(400),!1}function o(){var e,t,n=d.from_tag,r=d.call_id,s=d.cseq;if(!d.to_tag)if(d.method===g.INVITE){if(p.transactions.ist[d.via_branch])return!1;for(t in p.transactions.ist)if(e=p.transactions.ist[t],e.request.from_tag===n&&e.request.call_id===r&&e.request.cseq===s)return h(482),!1}else{if(p.transactions.nist[d.via_branch])return!1;for(t in p.transactions.nist)if(e=p.transactions.nist[t],e.request.from_tag===n&&e.request.call_id===r&&e.request.cseq===s)return h(482),!1}}function u(){if(d.getHeaders("via").length>1)return m("more than one Via header field present in the response, dropping the response"),!1}function a(){if(v.str_utf8_length(d.body)<d.getHeader("content-length"))return m("message body length is lower than the value in Content-Length header field, dropping the response"),!1}function c(){for(var e=["from","to","call_id","cseq","via"],t=e.length;t--;)if(!d.hasHeader(e[t]))return m("missing mandatory header field : "+e[t]+", dropping the response"),!1}function h(e){var t,n="SIP/2.0 "+e+" "+g.REASON_PHRASE[e]+"\r\n",r=d.getHeaders("via"),s=r.length,i=0;for(i;i<s;i++)n+="Via: "+r[i]+"\r\n";t=d.getHeader("To"),d.to_tag||(t+=";tag="+v.newTag()),n+="To: "+t+"\r\n",n+="From: "+d.getHeader("From")+"\r\n",n+="Call-ID: "+d.call_id+"\r\n",n+="CSeq: "+d.cseq+" "+d.method+"\r\n",n+="\r\n",f.send(n)}t.exports=r;var d,p,f,m=e("debug")("JsSIP:sanityCheck"),g=e("./Constants"),T=e("./SIPMessage"),v=e("./Utils"),_=[],S=[],C=[];_.push(s),_.push(i),_.push(l),_.push(o),S.push(u),S.push(a),C.push(c)},{"./Constants":1,"./SIPMessage":18,"./Utils":25,debug:29}],28:[function(t,n,r){!function(t,r,s){void 0!==n&&n.exports?n.exports=s():"function"==typeof e&&e.amd?e("bowser",s):t.bowser=s()}(this,0,function(){function e(e){function t(t){var n=e.match(t);return n&&n.length>1&&n[1]||""}var n,r=t(/(ipod|iphone|ipad)/i).toLowerCase(),s=/like android/i.test(e),i=!s&&/android/i.test(e),o=/nexus\s*[0-6]\s*/i.test(e),u=!o&&/nexus\s*[0-9]+/i.test(e),a=/CrOS/.test(e),c=/silk/i.test(e),h=/sailfish/i.test(e),d=/tizen/i.test(e),p=/(web|hpw)os/i.test(e),f=/windows phone/i.test(e),m=(/SamsungBrowser/i.test(e),!f&&/windows/i.test(e)),g=!r&&!c&&/macintosh/i.test(e),T=!i&&!h&&!d&&!p&&/linux/i.test(e),v=t(/edge\/(\d+(\.\d+)?)/i),_=t(/version\/(\d+(\.\d+)?)/i),S=/tablet/i.test(e),C=!S&&/[^-]mobi/i.test(e),E=/xbox/i.test(e);/opera/i.test(e)?n={name:"Opera",opera:l,version:_||t(/(?:opera|opr|opios)[\s\/](\d+(\.\d+)?)/i)}:/opr|opios/i.test(e)?n={name:"Opera",opera:l,version:t(/(?:opr|opios)[\s\/](\d+(\.\d+)?)/i)||_}:/SamsungBrowser/i.test(e)?n={name:"Samsung Internet for Android",samsungBrowser:l,version:_||t(/(?:SamsungBrowser)[\s\/](\d+(\.\d+)?)/i)}:/coast/i.test(e)?n={name:"Opera Coast",coast:l,version:_||t(/(?:coast)[\s\/](\d+(\.\d+)?)/i)}:/yabrowser/i.test(e)?n={name:"Yandex Browser",yandexbrowser:l,version:_||t(/(?:yabrowser)[\s\/](\d+(\.\d+)?)/i)}:/ucbrowser/i.test(e)?n={name:"UC Browser",ucbrowser:l,version:t(/(?:ucbrowser)[\s\/](\d+(?:\.\d+)+)/i)}:/mxios/i.test(e)?n={name:"Maxthon",maxthon:l,version:t(/(?:mxios)[\s\/](\d+(?:\.\d+)+)/i)}:/epiphany/i.test(e)?n={name:"Epiphany",epiphany:l,version:t(/(?:epiphany)[\s\/](\d+(?:\.\d+)+)/i)}:/puffin/i.test(e)?n={name:"Puffin",puffin:l,version:t(/(?:puffin)[\s\/](\d+(?:\.\d+)?)/i)}:/sleipnir/i.test(e)?n={name:"Sleipnir",sleipnir:l,version:t(/(?:sleipnir)[\s\/](\d+(?:\.\d+)+)/i)}:/k-meleon/i.test(e)?n={name:"K-Meleon",kMeleon:l,version:t(/(?:k-meleon)[\s\/](\d+(?:\.\d+)+)/i)}:f?(n={name:"Windows Phone",windowsphone:l},v?(n.msedge=l,n.version=v):(n.msie=l,n.version=t(/iemobile\/(\d+(\.\d+)?)/i))):/msie|trident/i.test(e)?n={name:"Internet Explorer",msie:l,version:t(/(?:msie |rv:)(\d+(\.\d+)?)/i)}:a?n={name:"Chrome",chromeos:l,chromeBook:l,chrome:l,version:t(/(?:chrome|crios|crmo)\/(\d+(\.\d+)?)/i)}:/chrome.+? edge/i.test(e)?n={name:"Microsoft Edge",msedge:l,version:v}:/vivaldi/i.test(e)?n={name:"Vivaldi",vivaldi:l,version:t(/vivaldi\/(\d+(\.\d+)?)/i)||_}:h?n={name:"Sailfish",sailfish:l,version:t(/sailfish\s?browser\/(\d+(\.\d+)?)/i)}:/seamonkey\//i.test(e)?n={name:"SeaMonkey",seamonkey:l,version:t(/seamonkey\/(\d+(\.\d+)?)/i)}:/firefox|iceweasel|fxios/i.test(e)?(n={name:"Firefox",firefox:l,version:t(/(?:firefox|iceweasel|fxios)[ \/](\d+(\.\d+)?)/i)},/\((mobile|tablet);[^\)]*rv:[\d\.]+\)/i.test(e)&&(n.firefoxos=l)):c?n={name:"Amazon Silk",silk:l,version:t(/silk\/(\d+(\.\d+)?)/i)}:/phantom/i.test(e)?n={name:"PhantomJS",phantom:l,version:t(/phantomjs\/(\d+(\.\d+)?)/i)}:/slimerjs/i.test(e)?n={name:"SlimerJS",slimer:l,version:t(/slimerjs\/(\d+(\.\d+)?)/i)}:/blackberry|\bbb\d+/i.test(e)||/rim\stablet/i.test(e)?n={name:"BlackBerry",blackberry:l,version:_||t(/blackberry[\d]+\/(\d+(\.\d+)?)/i)}:p?(n={name:"WebOS",webos:l,version:_||t(/w(?:eb)?osbrowser\/(\d+(\.\d+)?)/i)},/touchpad\//i.test(e)&&(n.touchpad=l)):/bada/i.test(e)?n={name:"Bada",bada:l,version:t(/dolfin\/(\d+(\.\d+)?)/i)}:d?n={name:"Tizen",tizen:l,version:t(/(?:tizen\s?)?browser\/(\d+(\.\d+)?)/i)||_}:/qupzilla/i.test(e)?n={name:"QupZilla",qupzilla:l,version:t(/(?:qupzilla)[\s\/](\d+(?:\.\d+)+)/i)||_}:/chromium/i.test(e)?n={name:"Chromium",chromium:l,version:t(/(?:chromium)[\s\/](\d+(?:\.\d+)?)/i)||_}:/chrome|crios|crmo/i.test(e)?n={name:"Chrome",chrome:l,version:t(/(?:chrome|crios|crmo)\/(\d+(\.\d+)?)/i)}:i?n={name:"Android",version:_}:/safari|applewebkit/i.test(e)?(n={name:"Safari",safari:l},_&&(n.version=_)):r?(n={name:"iphone"==r?"iPhone":"ipad"==r?"iPad":"iPod"},_&&(n.version=_)):n=/googlebot/i.test(e)?{name:"Googlebot",googlebot:l,version:t(/googlebot\/(\d+(\.\d+))/i)||_}:{name:t(/^(.*)\/(.*) /),version:function(t){var n=e.match(t);return n&&n.length>1&&n[2]||""}(/^(.*)\/(.*) /)},!n.msedge&&/(apple)?webkit/i.test(e)?(/(apple)?webkit\/537\.36/i.test(e)?(n.name=n.name||"Blink",n.blink=l):(n.name=n.name||"Webkit",n.webkit=l),!n.version&&_&&(n.version=_)):!n.opera&&/gecko\//i.test(e)&&(n.name=n.name||"Gecko",n.gecko=l,n.version=n.version||t(/gecko\/(\d+(\.\d+)?)/i)),n.windowsphone||n.msedge||!i&&!n.silk?n.windowsphone||n.msedge||!r?g?n.mac=l:E?n.xbox=l:m?n.windows=l:T&&(n.linux=l):(n[r]=l,n.ios=l):n.android=l;var A="";n.windowsphone?A=t(/windows phone (?:os)?\s?(\d+(\.\d+)*)/i):r?(A=t(/os (\d+([_\s]\d+)*) like mac os x/i),A=A.replace(/[_\s]/g,".")):i?A=t(/android[ \/-](\d+(\.\d+)*)/i):n.webos?A=t(/(?:web|hpw)os\/(\d+(\.\d+)*)/i):n.blackberry?A=t(/rim\stablet\sos\s(\d+(\.\d+)*)/i):n.bada?A=t(/bada\/(\d+(\.\d+)*)/i):n.tizen&&(A=t(/tizen[\/\s](\d+(\.\d+)*)/i)),A&&(n.osversion=A);var y=A.split(".")[0];return S||u||"ipad"==r||i&&(3==y||y>=4&&!C)||n.silk?n.tablet=l:(C||"iphone"==r||"ipod"==r||i||o||n.blackberry||n.webos||n.bada)&&(n.mobile=l),n.msedge||n.msie&&n.version>=10||n.yandexbrowser&&n.version>=15||n.vivaldi&&n.version>=1||n.chrome&&n.version>=20||n.samsungBrowser&&n.version>=4||n.firefox&&n.version>=20||n.safari&&n.version>=6||n.opera&&n.version>=10||n.ios&&n.osversion&&n.osversion.split(".")[0]>=6||n.blackberry&&n.version>=10.1||n.chromium&&n.version>=20?n.a=l:n.msie&&n.version<10||n.chrome&&n.version<20||n.firefox&&n.version<20||n.safari&&n.version<6||n.opera&&n.version<10||n.ios&&n.osversion&&n.osversion.split(".")[0]<6||n.chromium&&n.version<20?n.c=l:n.x=l,n}function t(e){return e.split(".").length}function n(e,t){var n,r=[];if(Array.prototype.map)return Array.prototype.map.call(e,t);for(n=0;n<e.length;n++)r.push(t(e[n]));return r}function r(e){for(var r=Math.max(t(e[0]),t(e[1])),s=n(e,function(e){var s=r-t(e);return e+=new Array(s+1).join(".0"),n(e.split("."),function(e){return new Array(20-e.length).join("0")+e}).reverse()});--r>=0;){if(s[0][r]>s[1][r])return 1;if(s[0][r]!==s[1][r])return-1;if(0===r)return 0}}function s(t,n,s){var i=o;"string"==typeof n&&(s=n,n=void 0),void 0===n&&(n=!1),s&&(i=e(s));var l=""+i.version;for(var u in t)if(t.hasOwnProperty(u)&&i[u]){if("string"!=typeof t[u])throw new Error("Browser version in the minVersion map should be a string: "+u+": "+String(t));return r([l,t[u]])<0}return n}function i(e,t,n){return!s(e,t,n)}var l=!0,o=e("undefined"!=typeof navigator?navigator.userAgent||"":"");return o.test=function(e){for(var t=0;t<e.length;++t){var n=e[t];if("string"==typeof n&&n in o)return!0}return!1},o.isUnsupportedBrowser=s,o.compareVersions=r,o.check=i,o._detect=e,o})},{}],29:[function(e,t,n){(function(r){function s(){return!("undefined"==typeof window||!window||void 0===window.process||"renderer"!==window.process.type)||("undefined"!=typeof document&&document&&"WebkitAppearance"in document.documentElement.style||"undefined"!=typeof window&&window&&window.console&&(console.firebug||console.exception&&console.table)||"undefined"!=typeof navigator&&navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||"undefined"!=typeof navigator&&navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/))}function i(e){var t=this.useColors;if(e[0]=(t?"%c":"")+this.namespace+(t?" %c":" ")+e[0]+(t?"%c ":" ")+"+"+n.humanize(this.diff),t){var r="color: "+this.color;e.splice(1,0,r,"color: inherit");var s=0,i=0;e[0].replace(/%[a-zA-Z%]/g,function(e){"%%"!==e&&(s++,"%c"===e&&(i=s))}),e.splice(i,0,r)}}function l(){return"object"==typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)}function o(e){try{null==e?n.storage.removeItem("debug"):n.storage.debug=e}catch(e){}}function u(){try{return n.storage.debug}catch(e){}if(void 0!==r&&"env"in r)return r.env.DEBUG}n=t.exports=e("./debug"),n.log=l,n.formatArgs=i,n.save=o,n.load=u,n.useColors=s,n.storage="undefined"!=typeof chrome&&void 0!==chrome.storage?chrome.storage.local:function(){try{return window.localStorage}catch(e){}}(),n.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"],n.formatters.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}},n.enable(u())}).call(this,e("_process"))},{"./debug":30,_process:35}],30:[function(e,t,n){function r(e){var t,r=0;for(t in e)r=(r<<5)-r+e.charCodeAt(t),r|=0;return n.colors[Math.abs(r)%n.colors.length]}function s(e){function t(){if(t.enabled){var e=t,r=+new Date,s=r-(a||r);e.diff=s,e.prev=a,e.curr=r,a=r;for(var i=new Array(arguments.length),l=0;l<i.length;l++)i[l]=arguments[l];i[0]=n.coerce(i[0]),"string"!=typeof i[0]&&i.unshift("%O");var o=0;i[0]=i[0].replace(/%([a-zA-Z%])/g,function(t,r){if("%%"===t)return t;o++;var s=n.formatters[r];if("function"==typeof s){var l=i[o];t=s.call(e,l),i.splice(o,1),o--}return t}),n.formatArgs.call(e,i);(t.log||n.log||console.log.bind(console)).apply(e,i)}}return t.namespace=e,t.enabled=n.enabled(e),t.useColors=n.useColors(),t.color=r(e),"function"==typeof n.init&&n.init(t),t}function i(e){n.save(e),n.names=[],n.skips=[];for(var t=(e||"").split(/[\s,]+/),r=t.length,s=0;s<r;s++)t[s]&&(e=t[s].replace(/\*/g,".*?"),"-"===e[0]?n.skips.push(new RegExp("^"+e.substr(1)+"$")):n.names.push(new RegExp("^"+e+"$")))}function l(){n.enable("")}function o(e){var t,r;for(t=0,r=n.skips.length;t<r;t++)if(n.skips[t].test(e))return!1;for(t=0,r=n.names.length;t<r;t++)if(n.names[t].test(e))return!0;return!1}function u(e){return e instanceof Error?e.stack||e.message:e}n=t.exports=s.debug=s.default=s,n.coerce=u,n.disable=l,n.enable=i,n.enabled=o,n.humanize=e("ms"),n.names=[],n.skips=[],n.formatters={};var a},{ms:34}],31:[function(e,t,n){function r(){this._events=this._events||{},this._maxListeners=this._maxListeners||void 0}function s(e){return"function"==typeof e}function i(e){return"number"==typeof e}function l(e){return"object"==typeof e&&null!==e}function o(e){return void 0===e}t.exports=r,r.EventEmitter=r,r.prototype._events=void 0,r.prototype._maxListeners=void 0,r.defaultMaxListeners=10,r.prototype.setMaxListeners=function(e){if(!i(e)||e<0||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},r.prototype.emit=function(e){var t,n,r,i,u,a;if(this._events||(this._events={}),"error"===e&&(!this._events.error||l(this._events.error)&&!this._events.error.length)){if((t=arguments[1])instanceof Error)throw t;var c=new Error('Uncaught, unspecified "error" event. ('+t+")");throw c.context=t,c}if(n=this._events[e],o(n))return!1;if(s(n))switch(arguments.length){case 1:n.call(this);break;case 2:n.call(this,arguments[1]);break;case 3:n.call(this,arguments[1],arguments[2]);break;default:i=Array.prototype.slice.call(arguments,1),n.apply(this,i)}else if(l(n))for(i=Array.prototype.slice.call(arguments,1),a=n.slice(),r=a.length,u=0;u<r;u++)a[u].apply(this,i);return!0},r.prototype.addListener=function(e,t){var n;if(!s(t))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,s(t.listener)?t.listener:t),this._events[e]?l(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,l(this._events[e])&&!this._events[e].warned&&(n=o(this._maxListeners)?r.defaultMaxListeners:this._maxListeners)&&n>0&&this._events[e].length>n&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),"function"==typeof console.trace&&console.trace()),this},r.prototype.on=r.prototype.addListener,r.prototype.once=function(e,t){function n(){this.removeListener(e,n),r||(r=!0,t.apply(this,arguments))}if(!s(t))throw TypeError("listener must be a function");var r=!1;return n.listener=t,this.on(e,n),this},r.prototype.removeListener=function(e,t){var n,r,i,o;if(!s(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;if(n=this._events[e],i=n.length,r=-1,n===t||s(n.listener)&&n.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(l(n)){for(o=i;o-- >0;)if(n[o]===t||n[o].listener&&n[o].listener===t){r=o;break}if(r<0)return this;1===n.length?(n.length=0,delete this._events[e]):n.splice(r,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},r.prototype.removeAllListeners=function(e){var t,n;if(!this._events)return this;if(!this._events.removeListener)return 0===arguments.length?this._events={}:this._events[e]&&delete this._events[e],this;if(0===arguments.length){for(t in this._events)"removeListener"!==t&&this.removeAllListeners(t);return this.removeAllListeners("removeListener"),this._events={},this}if(n=this._events[e],s(n))this.removeListener(e,n);else if(n)for(;n.length;)this.removeListener(e,n[n.length-1]);return delete this._events[e],this},r.prototype.listeners=function(e){return this._events&&this._events[e]?s(this._events[e])?[this._events[e]]:this._events[e].slice():[]},r.prototype.listenerCount=function(e){if(this._events){var t=this._events[e];if(s(t))return 1;if(t)return t.length}return 0},r.listenerCount=function(e,t){return e.listenerCount(t)}},{}],32:[function(e,t,n){"function"==typeof Object.create?t.exports=function(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:t.exports=function(e,t){e.super_=t;var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e}},{}],33:[function(e,t,n){!function(e){function n(e,t){if("object"!==s(e))return t;for(var r in t)"object"===s(e[r])&&"object"===s(t[r])?e[r]=n(e[r],t[r]):e[r]=t[r];return e}function r(e,t,r){var l=r[0],o=r.length;(e||"object"!==s(l))&&(l={});for(var u=0;u<o;++u){var a=r[u];if("object"===s(a))for(var c in a){var h=e?i.clone(a[c]):a[c];l[c]=t?n(l[c],h):h}}return l}function s(e){return{}.toString.call(e).slice(8,-1).toLowerCase()}var i=function(e){return r(!0===e,!1,arguments)};i.recursive=function(e){return r(!0===e,!0,arguments)},i.clone=function(e){var t,n,r=e,l=s(e);if("array"===l)for(r=[],n=e.length,t=0;t<n;++t)r[t]=i.clone(e[t]);else if("object"===l){r={};for(t in e)r[t]=i.clone(e[t])}return r},e?t.exports=i:window.merge=i}("object"==typeof t&&t&&"object"==typeof t.exports&&t.exports)},{}],34:[function(e,t,n){function r(e){if(e=String(e),!(e.length>1e4)){var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(t){var n=parseFloat(t[1]);switch((t[2]||"ms").toLowerCase()){case"years":case"year":case"yrs":case"yr":case"y":return n*h;case"days":case"day":case"d":return n*c;case"hours":case"hour":case"hrs":case"hr":case"h":return n*a;case"minutes":case"minute":case"mins":case"min":case"m":return n*u;case"seconds":case"second":case"secs":case"sec":case"s":return n*o;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return n;default:return}}}}function s(e){return e>=c?Math.round(e/c)+"d":e>=a?Math.round(e/a)+"h":e>=u?Math.round(e/u)+"m":e>=o?Math.round(e/o)+"s":e+"ms"}function i(e){
return l(e,c,"day")||l(e,a,"hour")||l(e,u,"minute")||l(e,o,"second")||e+" ms"}function l(e,t,n){if(!(e<t))return e<1.5*t?Math.floor(e/t)+" "+n:Math.ceil(e/t)+" "+n+"s"}var o=1e3,u=60*o,a=60*u,c=24*a,h=365.25*c;t.exports=function(e,t){t=t||{};var n=typeof e;if("string"===n&&e.length>0)return r(e);if("number"===n&&!1===isNaN(e))return t.long?i(e):s(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))}},{}],35:[function(e,t,n){function r(){throw new Error("setTimeout has not been defined")}function s(){throw new Error("clearTimeout has not been defined")}function i(e){if(h===setTimeout)return setTimeout(e,0);if((h===r||!h)&&setTimeout)return h=setTimeout,setTimeout(e,0);try{return h(e,0)}catch(t){try{return h.call(null,e,0)}catch(t){return h.call(this,e,0)}}}function l(e){if(d===clearTimeout)return clearTimeout(e);if((d===s||!d)&&clearTimeout)return d=clearTimeout,clearTimeout(e);try{return d(e)}catch(t){try{return d.call(null,e)}catch(t){return d.call(this,e)}}}function o(){g&&f&&(g=!1,f.length?m=f.concat(m):T=-1,m.length&&u())}function u(){if(!g){var e=i(o);g=!0;for(var t=m.length;t;){for(f=m,m=[];++T<t;)f&&f[T].run();T=-1,t=m.length}f=null,g=!1,l(e)}}function a(e,t){this.fun=e,this.array=t}function c(){}var h,d,p=t.exports={};!function(){try{h="function"==typeof setTimeout?setTimeout:r}catch(e){h=r}try{d="function"==typeof clearTimeout?clearTimeout:s}catch(e){d=s}}();var f,m=[],g=!1,T=-1;p.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];m.push(new a(e,t)),1!==m.length||g||i(u)},a.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=c,p.addListener=c,p.once=c,p.off=c,p.removeListener=c,p.removeAllListeners=c,p.emit=c,p.prependListener=c,p.prependOnceListener=c,p.listeners=function(e){return[]},p.binding=function(e){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(e){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}},{}],36:[function(e,t,n){(function(n){"use strict";function r(e){function t(e){return function(){throw new Error("rtcninja: WebRTC not supported, missing "+e+" [browser: "+s.name+" "+s.version+"]")}}if(e.useIsacoPlugin&&C.getUserMedia&&S.RTCPeerConnection)_=!0,o=C.getUserMedia.bind(C),u=C.mediaDevices,a=S.RTCPeerConnection,c=S.RTCSessionDescription,h=S.RTCIceCandidate,d=S.MediaStreamTrack,d&&d.getSources?p=d.getSources.bind(d):C.getMediaDevices&&(p=C.getMediaDevices.bind(C)),f=S.attachMediaStream||function(e,t){return e.src=URL.createObjectURL(t),e},m=!0,g=!1;else if(v&&s.chrome&&T>=32||s.android&&s.chrome&&T>=39||v&&s.opera&&T>=27||s.android&&s.opera&&T>=24||s.android&&s.webkit&&!s.chrome&&T>=37||C.webkitGetUserMedia&&S.webkitRTCPeerConnection)_=!0,o=C.webkitGetUserMedia.bind(C),u=C.mediaDevices,a=S.webkitRTCPeerConnection,c=S.RTCSessionDescription,h=S.RTCIceCandidate,d=S.MediaStreamTrack,d&&d.getSources?p=d.getSources.bind(d):C.getMediaDevices&&(p=C.getMediaDevices.bind(C)),f=function(e,t){return e.src=URL.createObjectURL(t),e},m=!0,g=!1;else if(s.firefox&&T<47||C.mozGetUserMedia&&S.mozRTCPeerConnection)_=!0,o=C.mozGetUserMedia.bind(C),u=C.mediaDevices,a=S.mozRTCPeerConnection,c=S.mozRTCSessionDescription,h=S.mozRTCIceCandidate,d=S.MediaStreamTrack,f=function(e,t){return e.src=URL.createObjectURL(t),e},m=!1,g=!1;else if((s.firefox||s.gecko)&&T>=47)_=!0,o=C.mozGetUserMedia.bind(C),u=C.mediaDevices,a=S.RTCPeerConnection,c=S.RTCSessionDescription,h=S.RTCIceCandidate,d=S.MediaStreamTrack,f=function(e,t){return e.src=URL.createObjectURL(t),e},m=!1,g=!1;else if(e.plugin&&"function"==typeof e.plugin.isRequired&&e.plugin.isRequired()&&"function"==typeof e.plugin.isInstalled&&e.plugin.isInstalled()){var n=e.plugin.interface;_=!0,o=n.getUserMedia,u=n.mediaDevices,a=n.RTCPeerConnection,c=n.RTCSessionDescription,h=n.RTCIceCandidate,d=n.MediaStreamTrack,d&&d.getSources?p=d.getSources.bind(d):C.getMediaDevices&&(p=C.getMediaDevices.bind(C)),f=n.attachMediaStream,m=n.canRenegotiate,g=!0}else C.getUserMedia&&S.RTCPeerConnection&&(_=!0,o=C.getUserMedia.bind(C),u=C.mediaDevices,a=S.RTCPeerConnection,c=S.RTCSessionDescription,h=S.RTCIceCandidate,d=S.MediaStreamTrack,d&&d.getSources?p=d.getSources.bind(d):C.getMediaDevices&&(p=C.getMediaDevices.bind(C)),f=S.attachMediaStream||function(e,t){return e.src=URL.createObjectURL(t),e},m=!0,g=!1);return r.hasWebRTC=function(){return _},r.getUserMedia=o?function(e,t,n){i("getUserMedia() | constraints: %o",e);try{o(e,function(e){i("getUserMedia() | success"),t&&t(e)},function(e){i("getUserMedia() | error:",e),n&&n(e)})}catch(e){l("getUserMedia() | error:",e),n&&n(e)}}:function(e,n,r){l("getUserMedia() | WebRTC not supported"),r?r(new Error("rtcninja: WebRTC not supported, missing getUserMedia [browser: "+s.name+" "+s.version+"]")):t("getUserMedia")},r.mediaDevices=u,r.RTCPeerConnection=a||t("RTCPeerConnection"),r.RTCSessionDescription=c||t("RTCSessionDescription"),r.RTCIceCandidate=h||t("RTCIceCandidate"),r.MediaStreamTrack=d||t("MediaStreamTrack"),r.getMediaDevices=p,r.attachMediaStream=f||t("attachMediaStream"),r.canRenegotiate=m,r.closeMediaStream=function(e){if(e)try{i("closeMediaStream() | calling stop() on all the MediaStreamTrack");var t,n,r;if(e.getTracks)for(t=e.getTracks(),n=0,r=t.length;n<r;n+=1)t[n].stop();else{for(t=e.getAudioTracks(),n=0,r=t.length;n<r;n+=1)t[n].stop();for(t=e.getVideoTracks(),n=0,r=t.length;n<r;n+=1)t[n].stop()}}catch(t){"function"!=typeof e.stop&&"object"!=typeof e.stop||(i("closeMediaStream() | calling stop() on the MediaStream"),e.stop())}},r.fixPeerConnectionConfig=function(e){var t,n,r,s,i;for(Array.isArray(e.iceServers)||(e.iceServers=[]),t=0,n=e.iceServers.length;t<n;t+=1)r=e.iceServers[t],s=r.hasOwnProperty("urls"),i=r.hasOwnProperty("url"),"object"==typeof r&&(s&&!i?r.url=Array.isArray(r.urls)?r.urls[0]:r.urls:!s&&i&&(r.urls=Array.isArray(r.url)?r.url.slice():r.url),i&&Array.isArray(r.url)&&(r.url=r.url[0]))},r.fixRTCOfferOptions=function(e){e=e||{},g?(e.hasOwnProperty("offerToReceiveAudio")&&(e.mandatory=e.mandatory||{},e.mandatory.OfferToReceiveAudio=!!e.offerToReceiveAudio),e.hasOwnProperty("offerToReceiveVideo")&&(e.mandatory=e.mandatory||{},e.mandatory.OfferToReceiveVideo=!!e.offerToReceiveVideo)):(e.mandatory&&e.mandatory.hasOwnProperty("OfferToReceiveAudio")&&(e.offerToReceiveAudio=e.mandatory.OfferToReceiveAudio?1:0),e.mandatory&&e.mandatory.hasOwnProperty("OfferToReceiveVideo")&&(e.offerToReceiveVideo=e.mandatory.OfferToReceiveVideo?1:0),delete e.mandatory)},r}t.exports=r;var s=e("bowser"),i=e("debug")("rtcninja:Adapter"),l=e("debug")("rtcninja:ERROR:Adapter"),o=null,u=null,a=null,c=null,h=null,d=null,p=null,f=null,m=!1,g=!1,T=Number(s.version)||0,v=!(s.mobile||s.tablet&&!(s.msie&&T>=10)),_=!1,S=n.window||n,C=S.navigator||{};l.log=console.warn.bind(console)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{bowser:28,debug:29}],37:[function(e,t,n){"use strict";function r(e,t){h("new | [pcConfig:%o, pcConstraints:%o]",e,t),s.call(this,e),this.pcConstraints=t,this.ourLocalDescription=null,this.ourSignalingState=null,this.ourIceConnectionState=null,this.ourIceGatheringState=null,this.timerGatheringTimeout=null,this.timerGatheringTimeoutAfterRelay=null,this.ignoreIceGathering=!1,this.closed=!1,o.call(this),a.call(this)}function s(e){this.pcConfig=c(!0,e),p.fixPeerConnectionConfig(this.pcConfig),this.options={iceTransportsRelay:"relay"===this.pcConfig.iceTransports,iceTransportsNone:"none"===this.pcConfig.iceTransports,gatheringTimeout:this.pcConfig.gatheringTimeout,gatheringTimeoutAfterRelay:this.pcConfig.gatheringTimeoutAfterRelay},delete this.pcConfig.gatheringTimeout,delete this.pcConfig.gatheringTimeoutAfterRelay,h("setConfigurationAndOptions | processed pcConfig: %o",this.pcConfig)}function i(){return this.closed||this.pc&&"closed"===this.pc.iceConnectionState}function l(){var e=this,t=this.pc;t.onnegotiationneeded=function(t){i.call(e)||(h("onnegotiationneeded()"),e.onnegotiationneeded&&e.onnegotiationneeded(t))},t.onicecandidate=function(t){var n,r,s;if(!i.call(e)&&!e.ignoreIceGathering&&!e.options.iceTransportsNone)if(n=t.candidate){if(r=f.REGEXP_RELAY_CANDIDATE.test(n.candidate),e.options.iceTransportsRelay&&!r)return;r&&!e.timerGatheringTimeoutAfterRelay&&"number"==typeof e.options.gatheringTimeoutAfterRelay&&(h("onicecandidate() | first relay candidate found, ending gathering in %d ms",e.options.gatheringTimeoutAfterRelay),e.timerGatheringTimeoutAfterRelay=setTimeout(function(){i.call(e)||(h("forced end of candidates after timeout"),delete e.timerGatheringTimeoutAfterRelay,clearTimeout(e.timerGatheringTimeout),delete e.timerGatheringTimeout,e.ignoreIceGathering=!0,e.onicecandidate&&e.onicecandidate({candidate:null},null))},e.options.gatheringTimeoutAfterRelay)),s=new p.RTCIceCandidate({sdpMid:n.sdpMid,sdpMLineIndex:n.sdpMLineIndex,candidate:n.candidate}),null===m.normalizeCandidate&&(f.REGEXP_NORMALIZED_CANDIDATE.test(n.candidate)?m.normalizeCandidate=!1:(h('onicecandidate() | normalizing ICE candidates syntax (remove "a=" and "\\r\\n")'),m.normalizeCandidate=!0)),m.normalizeCandidate&&(s.candidate=n.candidate.replace(f.REGEXP_FIX_CANDIDATE,"")),h("onicecandidate() | m%d(%s) %s",s.sdpMLineIndex,s.sdpMid||"no mid",s.candidate),e.onicecandidate&&e.onicecandidate(t,s)}else h("onicecandidate() | end of candidates"),clearTimeout(e.timerGatheringTimeout),delete e.timerGatheringTimeout,clearTimeout(e.timerGatheringTimeoutAfterRelay),delete e.timerGatheringTimeoutAfterRelay,e.onicecandidate&&e.onicecandidate(t,null)},t.onaddstream=function(t){i.call(e)||(h("onaddstream() | stream: %o",t.stream),e.onaddstream&&e.onaddstream(t,t.stream))},t.onremovestream=function(t){i.call(e)||(h("onremovestream() | stream: %o",t.stream),e.onremovestream&&e.onremovestream(t,t.stream))},t.ondatachannel=function(t){i.call(e)||(h("ondatachannel() | datachannel: %o",t.channel),e.ondatachannel&&e.ondatachannel(t,t.channel))},t.onsignalingstatechange=function(n){t.signalingState!==e.ourSignalingState&&(h("onsignalingstatechange() | signalingState: %s",t.signalingState),e.ourSignalingState=t.signalingState,e.onsignalingstatechange&&e.onsignalingstatechange(n,t.signalingState))},t.oniceconnectionstatechange=function(n){t.iceConnectionState!==e.ourIceConnectionState&&(h("oniceconnectionstatechange() | iceConnectionState: %s",t.iceConnectionState),e.ourIceConnectionState=t.iceConnectionState,e.oniceconnectionstatechange&&e.oniceconnectionstatechange(n,t.iceConnectionState))},t.onicegatheringstatechange=function(n){i.call(e)||t.iceGatheringState!==e.ourIceGatheringState&&(h("onicegatheringstatechange() | iceGatheringState: %s",t.iceGatheringState),e.ourIceGatheringState=t.iceGatheringState,e.onicegatheringstatechange&&e.onicegatheringstatechange(n,t.iceGatheringState))},t.onidentityresult=function(t){i.call(e)||(h("onidentityresult()"),e.onidentityresult&&e.onidentityresult(t))},t.onpeeridentity=function(t){i.call(e)||(h("onpeeridentity()"),e.onpeeridentity&&e.onpeeridentity(t))},t.onidpassertionerror=function(t){i.call(e)||(h("onidpassertionerror()"),e.onidpassertionerror&&e.onidpassertionerror(t))},t.onidpvalidationerror=function(t){i.call(e)||(h("onidpvalidationerror()"),e.onidpvalidationerror&&e.onidpvalidationerror(t))}}function o(){this.pcConstraints?this.pc=new p.RTCPeerConnection(this.pcConfig,this.pcConstraints):this.pc=new p.RTCPeerConnection(this.pcConfig),l.call(this)}function u(){var e=this.pc,t=this.options,n=null;return e.localDescription?(t.iceTransportsRelay?n=e.localDescription.sdp.replace(f.REGEXP_SDP_NON_RELAY_CANDIDATES,""):t.iceTransportsNone&&(n=e.localDescription.sdp.replace(f.REGEXP_SDP_CANDIDATES,"")),this.ourLocalDescription=new p.RTCSessionDescription({type:e.localDescription.type,sdp:n||e.localDescription.sdp}),this.ourLocalDescription):(this.ourLocalDescription=null,null)}function a(){var e=this;Object.defineProperties(this,{peerConnection:{get:function(){return e.pc}},signalingState:{get:function(){return e.pc.signalingState}},iceConnectionState:{get:function(){return e.pc.iceConnectionState}},iceGatheringState:{get:function(){return e.pc.iceGatheringState}},localDescription:{get:function(){return u.call(e)}},remoteDescription:{get:function(){return e.pc.remoteDescription}},peerIdentity:{get:function(){return e.pc.peerIdentity}}})}t.exports=r;var c=e("merge"),h=e("debug")("rtcninja:RTCPeerConnection"),d=e("debug")("rtcninja:ERROR:RTCPeerConnection"),p=e("./Adapter"),f={REGEXP_NORMALIZED_CANDIDATE:new RegExp(/^candidate:/i),REGEXP_FIX_CANDIDATE:new RegExp(/(^a=|\r|\n)/gi),REGEXP_RELAY_CANDIDATE:new RegExp(/ relay /i),REGEXP_SDP_CANDIDATES:new RegExp(/^a=candidate:.*\r\n/gim),REGEXP_SDP_NON_RELAY_CANDIDATES:new RegExp(/^a=candidate:(.(?!relay ))*\r\n/gim)},m={normalizeCandidate:null};d.log=console.warn.bind(console),r.prototype.createOffer=function(e,t,n){h("createOffer()");var r=this;p.fixRTCOfferOptions(n),this.pc.createOffer(function(t){i.call(r)||(h("createOffer() | success"),e&&e(t))},function(e){i.call(r)||(d("createOffer() | error:",e),t&&t(e))},n)},r.prototype.createAnswer=function(e,t,n){h("createAnswer()");var r=this;this.pc.createAnswer(function(t){i.call(r)||(h("createAnswer() | success"),e&&e(t))},function(e){i.call(r)||(d("createAnswer() | error:",e),t&&t(e))},n)},r.prototype.setLocalDescription=function(e,t,n){function r(){"number"==typeof s.options.gatheringTimeout&&"complete"!==s.pc.iceGatheringState&&(h("setLocalDescription() | ending gathering in %d ms (gatheringTimeout option)",s.options.gatheringTimeout),s.timerGatheringTimeout=setTimeout(function(){i.call(s)||(h("forced end of candidates after gatheringTimeout timeout"),delete s.timerGatheringTimeout,clearTimeout(s.timerGatheringTimeoutAfterRelay),delete s.timerGatheringTimeoutAfterRelay,s.ignoreIceGathering=!0,s.onicecandidate&&s.onicecandidate({candidate:null},null))},s.options.gatheringTimeout))}h("setLocalDescription()");var s=this;this.pc.setLocalDescription(e,function(){i.call(s)||(h("setLocalDescription() | success"),clearTimeout(s.timerGatheringTimeout),delete s.timerGatheringTimeout,clearTimeout(s.timerGatheringTimeoutAfterRelay),delete s.timerGatheringTimeoutAfterRelay,r(),t&&t())},function(e){i.call(s)||(d("setLocalDescription() | error:",e),n&&n(e))}),this.ignoreIceGathering=!1},r.prototype.setRemoteDescription=function(e,t,n){h("setRemoteDescription()");var r=this;this.pc.setRemoteDescription(e,function(){i.call(r)||(h("setRemoteDescription() | success"),t&&t())},function(e){i.call(r)||(d("setRemoteDescription() | error:",e),n&&n(e))})},r.prototype.updateIce=function(e){h("updateIce() | pcConfig: %o",e),s.call(this,e),this.pc.updateIce(this.pcConfig),this.ignoreIceGathering=!1},r.prototype.addIceCandidate=function(e,t,n){h("addIceCandidate() | candidate: %o",e);var r=this;this.pc.addIceCandidate(e,function(){i.call(r)||(h("addIceCandidate() | success"),t&&t())},function(e){i.call(r)||(d("addIceCandidate() | error:",e),n&&n(e))})},r.prototype.getConfiguration=function(){return h("getConfiguration()"),this.pc.getConfiguration()},r.prototype.getLocalStreams=function(){return h("getLocalStreams()"),this.pc.getLocalStreams()},r.prototype.getRemoteStreams=function(){return h("getRemoteStreams()"),this.pc.getRemoteStreams()},r.prototype.getStreamById=function(e){return h("getStreamById() | streamId: %s",e),this.pc.getStreamById(e)},r.prototype.addStream=function(e){h("addStream() | stream: %s",e),this.pc.addStream(e)},r.prototype.removeStream=function(e){h("removeStream() | stream: %o",e),this.pc.removeStream(e)},r.prototype.close=function(){h("close()"),this.closed=!0,clearTimeout(this.timerGatheringTimeout),delete this.timerGatheringTimeout,clearTimeout(this.timerGatheringTimeoutAfterRelay),delete this.timerGatheringTimeoutAfterRelay,this.pc.close()},r.prototype.createDataChannel=function(){return h("createDataChannel()"),this.pc.createDataChannel.apply(this.pc,arguments)},r.prototype.createDTMFSender=function(e){return h("createDTMFSender()"),this.pc.createDTMFSender?this.pc.createDTMFSender(e):null},r.prototype.getStats=function(){return h("getStats()"),this.pc.getStats.apply(this.pc,arguments)},r.prototype.setIdentityProvider=function(){return h("setIdentityProvider()"),this.pc.setIdentityProvider.apply(this.pc,arguments)},r.prototype.getIdentityAssertion=function(){return h("getIdentityAssertion()"),this.pc.getIdentityAssertion()},r.prototype.reset=function(e){h("reset() | pcConfig: %o",e);var t=this.pc;t.onnegotiationneeded=null,t.onicecandidate=null,t.onaddstream=null,t.onremovestream=null,t.ondatachannel=null,t.onsignalingstatechange=null,t.oniceconnectionstatechange=null,t.onicegatheringstatechange=null,t.onidentityresult=null,t.onpeeridentity=null,t.onidpassertionerror=null,t.onidpvalidationerror=null,clearTimeout(this.timerGatheringTimeout),delete this.timerGatheringTimeout,clearTimeout(this.timerGatheringTimeoutAfterRelay),delete this.timerGatheringTimeoutAfterRelay,h("reset() | closing current peerConnection"),t.close(),s.call(this,e),o.call(this)}},{"./Adapter":36,debug:29,merge:33}],38:[function(e,t,n){"use strict";function r(e){var t=u(e||{});return c=!0,r.RTCPeerConnection=a,r.getUserMedia=t.getUserMedia,r.mediaDevices=t.mediaDevices,r.RTCSessionDescription=t.RTCSessionDescription,r.RTCIceCandidate=t.RTCIceCandidate,r.MediaStreamTrack=t.MediaStreamTrack,r.getMediaDevices=t.getMediaDevices,r.attachMediaStream=t.attachMediaStream,r.closeMediaStream=t.closeMediaStream,r.canRenegotiate=t.canRenegotiate,t.hasWebRTC()?(i("WebRTC supported"),!0):(l("WebRTC not supported"),!1)}t.exports=r;var s=e("bowser"),i=e("debug")("rtcninja"),l=e("debug")("rtcninja:ERROR"),o=e("./version"),u=e("./Adapter"),a=e("./RTCPeerConnection"),c=!1;l.log=console.warn.bind(console),i("version %s",o),i("detected browser: %s %s [mobile:%s, tablet:%s, android:%s, ios:%s]",s.name,s.version,!!s.mobile,!!s.tablet,!!s.android,!!s.ios),r.hasWebRTC=function(){return c||r(),u.hasWebRTC()},Object.defineProperty(r,"version",{get:function(){return o}}),Object.defineProperty(r,"called",{get:function(){return c}}),r.debug=e("debug"),r.browser=s},{"./Adapter":36,"./RTCPeerConnection":37,"./version":39,bowser:28,debug:29}],39:[function(e,t,n){"use strict";t.exports=e("../package.json").version},{"../package.json":40}],40:[function(e,t,n){t.exports={name:"rtcninja",version:"0.7.1",description:"WebRTC API wrapper to deal with different browsers",author:{name:"Iñaki Baz Castillo",email:"inaki.baz@eface2face.com",url:"http://eface2face.com"},contributors:[{name:"Jesús Pérez",email:"jesus.perez@eface2face.com"}],license:"MIT",main:"lib/rtcninja.js",homepage:"https://github.com/eface2face/rtcninja.js",repository:{type:"git",url:"https://github.com/eface2face/rtcninja.js.git"},keywords:["webrtc"],engines:{node:">=4"},dependencies:{bowser:"^1.5.0",debug:"^2.3.3",merge:"^1.2.0"},devDependencies:{browserify:"^13.1.1",gulp:"git+https://github.com/gulpjs/gulp.git#4.0","gulp-expect-file":"0.0.7","gulp-filelog":"^0.4.1","gulp-header":"^1.8.8","gulp-jscs":"^3.0.2","gulp-jscs-stylish":"^1.4.0","gulp-jshint":"^2.0.4","gulp-rename":"^1.2.2","gulp-uglify":"^1.5.4",jshint:"^2.9.4","jshint-stylish":"^2.2.1","vinyl-source-stream":"^1.1.0"},readme:'# rtcninja.js <img src="http://www.pubnub.com/blog/wp-content/uploads/2014/01/google-webrtc-logo.png" height="30" width="30">\n\nWebRTC API wrapper to deal with different browsers transparently, [eventually](http://iswebrtcreadyyet.com/) this library shouldn\'t be needed. We only have to wait until W3C group in charge [finishes the specification](https://tools.ietf.org/wg/rtcweb/) and the different browsers implement it correctly :sweat_smile:.\n\n<img src="http://images4.fanpop.com/image/photos/21800000/browser-fight-google-chrome-21865454-600-531.jpg" height="250" width="250">\n\nSupported environments:\n* [Google Chrome](https://www.google.com/chrome/browser/desktop/index.html) (desktop & mobile)\n* [Google Canary](https://www.google.com/chrome/browser/canary.html) (desktop & mobile)\n* [Mozilla Firefox](https://www.mozilla.org/en-GB/firefox/new) (desktop & mobile)\n* [Firefox Nigthly](https://nightly.mozilla.org/) (desktop & mobile)\n* [Opera](http://www.opera.com/)\n* [Vivaldi](https://vivaldi.com/)\n* [CrossWalk](https://crosswalk-project.org/)\n* [Cordova](http://cordova.apache.org/): iOS support, you only have to use our plugin [following these steps](https://github.com/eface2face/cordova-plugin-iosrtc#usage).\n* [NW.js](https://github.com/nwjs/nw.js/)\n* [Electron](https://github.com/atom/electron)\n\n\n## Installation\n\n### **npm**:\n\n```bash\n$ npm install rtcninja\n```\n\nand then:\n\n```javascript\nvar rtcninja = require(\'rtcninja\');\n```\n\n### **bower**:\n\n```bash\n$ bower install rtcninja\n```\n\n\n## Browserified library\n\nTake a browserified version of the library from the `dist/` folder:\n\n* `dist/rtcninja.js`: The uncompressed version.\n* `dist/rtcninja.min.js`: The compressed production-ready version.\n\nThey expose the global `window.rtcninja` module.\n\n\n## Usage\n\nIn the [examples](./examples/) folder we provide a complete one.\n\n```javascript\n// Must first call it.\nrtcninja();\n\n// Then check.\nif (rtcninja.hasWebRTC()) {\n    // Do something.\n}\nelse {\n    // Do something.\n}\n```\n\n\n## Documentation\n\nYou can read the full [API documentation](docs/index.md) in the docs folder.\n\n\n## Issues\n\nhttps://github.com/eface2face/rtcninja.js/issues\n\n\n## Developer guide\n\n* Create a branch with a name including your user and a meaningful word about the fix/feature you\'re going to implement, ie: "jesusprubio/fixstuff"\n* Use [GitHub pull requests](https://help.github.com/articles/using-pull-requests).\n* Conventions:\n * We use [JSHint](http://jshint.com/) and [Crockford\'s Styleguide](http://javascript.crockford.com/code.html).\n * Please run `gulp lint` to be sure your code fits with them.\n\n\n### Debugging\n\nThe library includes the Node [debug](https://github.com/visionmedia/debug) module. In order to enable debugging:\n\nIn Node set the `DEBUG=rtcninja*` environment variable before running the application, or set it at the top of the script:\n\n```javascript\nprocess.env.DEBUG = \'rtcninja*\';\n```\n\nIn the browser run `rtcninja.debug.enable(\'rtcninja*\');` and reload the page. Note that the debugging settings are stored into the browser LocalStorage. To disable it run `rtcninja.debug.disable(\'rtcninja*\');`.\n\n\n## Copyright & License\n\n* eFace2Face Inc.\n* [MIT](./LICENSE)\n',readmeFilename:"README.md",bugs:{url:"https://github.com/eface2face/rtcninja.js/issues"},_id:"rtcninja@0.7.1",dist:{shasum:"826503af0f275bf40a5e4ecb35d7ae1185854092"},_resolved:"git+ssh://git@git.isaco.de:ext/rtcninja#60dd2cd53127d0a5555c05c66b3ddb77c8a92904",_from:"rtcninja@git+ssh://git@git.isaco.de:ext/rtcninja#isaco-enhancements-2016"}},{}],41:[function(e,t,n){var r=t.exports={v:[{name:"version",reg:/^(\d*)$/}],o:[{name:"origin",reg:/^(\S*) (\d*) (\d*) (\S*) IP(\d) (\S*)/,names:["username","sessionId","sessionVersion","netType","ipVer","address"],format:"%s %s %d %s IP%d %s"}],s:[{name:"name"}],i:[{name:"description"}],u:[{name:"uri"}],e:[{name:"email"}],p:[{name:"phone"}],z:[{name:"timezones"}],r:[{name:"repeats"}],t:[{name:"timing",reg:/^(\d*) (\d*)/,names:["start","stop"],format:"%d %d"}],c:[{name:"connection",reg:/^IN IP(\d) (\S*)/,names:["version","ip"],format:"IN IP%d %s"}],b:[{push:"bandwidth",reg:/^(TIAS|AS|CT|RR|RS):(\d*)/,names:["type","limit"],format:"%s:%s"}],m:[{reg:/^(\w*) (\d*) ([\w\/]*)(?: (.*))?/,names:["type","port","protocol","payloads"],format:"%s %d %s %s"}],a:[{push:"rtp",reg:/^rtpmap:(\d*) ([\w\-\.]*)(?:\s*\/(\d*)(?:\s*\/(\S*))?)?/,names:["payload","codec","rate","encoding"],format:function(e){return e.encoding?"rtpmap:%d %s/%s/%s":e.rate?"rtpmap:%d %s/%s":"rtpmap:%d %s"}},{push:"fmtp",reg:/^fmtp:(\d*) ([\S| ]*)/,names:["payload","config"],format:"fmtp:%d %s"},{name:"control",reg:/^control:(.*)/,format:"control:%s"},{name:"rtcp",reg:/^rtcp:(\d*)(?: (\S*) IP(\d) (\S*))?/,names:["port","netType","ipVer","address"],format:function(e){return null!=e.address?"rtcp:%d %s IP%d %s":"rtcp:%d"}},{push:"rtcpFbTrrInt",reg:/^rtcp-fb:(\*|\d*) trr-int (\d*)/,names:["payload","value"],format:"rtcp-fb:%d trr-int %d"},{push:"rtcpFb",reg:/^rtcp-fb:(\*|\d*) ([\w-_]*)(?: ([\w-_]*))?/,names:["payload","type","subtype"],format:function(e){return null!=e.subtype?"rtcp-fb:%s %s %s":"rtcp-fb:%s %s"}},{push:"ext",reg:/^extmap:([\w_\/]*) (\S*)(?: (\S*))?/,names:["value","uri","config"],format:function(e){return null!=e.config?"extmap:%s %s %s":"extmap:%s %s"}},{push:"crypto",reg:/^crypto:(\d*) ([\w_]*) (\S*)(?: (\S*))?/,names:["id","suite","config","sessionConfig"],format:function(e){return null!=e.sessionConfig?"crypto:%d %s %s %s":"crypto:%d %s %s"}},{name:"setup",reg:/^setup:(\w*)/,format:"setup:%s"},{name:"mid",reg:/^mid:([^\s]*)/,format:"mid:%s"},{name:"msid",reg:/^msid:(.*)/,format:"msid:%s"},{name:"ptime",reg:/^ptime:(\d*)/,format:"ptime:%d"},{name:"maxptime",reg:/^maxptime:(\d*)/,format:"maxptime:%d"},{name:"direction",reg:/^(sendrecv|recvonly|sendonly|inactive)/},{name:"icelite",reg:/^(ice-lite)/},{name:"iceUfrag",reg:/^ice-ufrag:(\S*)/,format:"ice-ufrag:%s"},{name:"icePwd",reg:/^ice-pwd:(\S*)/,format:"ice-pwd:%s"},{name:"fingerprint",reg:/^fingerprint:(\S*) (\S*)/,names:["type","hash"],format:"fingerprint:%s %s"},{push:"candidates",reg:/^candidate:(\S*) (\d*) (\S*) (\d*) (\S*) (\d*) typ (\S*)(?: raddr (\S*) rport (\d*))?(?: tcptype (\S*))?(?: generation (\d*))?(?: network-id (\d*))?(?: network-cost (\d*))?/,names:["foundation","component","transport","priority","ip","port","type","raddr","rport","tcptype","generation","network-id","network-cost"],format:function(e){var t="candidate:%s %d %s %d %s %d typ %s";return t+=null!=e.raddr?" raddr %s rport %d":"%v%v",t+=null!=e.tcptype?" tcptype %s":"%v",null!=e.generation&&(t+=" generation %d"),t+=null!=e["network-id"]?" network-id %d":"%v",t+=null!=e["network-cost"]?" network-cost %d":"%v"}},{name:"endOfCandidates",reg:/^(end-of-candidates)/},{name:"remoteCandidates",reg:/^remote-candidates:(.*)/,format:"remote-candidates:%s"},{name:"iceOptions",reg:/^ice-options:(\S*)/,format:"ice-options:%s"},{push:"ssrcs",reg:/^ssrc:(\d*) ([\w_]*)(?::(.*))?/,names:["id","attribute","value"],format:function(e){var t="ssrc:%d";return null!=e.attribute&&(t+=" %s",null!=e.value&&(t+=":%s")),t}},{push:"ssrcGroups",reg:/^ssrc-group:(\w*) (.*)/,names:["semantics","ssrcs"],format:"ssrc-group:%s %s"},{name:"msidSemantic",reg:/^msid-semantic:\s?(\w*) (\S*)/,names:["semantic","token"],format:"msid-semantic: %s %s"},{push:"groups",reg:/^group:(\w*) (.*)/,names:["type","mids"],format:"group:%s %s"},{name:"rtcpMux",reg:/^(rtcp-mux)/},{name:"rtcpRsize",reg:/^(rtcp-rsize)/},{name:"sctpmap",reg:/^sctpmap:([\w_\/]*) (\S*)(?: (\S*))?/,names:["sctpmapNumber","app","maxMessageSize"],format:function(e){return null!=e.maxMessageSize?"sctpmap:%s %s %s":"sctpmap:%s %s"}},{push:"invalid",names:["value"]}]};Object.keys(r).forEach(function(e){r[e].forEach(function(e){e.reg||(e.reg=/(.*)/),e.format||(e.format="%s")})})},{}],42:[function(e,t,n){var r=e("./parser"),s=e("./writer");n.write=s,n.parse=r.parse,n.parseFmtpConfig=r.parseFmtpConfig,n.parsePayloads=r.parsePayloads,n.parseRemoteCandidates=r.parseRemoteCandidates},{"./parser":43,"./writer":44}],43:[function(e,t,n){var r=function(e){return String(Number(e))===e?Number(e):e},s=function(e,t,n,s){if(s&&!n)t[s]=r(e[1]);else for(var i=0;i<n.length;i+=1)null!=e[i+1]&&(t[n[i]]=r(e[i+1]))},i=function(e,t,n){var r=e.name&&e.names;e.push&&!t[e.push]?t[e.push]=[]:r&&!t[e.name]&&(t[e.name]={});var i=e.push?{}:r?t[e.name]:t;s(n.match(e.reg),i,e.names,e.name),e.push&&t[e.push].push(i)},l=e("./grammar"),o=RegExp.prototype.test.bind(/^([a-z])=(.*)/);n.parse=function(e){var t={},n=[],r=t;return e.split(/(\r\n|\r|\n)/).filter(o).forEach(function(e){var t=e[0],s=e.slice(2);"m"===t&&(n.push({rtp:[],fmtp:[]}),r=n[n.length-1]);for(var o=0;o<(l[t]||[]).length;o+=1){var u=l[t][o];if(u.reg.test(s))return i(u,r,s)}}),t.media=n,t};var u=function(e,t){var n=t.split(/=(.+)/,2);return 2===n.length&&(e[n[0]]=r(n[1])),e};n.parseFmtpConfig=function(e){return e.split(/\;\s?/).reduce(u,{})},n.parsePayloads=function(e){return e.split(" ").map(Number)},n.parseRemoteCandidates=function(e){for(var t=[],n=e.split(" ").map(r),s=0;s<n.length;s+=3)t.push({component:n[s],ip:n[s+1],port:n[s+2]});return t}},{"./grammar":41}],44:[function(e,t,n){var r=e("./grammar"),s=/%[sdv%]/g,i=function(e){var t=1,n=arguments,r=n.length;return e.replace(s,function(e){if(t>=r)return e;var s=n[t];switch(t+=1,e){case"%%":return"%";case"%s":return String(s);case"%d":return Number(s);case"%v":return""}})},l=function(e,t,n){var r=t.format instanceof Function?t.format(t.push?n:n[t.name]):t.format,s=[e+"="+r];if(t.names)for(var l=0;l<t.names.length;l+=1){var o=t.names[l];t.name?s.push(n[t.name][o]):s.push(n[t.names[l]])}else s.push(n[t.name]);return i.apply(null,s)},o=["v","o","s","i","u","e","p","c","b","t","r","z","a"],u=["i","c","b","a"];t.exports=function(e,t){t=t||{},null==e.version&&(e.version=0),null==e.name&&(e.name=" "),e.media.forEach(function(e){null==e.payloads&&(e.payloads="")});var n=t.outerOrder||o,s=t.innerOrder||u,i=[];return n.forEach(function(t){r[t].forEach(function(n){n.name in e&&null!=e[n.name]?i.push(l(t,n,e)):n.push in e&&null!=e[n.push]&&e[n.push].forEach(function(e){i.push(l(t,n,e))})})}),e.media.forEach(function(e){i.push(l("m",r.m[0],e)),s.forEach(function(t){r[t].forEach(function(n){n.name in e&&null!=e[n.name]?i.push(l(t,n,e)):n.push in e&&null!=e[n.push]&&e[n.push].forEach(function(e){i.push(l(t,n,e))})})})}),i.join("\r\n")+"\r\n"}},{"./grammar":41}],45:[function(e,t,n){t.exports=function(e){return e&&"object"==typeof e&&"function"==typeof e.copy&&"function"==typeof e.fill&&"function"==typeof e.readUInt8}},{}],46:[function(e,t,n){(function(t,r){function s(e,t){var r={seen:[],stylize:l};return arguments.length>=3&&(r.depth=arguments[2]),arguments.length>=4&&(r.colors=arguments[3]),m(t)?r.showHidden=t:t&&n._extend(r,t),C(r.showHidden)&&(r.showHidden=!1),C(r.depth)&&(r.depth=2),C(r.colors)&&(r.colors=!1),C(r.customInspect)&&(r.customInspect=!0),r.colors&&(r.stylize=i),u(r,e,r.depth)}function i(e,t){var n=s.styles[t];return n?"["+s.colors[n][0]+"m"+e+"["+s.colors[n][1]+"m":e}function l(e,t){return e}function o(e){var t={};return e.forEach(function(e,n){t[e]=!0}),t}function u(e,t,r){if(e.customInspect&&t&&b(t.inspect)&&t.inspect!==n.inspect&&(!t.constructor||t.constructor.prototype!==t)){var s=t.inspect(r,e);return _(s)||(s=u(e,s,r)),s}var i=a(e,t);if(i)return i;var l=Object.keys(t),m=o(l);if(e.showHidden&&(l=Object.getOwnPropertyNames(t)),R(t)&&(l.indexOf("message")>=0||l.indexOf("description")>=0))return c(t);if(0===l.length){if(b(t)){var g=t.name?": "+t.name:"";return e.stylize("[Function"+g+"]","special")}if(E(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(y(t))return e.stylize(Date.prototype.toString.call(t),"date");if(R(t))return c(t)}var T="",v=!1,S=["{","}"];if(f(t)&&(v=!0,S=["[","]"]),b(t)){T=" [Function"+(t.name?": "+t.name:"")+"]"}if(E(t)&&(T=" "+RegExp.prototype.toString.call(t)),y(t)&&(T=" "+Date.prototype.toUTCString.call(t)),R(t)&&(T=" "+c(t)),0===l.length&&(!v||0==t.length))return S[0]+T+S[1];if(r<0)return E(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special");e.seen.push(t);var C;return C=v?h(e,t,r,m,l):l.map(function(n){return d(e,t,r,m,n,v)}),e.seen.pop(),p(C,T,S)}function a(e,t){if(C(t))return e.stylize("undefined","undefined");if(_(t)){var n="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(n,"string")}
return v(t)?e.stylize(""+t,"number"):m(t)?e.stylize(""+t,"boolean"):g(t)?e.stylize("null","null"):void 0}function c(e){return"["+Error.prototype.toString.call(e)+"]"}function h(e,t,n,r,s){for(var i=[],l=0,o=t.length;l<o;++l)O(t,String(l))?i.push(d(e,t,n,r,String(l),!0)):i.push("");return s.forEach(function(s){s.match(/^\d+$/)||i.push(d(e,t,n,r,s,!0))}),i}function d(e,t,n,r,s,i){var l,o,a;if(a=Object.getOwnPropertyDescriptor(t,s)||{value:t[s]},a.get?o=a.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):a.set&&(o=e.stylize("[Setter]","special")),O(r,s)||(l="["+s+"]"),o||(e.seen.indexOf(a.value)<0?(o=g(n)?u(e,a.value,null):u(e,a.value,n-1),o.indexOf("\n")>-1&&(o=i?o.split("\n").map(function(e){return"  "+e}).join("\n").substr(2):"\n"+o.split("\n").map(function(e){return"   "+e}).join("\n"))):o=e.stylize("[Circular]","special")),C(l)){if(i&&s.match(/^\d+$/))return o;l=JSON.stringify(""+s),l.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(l=l.substr(1,l.length-2),l=e.stylize(l,"name")):(l=l.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),l=e.stylize(l,"string"))}return l+": "+o}function p(e,t,n){var r=0;return e.reduce(function(e,t){return r++,t.indexOf("\n")>=0&&r++,e+t.replace(/\u001b\[\d\d?m/g,"").length+1},0)>60?n[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+n[1]:n[0]+t+" "+e.join(", ")+" "+n[1]}function f(e){return Array.isArray(e)}function m(e){return"boolean"==typeof e}function g(e){return null===e}function T(e){return null==e}function v(e){return"number"==typeof e}function _(e){return"string"==typeof e}function S(e){return"symbol"==typeof e}function C(e){return void 0===e}function E(e){return A(e)&&"[object RegExp]"===w(e)}function A(e){return"object"==typeof e&&null!==e}function y(e){return A(e)&&"[object Date]"===w(e)}function R(e){return A(e)&&("[object Error]"===w(e)||e instanceof Error)}function b(e){return"function"==typeof e}function I(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||void 0===e}function w(e){return Object.prototype.toString.call(e)}function N(e){return e<10?"0"+e.toString(10):e.toString(10)}function D(){var e=new Date,t=[N(e.getHours()),N(e.getMinutes()),N(e.getSeconds())].join(":");return[e.getDate(),M[e.getMonth()],t].join(" ")}function O(e,t){return Object.prototype.hasOwnProperty.call(e,t)}var x=/%[sdj%]/g;n.format=function(e){if(!_(e)){for(var t=[],n=0;n<arguments.length;n++)t.push(s(arguments[n]));return t.join(" ")}for(var n=1,r=arguments,i=r.length,l=String(e).replace(x,function(e){if("%%"===e)return"%";if(n>=i)return e;switch(e){case"%s":return String(r[n++]);case"%d":return Number(r[n++]);case"%j":try{return JSON.stringify(r[n++])}catch(e){return"[Circular]"}default:return e}}),o=r[n];n<i;o=r[++n])g(o)||!A(o)?l+=" "+o:l+=" "+s(o);return l},n.deprecate=function(e,s){function i(){if(!l){if(t.throwDeprecation)throw new Error(s);t.traceDeprecation?console.trace(s):console.error(s),l=!0}return e.apply(this,arguments)}if(C(r.process))return function(){return n.deprecate(e,s).apply(this,arguments)};if(!0===t.noDeprecation)return e;var l=!1;return i};var U,P={};n.debuglog=function(e){if(C(U)&&(U=t.env.NODE_DEBUG||""),e=e.toUpperCase(),!P[e])if(new RegExp("\\b"+e+"\\b","i").test(U)){var r=t.pid;P[e]=function(){var t=n.format.apply(n,arguments);console.error("%s %d: %s",e,r,t)}}else P[e]=function(){};return P[e]},n.inspect=s,s.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},s.styles={special:"cyan",number:"yellow",boolean:"yellow",undefined:"grey",null:"bold",string:"green",date:"magenta",regexp:"red"},n.isArray=f,n.isBoolean=m,n.isNull=g,n.isNullOrUndefined=T,n.isNumber=v,n.isString=_,n.isSymbol=S,n.isUndefined=C,n.isRegExp=E,n.isObject=A,n.isDate=y,n.isError=R,n.isFunction=b,n.isPrimitive=I,n.isBuffer=e("./support/isBuffer");var M=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];n.log=function(){console.log("%s - %s",D(),n.format.apply(n,arguments))},n.inherits=e("inherits"),n._extend=function(e,t){if(!t||!A(t))return e;for(var n=Object.keys(t),r=n.length;r--;)e[n[r]]=t[n[r]];return e}}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./support/isBuffer":45,_process:35,inherits:32}],47:[function(e,t,n){t.exports={name:"jssip",title:"JsSIP",description:"the Javascript SIP library",version:"2.0.6",homepage:"http://jssip.net",author:"José Luis Millán <jmillan@aliax.net> (https://github.com/jmillan)",contributors:["Iñaki Baz Castillo <ibc@aliax.net> (https://github.com/ibc)","Saúl Ibarra Corretgé <saghul@gmail.com> (https://github.com/saghul)"],main:"lib/JsSIP.js",keywords:["sip","websocket","webrtc","node","browser","library"],license:"MIT",repository:{type:"git",url:"https://github.com/versatica/JsSIP.git"},bugs:{url:"https://github.com/versatica/JsSIP/issues"},dependencies:{debug:"^2.2.0",rtcninja:"git+ssh://git@git.isaco.de:ext/rtcninja#isaco-enhancements-2016","sdp-transform":"^1.6.2"},devDependencies:{browserify:"^13.1.0",gulp:"git+https://github.com/gulpjs/gulp.git#4.0","gulp-expect-file":"0.0.7","gulp-header":"1.8.8","gulp-jshint":"^2.0.1","gulp-nodeunit-runner":"^0.2.2","gulp-rename":"^1.2.2","gulp-uglify":"^2.0.0","gulp-util":"^3.0.7",jshint:"^2.9.3","jshint-stylish":"^2.2.1",pegjs:"0.7.0","vinyl-buffer":"^1.0.0","vinyl-source-stream":"^1.1.0"},scripts:{test:"gulp test",dist:"node node_modules/gulp/bin/gulp.js dist",package:"node node_modules/gulp/bin/gulp.js browserify uglify"}}},{}]},{},[7])(7)});